C
C Model grid point resolution parameters.
C
      integer
     $     plnlv,    ! Length of multilevel field slice
     $     plndlv,   ! Length of multilevel 3-d field slice
     $     pbflnb,   ! Length of buffer 1
     $     pbflna,   ! Length of buffer 2
     $     pflenb,   ! Length of buffer 1, padded for unblocked I/O
     $     pflena,   ! Length of buffer 2, padded for unblocked I/O
     $     ptifld,   ! Number of fields on time-invariant boundary dataset
     $     ptvsfld,  ! Number of fields on time-variant boundary dataset
     $     ptvofld,  ! Number of fields on ozone dataset
     $     plenhi,   ! Length of integer header record
     $     plenhc,   ! Length of character header record
     $     plenhr,   ! Length of real header record
     $     ptapes,   ! Maximum number of history tapes allowed
     $     pflds     ! Number of fields in master field list
      integer
     $     ptileni,  ! Length of time-invariant integer header
     $     ptilenc,  ! Length of time-invariant character header
     $     ptvoleni, ! Length of ozone integer header
     $     ptvolenc, ! Length of ozone character header
     $     ptvsleni, ! Length of time-variant integer header
     $     ptvslenc  ! Length of time-variant character header
      integer
     $     plenhis,  ! Length of integer header scalars
     $     plenhcs,  ! Length of character header scalars
     $     ptilenis, ! Length of time-invariant integer scalars
     $     ptilencs, ! Length of time-invariant character scalars
     $     ptolenis, ! Length of ozone integer header scalars
     $     ptolencs, ! Length of ozone character header scalars
     $     ptslenis, ! Length of time-variant integer header scalars
     $     ptslencs  ! Length of time-variant character header scalars
      integer pmulti,psingl,phtbf
C
      parameter(plnlv=plon*plev,plndlv=plond*plev)
C
C In pbflnb, 9 multi-level fields include the plev levels of plol and
C plos. 2 multi-level fields are pcnst-dependent.
C There are plevmx sub-surface temmperature fields. (See User-s Guide 
C for complete buffer description)
C
      parameter(pbflnb=(9 + 2*pcnst)*plndlv + (13+plevmx+pcnst)*plond,
C
C In pbflna, there are 6 multi-level and 4 single-level fields.
C
     $          pbflna = (4 + 6*plev)*plond,
     $          pflenb = ((pbflnb + pbflna)/512 + 1)*512,
     $          pflena = (pbflna/512 + 1)*512,
     $          ptapes = 6,
C
C 8 fields in master list are pcnst-dependent 2 fields occur only
C if pcnst > 1
C
     $          pflds=90+8*pcnst+2*(pcnst-1)+plevmx)
      parameter(ptifld = 11, ptvsfld = 1, ptvofld = 2)
C
C There are 37 scalar words in the integer header and 89 scalar words
C in the character header
C
      parameter(plenhis=37,plenhcs=89,
     $          plenhi=plenhis+3*pflds,plenhc=plenhcs+2*pflds,
#ifdef PP_PCCM
     $          plenhr=3*(2*plev + 1) + 2*p_glat,
#else
     $          plenhr=3*(2*plev + 1) + 2*plat,
#endif
     $          ptilenis=plenhis, ptilencs=plenhcs,
     $          ptileni=ptilenis+3*ptifld, ptilenc=ptilencs+2*ptifld,
     $          ptolenis=plenhis, ptolencs=plenhcs,
     $          ptvoleni=ptolenis+3*ptvofld,ptvolenc=ptolencs+2*ptvofld,
     $          ptslenis=plenhis, ptslencs=plenhcs,
     $          ptvsleni=ptslenis+3*ptvsfld,ptvslenc=ptslencs+2*ptvsfld)
C
C  Length of the history tape buffer for fldsin (INIDAT) and
C  hbuf2 (WRTHARR)
C
      parameter(pmulti = 19 + pcnst*4,psingl=46 + plevmx,
     $          phtbf = (pmulti*plev + psingl)*plon )






