#ifdef CCPCOMMENT

The cpp constants below are left over from FOAM development.  Change
at your own risk.

#endif

#define THIRTY_DAY_MONTH
#define NTOCOUP 13
#define NFROMCOUP 18
#define TSPDAY 48
#define OCNTSPDAY 4
#define ICE_MODEL
#define ACTICE
#define RIVER


#define Nrows OCEAN_LAT_PROCS
#define Ncols OCEAN_LON_PROCS
#define PP_NPROC_LT ATMOS_LAT_PROCS
#define PP_NPROC_LN ATMOS_LON_PROCS
#define UNIX

#ifdef THIRTY_DAY_MONTH
#  define YEAR_LENGTH 360
#else
#  define YEAR_LENGTH 365
#endif

#ifndef PARAMS_SET
# undef PARAMS_SET

#ifdef CPPCOMMENT
  The next set of lines checks to see whether an architecture has been
  already defined on the compiler command line, and if it has not, a
  default is set.
#endif

# if ( ! defined CRAY ) && ( ! defined RS6000 ) && ( ! defined SUN ) && ( ! defined INTEL) && ( ! defined T3D) && ( ! defined T3E) && ( ! defined LINUX) && ( ! defined SPP) && ( ! defined SGI)
#  define LINUX
#  undef RS6000
#  undef CRAY
#  undef SUN
#  undef INTEL
#  undef T3D
#  undef T3E
#  undef SGI
#  undef SPP
# endif

#ifdef CPPCOMMENT
  The setting is checked again to make sure that something has set
  one of the architectures.  If not, generate a syntax error.
#endif

# if ( ! defined CRAY ) && ( ! defined RS6000 ) && ( ! defined SUN ) && ( ! defined INTEL) && ( ! defined T3D)  && ( ! defined T3E)  && ( ! defined LINUX) && ( ! defined SPP) && ( ! defined SGI)
You must define one of CRAY, RS6000, SUN, INTEL, T3D, T3E, LINUX, SPP, SGI here or in makefile.
# endif

# define PP_PCCM

#ifdef PP_PCCM
# define PP_FFTX
# define BLOCK_FFT
# define PP_RADLB
# define INCORE_HBUF
# undef PP_ERROR
# undef NOOUT 
# undef PP_NORESTART 
# undef USE_DATA_GAUAW
# undef READ_ALP_FROM_FILE
# undef PP_INTEL_PFS
# undef INTERVAL_TIMER
# ifndef PP_TRIANG_TRUNC
#  ifndef PP_RHOMB_TRUNC
#   define PP_TRING_TRUNC 42
#  endif
# endif

# ifdef PP_RHOMB_TRUNC
#   if ( PP_RHOMB_TRUNC == 15)
#       define PP_GLAT 40
#       define PP_GLON 48
#       define PP_PLEV 18
#   endif
# endif

# ifdef PP_TRIANG_TRUNC
#   if ( PP_TRIANG_TRUNC == 21)
#       define PP_GLAT 32
#       define PP_GLON 64
#       define PP_PLEV 18
#   elif ( PP_TRIANG_TRUNC == 42 )
#       define PP_GLAT 64
#       define PP_GLON 128
#       define PP_PLEV 18
#       define LPT 2796
#       define KPT 6009
#   elif ( PP_TRIANG_TRUNC == 63 )
#       define PP_GLAT 96
#       define PP_GLON 192
#       define PP_PLEV 18
#   elif ( PP_TRIANG_TRUNC == 85 )
#       define PP_GLAT 128
#       define PP_GLON 256
#       define PP_PLEV 18
#   elif ( PP_TRIANG_TRUNC == 170 )
#       define PP_GLAT 256
#       define PP_GLON 512
#       define PP_PLEV 18
#   elif ( PP_TRIANG_TRUNC == 213 )
#       define PP_GLAT 320
#       define PP_GLON 640
#       define PP_PLEV 18
#   endif
# endif
# ifndef PP_NPROC_LT
#   define PP_NPROC_LT 1
# endif
# ifndef PP_NPROC_LN
#   define PP_NPROC_LN 1
# endif
# ifndef PP_NPROC
#   define PP_NPROC (PP_NPROC_LT*PP_NPROC_LN)
# endif
# ifndef PP_PLEV
#   define PP_PLEV 18
# endif
# ifndef PP_GLAT
#   define PP_GLAT 64
# endif
# ifndef PP_GLON
#   define PP_GLON 128
# endif
# define PLEVR 18
# ifndef WORD4
#    define real Real*8
#    define REAL Real*8
#    define COMPLEX Complex*16
#    define complex Complex*16
#    define alog log
#    define alog10 log10
#    define amax1 dmax1
#    define AMAX1 dmax1
#    define amin1 dmin1
#    define amod mod
#    define ifix idint
#    define float dfloat
#    define cabs abs
#    define AIMAG Dimag
#    define aimag Dimag
#    define csqrt sqrt
#    define CMPLX DCmplx
#    define AREAL DReal
# else
#     define AREAL Real
# endif
# ifdef INTEL
#  define NX_FORCETYPE 
#  ifdef WORD4
#    define I_SIZE 4 
#    define R_SIZE 4 
#    define D_SIZE 8
#  else
#    define I_SIZE 4 
#    define R_SIZE 8 
#    define D_SIZE 8 
#  endif
#  define PP_SUMOPT   21
#  define PP_SUMBUFS   1
#  define PP_SUMPROT   6
#  define PP_EXCHSZ    1
#  define PP_TFFTOPT  11
#  define PP_TFFTBUFS  2
#  define PP_TFFTPROT  6
#  define PP_DFFTOPT   1
#  define PP_DFFTPROT  6
#  define PP_SLTSWOPT  1
#  define PP_SLTSWPROT 6
#  define PP_SLTSROPT  1
#  define PP_SLTSRPROT 6
#  define PP_LBALOPT   1
#  define PP_LBALPROT  6
# endif
# ifdef LINUX
#  ifdef WORD4
#    define I_SIZE 4 
#    define R_SIZE 4 
#    define D_SIZE 8
#  else
#    define I_SIZE 4 
#    define R_SIZE 8 
#    define D_SIZE 8 
#  endif
#  define PP_SUMOPT   21
#  define PP_SUMBUFS   1
#  define PP_SUMPROT   6
#  define PP_EXCHSZ    1
#  define PP_TFFTOPT  11
#  define PP_TFFTBUFS  2
#  define PP_TFFTPROT  6
#  define PP_DFFTOPT   1
#  define PP_DFFTPROT  6
#  define PP_SLTSWOPT  1
#  define PP_SLTSWPROT 6
#  define PP_SLTSROPT  1
#  define PP_SLTSRPROT 6
#  define PP_LBALOPT   1
#  define PP_LBALPROT  6
# endif
# ifdef RS6000
#  ifdef WORD4
#    define I_SIZE 4 
#    define R_SIZE 4 
#    define D_SIZE 8
#  else
#    define I_SIZE 4 
#    define R_SIZE 8 
#    define D_SIZE 8 
#  endif
#  define PP_SUMOPT   21
#  define PP_SUMBUFS   1
#  define PP_SUMPROT   6
#  define PP_EXCHSZ    1
#  define PP_TFFTOPT  11
#  define PP_TFFTBUFS  2
#  define PP_TFFTPROT  6
#  define PP_DFFTOPT   1
#  define PP_DFFTPROT  6
#  define PP_SLTSWOPT  1
#  define PP_SLTSWPROT 6
#  define PP_SLTSROPT  1
#  define PP_SLTSRPROT 6
#  define PP_LBALOPT   1
#  define PP_LBALPROT  6
# endif
# ifdef T3D
#  ifdef WORD4
#    define I_SIZE 8
#    define R_SIZE 4 
#    define D_SIZE 8
#  else
#    define I_SIZE 8 
#    define R_SIZE 8 
#    define D_SIZE 8 
#  endif
#  define PP_SUMOPT   21
#  define PP_SUMBUFS   1
#  define PP_SUMPROT   6
#  define PP_EXCHSZ    1
#  define PP_TFFTOPT  11
#  define PP_TFFTBUFS  2
#  define PP_TFFTPROT  6
#  define PP_DFFTOPT   1
#  define PP_DFFTPROT  6
#  define PP_SLTSWOPT  1
#  define PP_SLTSWPROT 6
#  define PP_SLTSROPT  1
#  define PP_SLTSRPROT 6
#  define PP_LBALOPT   1
#  define PP_LBALPROT  6
# endif
# ifdef SUN
#  ifdef WORD4
#    define I_SIZE 4 
#    define R_SIZE 4 
#    define D_SIZE 8
#  else
#    define I_SIZE 4 
#    define R_SIZE 8 
#    define D_SIZE 8
#  endif
#  define PP_SUMOPT   21
#  define PP_SUMBUFS   1
#  define PP_SUMPROT   6
#  define PP_EXCHSZ    1
#  define PP_TFFTOPT  11
#  define PP_TFFTBUFS  2
#  define PP_TFFTPROT  6
#  define PP_DFFTOPT   1
#  define PP_DFFTPROT  6
#  define PP_SLTSWOPT  1
#  define PP_SLTSWPROT 6
#  define PP_SLTSROPT  1
#  define PP_SLTSRPROT 6
#  define PP_LBALOPT   1
#  define PP_LBALPROT  6
# endif
# ifdef T3E
#  undef CRAY
#  ifdef WORD4
#    define I_SIZE 8
#    define R_SIZE 4 
#    define D_SIZE 8
#  else
#    define I_SIZE 8 
#    define R_SIZE 8 
#    define D_SIZE 8 
#  endif
#  define PP_SUMOPT   21
#  define PP_SUMBUFS   1
#  define PP_SUMPROT   6
#  define PP_EXCHSZ    1
#  define PP_TFFTOPT  11
#  define PP_TFFTBUFS  2
#  define PP_TFFTPROT  6
#  define PP_DFFTOPT   1
#  define PP_DFFTPROT  6
#  define PP_SLTSWOPT  1
#  define PP_SLTSWPROT 6
#  define PP_SLTSROPT  1
#  define PP_SLTSRPROT 6
#  define PP_LBALOPT   1
#  define PP_LBALPROT  6
# endif
# ifdef SPP
#  ifdef WORD4
#    define I_SIZE 4 
#    define R_SIZE 4 
#    define D_SIZE 8
#  else
#    define I_SIZE 4 
#    define R_SIZE 8 
#    define D_SIZE 8
#  endif
#  define PP_SUMOPT   21
#  define PP_SUMBUFS   1
#  define PP_SUMPROT   6
#  define PP_EXCHSZ    1
#  define PP_TFFTOPT  11
#  define PP_TFFTBUFS  2
#  define PP_TFFTPROT  6
#  define PP_DFFTOPT   1
#  define PP_DFFTPROT  6
#  define PP_SLTSWOPT  1
#  define PP_SLTSWPROT 6
#  define PP_SLTSROPT  1
#  define PP_SLTSRPROT 6
#  define PP_LBALOPT   1
#  define PP_LBALPROT  6
# endif
# ifdef SGI
#  ifdef WORD4
#    define I_SIZE 4 
#    define R_SIZE 4 
#    define D_SIZE 8
#  else
#    define I_SIZE 4 
#    define R_SIZE 8 
#    define D_SIZE 8
#  endif
#  define PP_SUMOPT   21
#  define PP_SUMBUFS   1
#  define PP_SUMPROT   6
#  define PP_EXCHSZ    1
#  define PP_TFFTOPT  11
#  define PP_TFFTBUFS  2
#  define PP_TFFTPROT  6
#  define PP_DFFTOPT   1
#  define PP_DFFTPROT  6
#  define PP_SLTSWOPT  1
#  define PP_SLTSWPROT 6
#  define PP_SLTSROPT  1
#  define PP_SLTSRPROT 6
#  define PP_LBALOPT   1
#  define PP_LBALPROT  6
# endif
# ifdef CRAY
#    define I_SIZE 8 
#    define R_SIZE 8 
#    define D_SIZE 16
# endif
# if defined(PP_MPI) || defined(PP_MPL)
#    define SYSBUF 100000
# else
#    define SYSBUF 1
# endif

#else
# define HRES T42
# define PCNST 1
# define PLON 128
# define PLAT 64
# define PLEV 18
# define PLEVR 18
# define PTRM 42
# define PTRN 42
# define PTRK 42
#endif

#endif
