c
c
c surface boundary data
c
c vegtyp is used to specify the thermal properites of the surface,
c as well as determine the location of permanent land ice points;
c it is the dominant surface type within the model grid box based
c on a high resolution vegetation type dataset;
c it encoded in the following manner:
c
c   1        ocean
c   2        sea ice
c   3        permanent land ice
c   4        tropical evergreen forest
c   5        deciduous forest
c   6        grassland/tundra
c   7        desert
c
c rghnss is the aerodynamic roughness length for the grid box, computed
c by linear averaging of the values ascribed to high resolution 
c vegetation dataset values; ocean and land values are averaged together
c at coastlines.
c
      integer ovegtyp  ! surface thermal type, based on veg type
      real    orghnss  ! aerodynamic roughness length
c
      common /ocrdsrf/ovegtyp(uwlon,uwlat),orghnss(uwlon,uwlat)

