/**********************************************************************
$Id: UTP.h,v 1.1.1.1 2002/03/20 22:18:46 jacob Exp $

$Source: /homes/jacob/foam-cvs/om3coupled/UTP.h,v $

$Log: UTP.h,v $
Revision 1.1.1.1  2002/03/20 22:18:46  jacob
FOAM 1.5 reorg

Revision 1.1.1.1  2002/03/20 01:29:50  dvorak
Imported sources

Revision 1.1.1.1  2002/03/19 15:47:05  dvorak
Imported sources.

Revision 1.1.1.1  2002/03/12 20:22:14  dvorak
Imported sources.

Revision 1.1.1.1  2002/03/05 18:01:44  dvorak
Imported sources from FOAM 1.5

Revision 1.1.1.1  1999/10/28 22:20:43  rob
FOAM sources imported from portFOAM.tar

 * Revision 1.1  1995/10/05  20:52:59  schafer
 * Initial revision
 *
Revision 1.2  1994/10/07  03:54:26  kohr
Added UTP_reset_timer() and UTP_get_accum_time().

Revision 1.1  1994/09/14  06:03:12  kohr
Initial revision


Public declarations for the Unnamed Timing Package (UTP).
**********************************************************************/

#ifndef _UTP_h_
#define _UTP_h_

/**********************************************************************
Publicly-accessible functions.
**********************************************************************/

extern void UTP_init(unsigned numTimers);

extern void UTP_set_filename(const char *outFilename);

extern void UTP_start_timer(unsigned timerNumber);

extern void UTP_stop_timer(unsigned timerNumber);

extern void UTP_reset_timer(unsigned timerNumber);

extern void UTP_get_accum_time(unsigned timerNumber, double *time,
			       int *precision);

extern void UTP_shutdown(void);


/**********************************************************************
Publicly-accessible definitions.
**********************************************************************/

#define UTP_DEFAULT_OUT_FILE_NAME "utp_dump.txt"


#endif /* #ifndef _UTP_h_ */

