C
C Hybrid level definitions: p = a*p0 + b*ps
C        interfaces   p(k) = hyai(k)*ps0 + hybi(k)*ps
C        midpoints    p(k) = hyam(k)*ps0 + hybm(k)*ps
C
      common /comhyb/
     $     hyai(plevp) ,hyam(plev) ,hybi(plevp) ,hybm(plev) ,hybd(plev),
     $     hypi(plevp) ,hypm(plev) ,hypd(plev)  ,ps0        ,psr       ,
     $     prsfac      ,nprlev
C
      real hyai,       ! ps0 component of hybrid coordinate - interfaces
     $     hyam,       ! ps0 component of hybrid coordinate - midpoints
     $     hybi,       ! ps component of hybrid coordinate - interfaces
     $     hybm,       ! ps component of hybrid coordinate - midpoints
     $     hybd,       ! difference  in b (hybi) across layers
     $     hypi,       ! reference pressures at interfaces
     $     hypm,       ! reference pressures at midpoints
     $     hypd,       ! reference pressure layer thickness
     $     ps0,        ! base state sfc pressure for level definitions
     $     psr,        ! reference surface pressure for linearization
     $     prsfac      ! log pressure extrapolation factor
C                      !     (time, space independent)
      integer nprlev   ! number of pure pressure levels at top
C
