c
c     !   Parallel algorithm and protocol parameters
c
c parameters used in defining parallel global vector sum algorithm
      integer p_sumopt, p_sumbufs, p_sumprot, p_exchsz
      parameter (p_sumopt=PP_SUMOPT,   ! parallel algorithm variant
     $           p_sumbufs=PP_SUMBUFS, ! size of work buffer (in multiples
     $                                 !  of data buffer)
     $           p_sumprot=PP_SUMPROT, ! message passing protocol
     $           p_exchsz=PP_EXCHSZ )  ! vector length for switching in
     $                                 !  hybrid algorithms
c parameters used in allocating work space for parallel global vector
c sum algorithms
      integer lgprocsx, nprocsx
      parameter (lgprocsx=20,             
     $           nprocsx=PP_NPROC_LT*PP_NPROC_LN)
c parameters used in defining tranpose-based parallel FFT algorithm
      integer p_tfftopt, p_tfftbufs, p_tfftprot
      parameter (p_tfftopt=PP_TFFTOPT,   ! parallel algorithm variant
     $           p_tfftbufs=PP_TFFTBUFS, ! size of work buffer (in multiples
     $                                   !  of data buffer)
     $           p_tfftprot=PP_TFFTPROT) ! message passing protocol
c parameters used in defining distributed parallel FFT algorithm
      integer p_dfftopt, p_dfftprot
      parameter (p_dfftopt=PP_DFFTOPT,   ! communication ordering
     $           p_dfftprot=PP_DFFTPROT) ! message passing protocol
c parameters used in defining parallel SLT algorithm
      integer p_sltswopt, p_sltswprot,p_sltsropt, p_sltsrprot
      parameter (p_sltswopt=PP_SLTSWOPT,  ! communication ordering
     $                                    !  for pole swaps
     $           p_sltswprot=PP_SLTSWPROT,! message passing protocol
     $                                    !  for pole swaps
     $           p_sltsropt=PP_SLTSROPT,  ! communication ordering
     $                                    !  for overlap sendrecv
     $           p_sltsrprot=PP_SLTSRPROT) ! message passing protocol
c                                         !  for overlap sendrecv
c parameters used in load balancing
      integer p_lbalopt, p_lbalprot
      parameter (p_lbalopt=PP_LBALOPT,   ! communication ordering for
     $                                   !  local balancing swaps
     $           p_lbalprot=PP_LBALPROT) ! message passing protocol for
c                                        !  local balancing swaps
      INTEGER IBYTES, RBYTES, DBYTES, CBYTES, PICLREAL
#if (R_SIZE-4)
      PARAMETER (RBYTES=8,
     &           CBYTES=16,
     &           PICLREAL=5)
#else
      PARAMETER (RBYTES=4,
     &           CBYTES=8,
     &           PICLREAL=4)
#endif
#if (D_SIZE-8)
      PARAMETER (DBYTES=16)
#else
      PARAMETER (DBYTES=8)
#endif
#if (I_SIZE-4)
      PARAMETER (IBYTES=8)
#else
      PARAMETER (IBYTES=4)
#endif
C*                                                                     *
C***********************************************************************
C* The parameter value ALIGN specifies the alignment (in number of     *
C* REALs values) to use in defining arrays and communication buffers.  *
C* For example, ALIGN=2 means that all arrays and buffers will begin   *
C* on double REAL boundaries. Specifying alignment > 1 can be necessary*
C* for correct and/or efficient execution on some machines.            *
C* NOTE: ALIGN MUST BE .EQ. 1 OR A MULTIPLE OF 2 !!                    *
C***********************************************************************
      INTEGER ALIGN
#if defined(ALIGNMENT)
      PARAMETER (ALIGN = ALIGNMENT)
#else
      PARAMETER (ALIGN = 2)
#endif







