#include "params.h"
      subroutine cainti(cappax  ,cpairx  ,epsilox ,gravitx ,latvapx ,
     $                  rhoh2ox ,wssatx  ,rairx   ,clrh2ox ,tmeltx  )
C-----------------------------------------------------------------------
C
C Initialize convective adjustment common block /comadj/
C Note that the variable nlvdry in comadj is set to its default value in
C preset.for, and updated from namelist input (if necessary) in 
C subroutine DATA
C
C----------------------------Code History-------------------------------
C
C Original version:  J. Hack
C Standardized:      J. Rosinski, June 1992
C Reviewed:          J. Hack, G. Taylor, August 1992
C
C-----------------------------------------------------------------------
      implicit none
#if ( defined RS6000 )
c      implicit automatic (a-z)
#endif
C-----------------------------------------------------------------------
#include "pmgrid.com"
C-----------------------------------------------------------------------
#include "comadj.com"
C------------------------------Arguments--------------------------------
C
C Input arguments
C
      real cappax,           ! R/cp
     $     cpairx,           ! Specific heat of dry air
     $     epsilox,          ! Ratio of h2o to dry air molecular weights 
     $     gravitx,          ! Acceleration due to gravity
     $     latvapx,          ! Latent heat of vaporization
     $     rhoh2ox,          ! Density of liquid water
     $     wssatx,           ! Soil moisture capacity 
     $     rairx,            ! Gas constant for dry air 
     $     clrh2ox,          ! Ratio of latvap to water vapor gas constant
     $     tmeltx            ! Freezing point of water
C
C-----------------------------------------------------------------------
C
      cappa  = cappax
      cpair  = cpairx
      epsilo = epsilox
      gravit = gravitx
      latvap = latvapx
      rhoh2o = rhoh2ox
      wssat  = wssatx
      tmelt  = tmeltx
      clrh2o = clrh2ox
      rair   = rairx
C
      cldcp  = latvap/cpair
C
      return
      end
