#include "params.h"
      subroutine inital
C-----------------------------------------------------------------------
C
C Define initial conditions for first run of case
C
C-----------------------------parameters--------------------------------
c inserted by implnone
      implicit none
#include "pmgrid.com"
#include "pagrid.com"
#include "pspect.com"
#include "abemub.com"
C------------------------------commons----------------------------------
#include "comctl.com"
C-----------------------------------------------------------------------
#include "comhed.com"
C---------------------------------------------------------------------
#include "comhst.com"
C--------------------------------------------------------------------
#include "comloc.com"
C-----------------------------------------------------------------------
#include "comlun.com"
C---------------------------------------------------------------------
#include "commss.com"
C---------------------------------------------------------------------
#include "comqfl.com"
C----------------------------------------------------------------------
#include "comtim.com"
C----------------------------------------------------------------------
#include "com3d.com"
C---------------------------local workspace----------------------------
      character iuch*2             ! unit number (coded)
      character itmp*2             ! temporary for unit number
      character text*130           ! string sent to assign
      integer iftyp
      integer 
     $     ltszrg,              ! size of latitude slice on regen file
     $     nbtpwd,              ! number of bytes per word (8 for cray)
     $     nltrg,               ! number of latitudes per regen file
     $     nf                   ! file number
C----------------------------externals---------------------------------
      external fldlst,
     $         rdhdr,
     $         rgnfls,
     $         assign
C----------------------------------------------------------------------
C
c declarations inserted by implnone
      integer ierr,k,lenchr
      nbtpwd = 8
C
      do 10 k=1,plev
         tqf(k) = 1.
         dqf(k) = 0.
   10 continue

#ifdef PP_ERROR
      write(0,*) ' inital called '
#endif
#ifndef PP_PCCM
C
C Alias restart and regeneration files only if they will be written.
C Preallocate space on disk for all but nsds (restart file)
C
      if (nsvsn.ne.'        ') then
         write(itmp,'(i2)') nsds
         call ljust(itmp,iuch)
         text = 'assign -a '//nsvsn(1:lenchr(nsvsn))//
     $          ' -b 8 fort.'//iuch
         write(6,800) text
         call assign(text)
C
C Determine the number of latitudes per primary regeneration file and the
C number of files.
C The size computation ignores the extra 4*pcnst (if doslt=t) words which 
C are written to the last file . 
C
c         print *,'mxszrg ', mxszrg
         ltszrg = (((pbflnb+pbflna)/512+1)*512 + pflena +
     $        2*((3+pcnst)*plndlv) + 2*plond)
         if (doslt) ltszrg = ltszrg + (3*plnlv + 2*pcnst*plndlv)
         nltrg = mxszrg / (ltszrg * nbtpwd)
         if (nltrg .lt. 1) then
            write (6,*) 
            write (6,*)
     $        'INITAL:the regeneration file size is too small:'
            write (6,*) 'Maximum file size (mxszrg): ', mxszrg
            write (6,*) 'Size of a latitude record:  ', ltszrg*nbtpwd
            call endrun
         end if         
         nnrg1 = plat / nltrg
         if (mod(plat,nltrg) .ne. 0) nnrg1 = nnrg1 + 1
c         print *,'ltszrg, nltrg, nnrg1 ', ltszrg, nltrg, nnrg1
         if (nnrg1 .gt. pnrg1) then
            write (6,*) 
            write (6,*)
     $           'INITAL:too many primary regeneration files required:'
            write (6,*) 'Maximum number of files (pnrg1) = ', pnrg1
            write (6,*) 'Maximum size of files (mxszrg)  = ', mxszrg
            write (6,*) 'Actual number of files required = ', nnrg1
            write (6,*) 'Actual size of latitude record  = ', ltszrg
            write (6,*) 'Number of latitudes per file    = ', nltrg
            call endrun
         end if
C
C Set the sizes of the primary regeneration files and the index of the
C first latitude in each file.
C
         rg1buf = ltszrg/512 + 1
         rg1lat(1) = 1
c         print *, 'rg1buf, rg1lat(1) ', rg1buf, rg1lat(1)
         do nf = 1, nnrg1
            rg1lat(nf+1) = min0(rg1lat(nf)+nltrg, plat+1)
            rg1siz(nf) = ltszrg * (rg1lat(nf+1) - rg1lat(nf))
            if ((nf .eq. nnrg1) .and. doslt)
     $           rg1siz(nf) = rg1siz(nf) + 4*pcnst
            rg1siz(nf) = rg1siz(nf)/512 + 1
c            print *, 'nf, rg1lat(nf+1), rg1siz(nf) ',
c     $           nf, rg1lat(nf+1), rg1siz(nf)
         end do
C
C Skip secondary regeneration files unless they are required.
C
         if (aeres) then
C
C Determine the number of latitudes per secondary regeneration file and the
C number of files.
C
            ltszrg = plond*plevp*plevp + plond*plev*4 + plond*plevp
            nltrg = mxszrg / (ltszrg * nbtpwd)
            nnrg2 = plat / nltrg
            if (mod(plat,nltrg) .ne. 0) nnrg2 = nnrg2 + 1
c            print *,' ltszrg, nltrg, nnrg2 ', ltszrg, nltrg, nnrg2
            if (nnrg2 .gt. pnrg2) then
               write (6,*) 
               write (6,*)
     $         'INITAL:too many secondary regeneration files required:'
               write (6,*) 'Maximum number of files (pnrg2) = ', pnrg2
               write (6,*) 'Maximum size of files (mxszrg)  = ', mxszrg
               write (6,*) 'Actual number of files required = ', nnrg2
               write (6,*) 'Actual size of latitude record  = ', ltszrg
               write (6,*) 'Number of latitudes per file    = ', nltrg
               call endrun
            endif
C
C Set the sizes of the secondary regeneration files and the index of the
C first latitude in each file.
C
            rg2buf = nabebf
            rg2lat(1) = 1
c            print *, 'rg2buf, rg2lat(1) ', rg2buf, rg2lat(1)
            do nf = 1, nnrg2
               rg2lat(nf+1) = min0(rg2lat(nf)+nltrg, plat+1)
               rg2siz(nf) = ltszrg * (rg2lat(nf+1) - rg2lat(nf))
               rg2siz(nf) = rg2siz(nf)/512 + 1
c               print *, 'nf, rg2lat(nf+1), rg2siz(nf) ',
c     $                  nf, rg2lat(nf+1), rg2siz(nf)
            end do
         endif
C
C Assign and preallocate the regeneration files
C
         call rgnfls
      endif
  800 format(' from inital sending the following to assign:',a130)
C
C ATTACH INITIAL DATASET
C
#endif
      call atchbnd(ninit   ,ncdata  ,8       ,'U')
C
C Read initial data
C
#ifdef PP_ERROR
            write(0,*)'inital: ',ninit,ncdata
#endif
      call rdhdr(ninit   ,plenhi   ,plenhis ,plenhc  ,plenhcs ,
     $           plenhr  ,lenhdi(1),mcase   ,sigapb  ,mflds   ,
     $           mcflds  ,ierr)
      if (ierr.ne.0) then
#ifdef PP_ERROR
         write(0,*)'INITAL:Error returned from RDHDR for record ',ierr
#endif
         call endrun
      endif
      call prnthd(ninit    ,plenhi  ,plenhc  ,plenhr  ,
     $           lenhdi(1),mcase   ,sigapb  ,
     $           mflds    ,mcflds  ,.true.)
C
C Check model variables against initial data tape values
C
      if(mlon.ne.plon .or. morec.ne.plat .or. mlev.ne.plev .or.
     $   mtrk.ne.ptrk .or. mtrm.ne.ptrm  .or. mtrn.ne.ptrn) then
C
C Initial data set does not match parameters
C end the run
C
         write(6,8999) mlon,plon,morec,plat,mlev,plev,
     $        mtrm,ptrm,mtrn,ptrn,mtrk,ptrk
 8999 format(/'INITAL:MISMATCH BETWEEN INITIAL DATASET ',
     $'HEADER AND PARAMETERS'/5x,'MLON:',i10,'   PLON:',i10/
     $     4x,'MOREC:',i10,'  PLAT:',i10/5x,'MLEV:',i10,'   PLEV:',i10/
     $     5x,'MTRM:',i10,'   PTRM:',i10/5x,'MTRN:',i10,'   PTRN:',i10/
     $     5x,'MTRK:',i10,'   PTRK:',i10//)
#ifndef BOGUS
         call endrun
#else
          write(6,*)'Ensure that you are you using a bogus dataset'
          write(6,*)'the execution continues'
          write(0,*)'Ensure that you are you using a bogus dataset'
          write(0,*)'the execution continues'
#endif
      else
         write(6,9000)
 9000    format('INITAL:HEADER READ AND CHECKED CORRECTLY')
      endif
C
C Set comtim variables from header or from input parameter values
C if specified
C
      if (nndbas.ne.-9999) then
         mdbase = nndbas
         if (nnsbas.ne.-9999) then
            msbase = nnsbas
         else
            msbase = 0
         endif
      else
         mdbase = ndcur
         msbase = nscur
      endif
      if (nnbdat.ne.-9999) then
         mbdate = nnbdat
         if (nnbsec.ne.-9999) then
            mbsec = nnbsec
         else
            mbsec = 0
         endif
      else
         mbdate = ncdate
         mbsec = ncsec
      endif
      mdcur = mdbase
      mscur = msbase
      mcdate = mbdate
      mcsec = mbsec
C
C Initialize commap
C
#ifdef PP_ERROR
      write(0,*) 'inital: before call to initcom'
#endif
      call initcom
C
C Initialize model buffer and /threed/
C
      iftyp = mftyp - (mftyp/100)*100
      if (iftyp.eq.43) then
#ifdef PP_ERROR
      write(0,*) 'inital: before call to inidat'
#endif
#ifdef PP_PCCM
         call inidat(doslt,ps(1,1,1),u3(i1,1,1,1,1),v3(i1,1,1,1,1),
     $            t3(i1,1,1,1,1),q3(i1,1,1,1,1,1))
#else
         call inidat(doslt,ps(1,1,1),u3(i1,1,j1,1),v3(i1,1,j1,1),
     $            t3(i1,1,j1,1),q3(i1,1,1,j1,1))
#endif
      else
         write(6,*)'INITAL:Illegal format type on initial dataset.'
         write(6,*)'mftyp = ',mftyp
         call endrun
      endif
C
C Compute current calendar day
C
#ifdef PP_ERROR
      write(0,*) 'inital: before call to caldyi'
#endif
      if(anncyc) then
         call caldyi(nstep   ,dtime   ,mdbase  ,msbase  ,mbdate  ,
     $               mbsec   ,mdcur   ,mscur   ,mcdate  ,mcsec   ,
     $               calday)
      else
C
C perpetual: Current date,day = base date,day
C
         call caldyi(0       ,dtime   ,mdbase  ,msbase  ,mbdate  ,
     $               mbsec   ,mdcur   ,mscur   ,mcdate  ,mcsec   ,
     $               calday)
      end if
c
      return
      end
