#include "params.h"
	subroutine rdbcst(cnmlst, auxfp,nrevsnp)
      	implicit none
	character*(*) cnmlst
        character*72 nrevsnp
        character*8 auxfp(*)
c-----------------------------------------------------------------------
c
c  Read the namelist on node zero and broadcast the values
c  to all nodes.
c
#include "pmgrid.com"
#include "pagrid.com"
#include "pspect.com"
C ----------------------------------------------------------------------
#include "comadj.com"
C ----------------------------------------------------------------------
#include "comctl.com"
C-----------------------------------------------------------------------
#include "comhd.com"
C ----------------------------------------------------------------------
#include "comhst.com"
C ----------------------------------------------------------------------
#include "comloc.com"
C-----------------------------------------------------------------------
#include "comlun.com"
C ----------------------------------------------------------------------
#include "commss.com"
C-----------------------------------------------------------------------
#include "comtfc.com"
C ----------------------------------------------------------------------
#include "comtim.com"
C ----------------------------------------------------------------------
#include "comvmr.com"
C ----------------------------------------------------------------------
#include "comsol.com"
C--------------------------- Local workspace----------------------------
      character nrevsn*72   !  dataset to regenerate from
      character*8 auxf(pflds*(ptapes-1)) ! Input auxiliary tapes specs

      namelist /ccmexp/ ctitle  ,ncdata  ,bndti   ,bndtvs  ,bndtvo  ,
     $     nsvsn   ,nswrps  ,nsrest  ,irt     ,nsmvn   ,
     $     nrmvn   ,nrevsn ,ndens   ,nhtfrq  ,nrefrq  ,
     $     mfilt   ,ninavg  ,nlfilt  ,stfnum  ,rirt    ,
     $     exclude ,primary ,auxf   ,nndbas  ,nnsbas  ,
     $     nnbdat  ,nnbsec  ,dtime   ,nelapse ,nestep  ,
     $     eps     ,dif2    ,dif4    ,kmxhdc  ,iradsw  ,
     $     iradlw  ,iradae  ,itsst   ,nlvdry  ,sstcyc  ,
     $     ozncyc  ,async   ,mxszrg  ,ldebug  ,dodiavg ,
     $     cpuchek ,mresfq,
     $     accrst  ,parhist , rpath, hpath,      ! additions for PCCM
     $     co2vmr  ,n2ovmr  ,ch4vmr  ,f11vmr  ,f12vmr  ,
     $     scon    ,tauvis
C
C----------------------------Local variables--------------------------------
C
      character  chtem*80,   ! temporary for manipulating pathnames
     $           tempc*16,   ! temporary character variable
     $           itemp*3,    ! temporary for restart flag
     $           chcase*16   ! Temporary character string for case variable
      integer    kclen,      ! Length of case identifier
     $           istat,      ! status return from system routines
     $           mcstem(3),  ! Array to capture case environ. variable
     $           logname(2)  ! Array to capture logname environ. variable
      integer    rbufsize
      parameter (rbufsize=11)

C
#include "comparll.com"
      integer info, lenmsg, ii
      integer ibuf(20 + 3*ptapes)
      integer lbuf(8)
      real rbuf(rbufsize)
      character*80 cbuf(12+ptapes)
      character*4 savetype
      integer i

c
c Save current data type
c
      call getdataf(savetype)
c
      if(cnmlst.eq."ccmexp") then
       if(m_pin.eq.mapmesh(0,0)) then
C
C Preset local variables
C
      do i=1,pflds * (ptapes-1)
         auxf(i) = auxfp(i)
      end do
        nrevsn = nrevsnp
C
#ifdef PP_ERROR
        write(0,*)' 0 reading namelist'
#endif
        open(50,file='atmos_params')
        read (50,ccmexp)
c          ctitle  ,ncdata  ,bndti   ,bndtvs  ,bndtvo  ,
c	   nsvsn   ,nswrps  ,nsrest  ,irt     ,nsmvn   ,
c	   nrmvn   ,nrevsn  ,ndens   ,nhtfrq  ,nrefrq  ,
c	   mfilt   ,ninavg  ,nlfilt  ,stfnum  ,rirt    ,
c	   exclude ,primary ,auxf   ,nndbas  ,nnsbas  ,
c	   nnbdat  ,nnbsec  ,dtime   ,nelapse ,nestep  ,
c	   eps     ,dif2    ,dif4    ,kmxhdc  ,iradsw  ,
c	   iradlw  ,iradae  ,itsst   ,nlvdry  ,sstcyc  ,
c	   ozncyc  ,async   ,mxszrg  ,ldebug  ,dodiavg ,
c	   cpuchek ,mresfq

c
c
c Integers
c
#ifdef PP_ERROR
         write(0,*)' 0 has read namelist'
#endif
         ibuf(1) = nsrest
         ibuf(2) = irt
         ibuf(3) = nrefrq
         ibuf(4) = stfnum
         ibuf(5) = nndbas
         ibuf(6) = nnsbas
         ibuf(7) = nnbdat
         ibuf(8) = nnbsec
         ibuf(9) = nelapse
         ibuf(10) = nestep
         ibuf(11) = kmxhdc
         ibuf(12)= iradsw
         ibuf(13)= iradlw
         ibuf(14)= iradae
         ibuf(15)= itsst
         ibuf(16)= nlvdry
         ibuf(17)= mxszrg
         ibuf(18)= mresfq
         if ( accrst ) then
           ibuf(19)= 1
         else
           ibuf(19)= 0
         endif
         if ( parhist ) then
           ibuf(20)= 1
         else
           ibuf(20)= 0
         endif
c
c arrays
c
         ii = 21
         do i = 1,ptapes
	   ibuf(ii) = ndens(i)
	   ibuf(ii+1) = nhtfrq(i)
	   ibuf(ii+2) = mfilt(i)
           ii = ii + 3
           enddo
c
         lenmsg = 20 + 3*ptapes 
#ifdef PP_ERROR
         write(0,*) m_type,lenmsg
#endif
         call setdataf('integer')
	 call bcast0f(ibuf,lenmsg*I_SIZE,m_type,
     &               mapmesh(0,0))
         m_type = m_type + 1
c
c  Floats
c
	 rbuf(1) = dtime
	 rbuf(2) = eps
	 rbuf(3) = dif2
	 rbuf(4) = dif4
	 rbuf(5) = co2vmr
	 rbuf(6) = n2ovmr
	 rbuf(7) = ch4vmr
	 rbuf(8) = f11vmr
	 rbuf(9) = f12vmr
	 rbuf(10) = scon
	 rbuf(11) = tauvis
c
         lenmsg = rbufsize
#ifdef PP_ERROR
         write(0,*) m_type,lenmsg
#endif
#if defined(WORD4)
         call setdataf('real')
#else
         call setdataf('double')
#endif
	 call bcast0f(rbuf,lenmsg*R_SIZE,m_type,
     &               mapmesh(0,0))
         m_type = m_type + 1
c
c Characters
c
         cbuf(1) = ctitle
         cbuf(2) = ncdata
         cbuf(3) = bndti
         cbuf(4) = bndtvs
         cbuf(5) = bndtvo
         cbuf(6) = nsvsn
         cbuf(7) = nswrps
         cbuf(8) = nsmvn
         cbuf(9) = nrmvn
         cbuf(10) = nrevsn
         cbuf(11) = rpath
         cbuf(12) = hpath
c
         ii = 13
         do i = 1,ptapes
	   cbuf(ii) = ninavg(i)
           ii = ii + 1
           enddo
c
         lenmsg = 80*(12 + ptapes)
#ifdef PP_ERROR
         write(0,*) m_type,lenmsg
#endif
	 call bcastcf(cbuf,lenmsg,m_type,
     &               mapmesh(0,0))
         m_type = m_type + 1
c
c  Auxf fields
c
         lenmsg = 8*pflds*(ptapes-1)
#ifdef PP_ERROR
         write(0,*) m_type,lenmsg
#endif
	 call bcastcf(auxf,lenmsg,m_type,mapmesh(0,0))
         m_type = m_type + 1
c
c  Logicals
c
         lbuf(1) = 0
         lbuf(2) = 0
         lbuf(3) = 0
         lbuf(4) = 0
         lbuf(5) = 0
         lbuf(6) = 0
         lbuf(7) = 0
         lbuf(8) = 0
         if(nlfilt)  lbuf(1) = 1
         if(sstcyc)  lbuf(2) = 1
         if(ozncyc)  lbuf(3) = 1
         if(async)   lbuf(4) = 1
         if(anncyc)  lbuf(5) = 1
         if(ldebug)  lbuf(6) = 1
         if(dodiavg) lbuf(7) = 1
         if(cpuchek) lbuf(8) = 1
c
         lenmsg = 8
#ifdef PP_ERROR
         write(0,*) m_type,lenmsg
#endif
         call setdataf('integer')
	 call bcast0f(lbuf,lenmsg*I_SIZE,m_type,
     &               mapmesh(0,0))
         m_type = m_type + p_nproc
      else
c
c   Unpack the namelist on other than node zero.
c
c
c  Integers
c
         lenmsg = 20 + 3*ptapes
         call setdataf('integer')
	 call bcast0f(ibuf,lenmsg*I_SIZE,m_type,
     &               mapmesh(0,0))
#ifdef PP_ERROR
         write(0,*) m_type,lenmsg
#endif
         m_type = m_type + 1
c
         nsrest = ibuf(1)
         irt    = ibuf(2) 
         nrefrq = ibuf(3)
         stfnum = ibuf(4) 
         nndbas = ibuf(5) 
         nnsbas = ibuf(6) 
         nnbdat = ibuf(7) 
         nnbsec = ibuf(8) 
         nelapse= ibuf(9) 
         nestep = ibuf(10) 
         kmxhdc = ibuf(11) 
         iradsw = ibuf(12)
         iradlw = ibuf(13)
         iradae = ibuf(14)
         itsst  = ibuf(15)
         nlvdry = ibuf(16)
         mxszrg = ibuf(17)
         mresfq = ibuf(18)
         accrst = ( ibuf(19) .eq. 1 )
         parhist = ( ibuf(20) .eq. 1 )
c
c arrays
c
         ii = 21
         do i = 1,ptapes
	   ndens(i)   = ibuf(ii)
	   nhtfrq(i)  = ibuf(ii+1)
	   mfilt(i)   = ibuf(ii+2)
           ii = ii + 3
           enddo
c
c  Floats
c
         lenmsg = rbufsize
#if defined(WORD4)
         call setdataf('real')
#else
         call setdataf('double')
#endif
	 call bcast0f(rbuf,lenmsg*R_SIZE,m_type,
     &               mapmesh(0,0))
#ifdef PP_ERROR
         write(0,*) m_type,lenmsg
#endif
         m_type = m_type + 1
c
	 dtime  = rbuf(1)
	 eps    = rbuf(2)
	 dif2   = rbuf(3)
	 dif4   = rbuf(4)
	 co2vmr = rbuf(5)
	 n2ovmr = rbuf(6)
	 ch4vmr = rbuf(7)
	 f11vmr = rbuf(8)
	 f12vmr = rbuf(9)
	 scon   = rbuf(10)
	 tauvis = rbuf(11)
c
c Characters
c
         lenmsg = 80*(12+ptapes)
	 call bcastcf(cbuf,lenmsg,m_type,mapmesh(0,0))
#ifdef PP_ERROR
         write(0,*) m_type,lenmsg
#endif
         m_type = m_type + 1
c
         ctitle   = cbuf(1)
         ncdata   = cbuf(2)
         bndti    = cbuf(3)
         bndtvs   = cbuf(4)
         bndtvo   = cbuf(5)
         nsvsn    = cbuf(6)
         nswrps   = cbuf(7)
         nsmvn    = cbuf(8)
         nrmvn    = cbuf(9)
         nrevsn   = cbuf(10)
         rpath    = cbuf(11)
         hpath    = cbuf(12)
c
         ii = 13
         do i = 1,ptapes
	   ninavg(i) = cbuf(ii)
           ii = ii + 1
           enddo
c
c  Auxf fields
c
         lenmsg = 8*pflds*(ptapes-1)
#ifdef PP_ERROR
         write(0,*) m_type,lenmsg
#endif
	 call bcastcf(auxf,lenmsg,m_type,mapmesh(0,0))
         m_type = m_type + 1
c
c  Logicals
c
         lenmsg = 8
         call setdataf('integer')
	 call bcast0f(lbuf,lenmsg*I_SIZE,m_type,
     &               mapmesh(0,0))
#ifdef PP_ERROR
         write(0,*) m_type,lenmsg
#endif
         m_type = m_type + p_nproc
c
         nlfilt   = .FALSE.
         sstcyc   = .FALSE.
         ozncyc   = .FALSE.
         async    = .FALSE.
         anncyc   = .FALSE.
         ldebug   = .FALSE.
         dodiavg  = .FALSE.
         cpuchek   = .FALSE.
         nlfilt = (lbuf(1).eq.1) 
         sstcyc = (lbuf(2).eq.1)
         ozncyc = (lbuf(3).eq.1)
         async = (lbuf(4).eq.1)
         anncyc = (lbuf(5).eq.1)
         ldebug = (lbuf(6).eq.1)
         dodiavg = (lbuf(7).eq.1)
         cpuchek = (lbuf(8).eq.1) 
c
       endif
c
      endif
c
         do i = 1, pflds*(ptapes-1)
           auxfp(i) = auxf(i)
         enddo
         nrevsnp = nrevsn
c
c Restore default data type
c
      call setdataf(savetype)
c
      return
      end


