#include "params.h"
      subroutine resume(lhbuf)
C-----------------------------------------------------------------------
C
C Initialize for continuation run
C
C---------------------------Code history--------------------------------
C
C Original version:  CCM1
C Standardized:      L. Bath, June 1992
C
C-----------------------------------------------------------------------
      implicit none
C------------------------------Parameters-------------------------------
#include "pmgrid.com"
#include "pagrid.com"
#include "pspect.com"
C------------------------------Commons----------------------------------
#include "comctl.com"
C-----------------------------------------------------------------------
#include "comhed.com"
C-----------------------------------------------------------------------
#include "comhst.com"
C ----------------------------------------------------------------------
#include "comtim.com"
C------------------------------Argument---------------------------------
C
C Output
C
      integer lhbuf        ! Length of history tape buffer
C
C------------------------------Externals--------------------------------
C
      external restrt,     ! Do restart processing
     $         caldyi,     ! Calendar day calculation
     $         initcom     ! Initialize commons
C
C-----------------------------------------------------------------------

C
C Read restart data.  Acquire and position datasets
C
      call restrt(lhbuf)
C
C Set commons
C
      call initcom
C
C Save starting time step of restart run in nrstrt, used throughout
C model to test for beginning of run
C
      nrstrt = nstepr
      nstep  = nstepr
C
C If Model time request was made as an elapsed time, now can calculate
C nestep.
C
      if (nelapse.ne.0) then
          nestep = nstep + nelapse - 1
          nstop = nestep + 1
      end if
C
C Stop if final time step is less than current step
C
      if (nstep.ge.nstop) then
         write(6,*)'RESUME: nstep(starting time step).ge.nstop.  ',
     $                     'nstep = ',nstep,', nstop = ',nstop
         call endrun
      end if
C
C Set comtim variables
C
      mdbase = ndbase
      msbase = nsbase
      mbdate = nbdate
      mbsec  = nbsec
C
      if(anncyc) then
         call caldyi(nstepr-1,dtime  ,mdbase  ,msbase  ,mbdate  ,
     $               mbsec   ,mdcur  ,mscur   ,mcdate  ,mcsec   ,
     $               calday)
      else
C
C Perpetual: Current date,day = base date,day
C
         call caldyi(0       ,dtime  ,mdbase  ,msbase  ,mbdate  ,
     $               mbsec   ,mdcur  ,mscur   ,mcdate  ,mcsec   ,
     $               calday)
      end if
C
      write(6,*) 'Current calday is ',calday
      return
      end
