#include "params.h"
#define DEBUG_DBL_DIAGS
      subroutine scan1(wfld    ,psslt   ,etamid  ,detam   ,
     $                 gr1lps  ,gr1t    ,
     $                 gr1q    ,gr1z    ,gr1d    ,gr1fu   ,gr1fv   ,
     $                 gr1vt   ,gr1vq   ,gr1rh   ,gr2lps  ,gr2t    ,
     $                 gr2q    ,gr2z    ,gr2d    ,gr2fu   ,gr2fv   ,
     $                 gr2vt   ,gr2vq   ,gr2rh   ,hbuf    ,lhbuf)
C-----------------------------------------------------------------------
C
C First gaussian latitude scan (by latitude pairs) for which the physics
C and nonlinear dynamics calculations are completed.  The main loop over
C latitude pairs in this routine is multitasked.
C
C physics split for coupling by C. Schafer, R. Jacob, April 1995
C
C
C-----------------------------------------------------------------------
      implicit none
#include "pmgrid.com"
C---------------------------------------------------------------------
#include "pagrid.com"
C---------------------------------------------------------------------
#include "pspect.com"
C---------------------------------------------------------------------
#include "comcon.com"
C-----------------------------------------------------------------------
#include "comhd.com"
C-----------------------------------------------------------------------
#include "comhed.com"
C-----------------------------------------------------------------------
#include "comhst.com"
C-----------------------------------------------------------------------
#include "comloc.com"
C---------------------------------------------------------------------
#include "comqfl.com"
C---------------------------------------------------------------------
#include "comsta.com"
C---------------------------------------------------------------------
#include "comtim.com"
C---------------------------------------------------------------------
#ifdef PP_PCCM
#include "comspe.com"
C---------------------------------------------------------------------
#include "comparll.com"
C---------------------------------------------------------------------
#include "commap.com"
      real wgt
#endif
C---------------------------------------------------------------------
      logical whenwr
      external whenwr
C----------------------------Input arguments--------------------------
      real wfld(plon,plevp,plat),   ! Vertical motion (slt)
     $     psslt(plond,plat)
      real etamid(plev),
     $     detam(plev)            ! intervals between vert.levels
      integer lhbuf
      real hbuf(lhbuf)
C
C----------------------------Local workspace--------------------------
C
      real vmax1d(plev),               ! max. wind at each level
     $     vmax2d(plev,plat),          ! max. wind at each level, latitude
     $     vmax1dt(plev),              ! max. truncated wind at each level
     $     vmax2dt(plev,plat)          ! max. truncated wind at each lvl,lat
#if (defined(PP_PCCM))
      real  vmax1dtmp(plev)            ! temporary buffer for calculating
                                       ! max. wind at each level
#endif
      real vcour(plev,plat)            ! maximum Courant number in slice
      real tdt                      ! two delta t unless nstep <2
#ifdef BLOCK_FFT
#include "block_fft.com"
       real fft_buffer( plond, max_vects_fwd )
       integer ip, nvect, isign
# ifdef CRAY
      real work1((plon+1)*pcray)  ! Workspace for fft (Cray)
      real work2(1)
# else
#  if (defined(PP_PCCM))
#   if (defined(PP_FFTX))
c     transpose parallel fft work space
      real work1(plond,max_vects_fwd)
      real work2(p_glon+2,((max_vects_fwd)/p_nproc_ln + 1)*2) 
#   else
c     distributed parallel fft work space
      real work1(plond,(max_vects_fwd))
      real work2(1)
#   endif
#  else
      real work1((plon+1)*max_vects_fwd)   ! sequential definition
      real work2(1)
#  endif
# endif
#endif
#ifdef PP_PCCM
      integer m_root, m_bytes
      integer plat5, repro_size
      parameter ( plat5 = 5*plat )
      parameter ( repro_size = max(plat5,10))
      real repro_tmp( repro_size ), repro2_tmp(repro_size)
      real f_locsum
      integer kk,iter
#endif
#ifdef WORD4
      real*8 rmsz_d, rmsd_d, rmst_d, stps_d, stq_d
#else
      real   rmsz_d, rmsd_d, rmst_d, stps_d, stq_d
#endif
C
C Spectral coefficient arrays which will have a latitude index
C put on them for multitasking
C
#ifdef PP_PCCM
c with parallel fft, these have to be full width
      real gr1lps(plon,plat/2),gr2lps(plon,plat/2),
     $     gr1t(plon,plev,plat/2),gr2t(plon,plev,plat/2),
     $     gr1q(plon,plev,plat/2),gr2q(plon,plev,plat/2),
     $     gr1z(plon,plev,plat/2),gr2z(plon,plev,plat/2),
     $     gr1d(plon,plev,plat/2),gr2d(plon,plev,plat/2),
     $     gr1fu(plon,plev,plat/2),gr2fu(plon,plev,plat/2),
     $     gr1fv(plon,plev,plat/2),gr2fv(plon,plev,plat/2),
     $     gr1vt(plon,plev,plat/2),gr2vt(plon,plev,plat/2),
     $     gr1vq(plon,plev,plat/2),gr2vq(plon,plev,plat/2),
     $     gr1rh(plon,plev,plat/2),gr2rh(plon,plev,plat/2)
#else
      real gr1lps(2*pmmax,plat/2),gr2lps(2*pmmax,plat/2),
     $     gr1t(2*pmmax,plev,plat/2),gr2t(2*pmmax,plev,plat/2),
     $     gr1q(2*pmmax,plev,plat/2),gr2q(2*pmmax,plev,plat/2),
     $     gr1z(2*pmmax,plev,plat/2),gr2z(2*pmmax,plev,plat/2),
     $     gr1d(2*pmmax,plev,plat/2),gr2d(2*pmmax,plev,plat/2),
     $     gr1fu(2*pmmax,plev,plat/2),gr2fu(2*pmmax,plev,plat/2),
     $     gr1fv(2*pmmax,plev,plat/2),gr2fv(2*pmmax,plev,plat/2),
     $     gr1vt(2*pmmax,plev,plat/2),gr2vt(2*pmmax,plev,plat/2),
     $     gr1vq(2*pmmax,plev,plat/2),gr2vq(2*pmmax,plev,plat/2),
     $     gr1rh(2*pmmax,plev,plat/2),gr2rh(2*pmmax,plev,plat/2)
#endif
      real cn,cnmax,r2plon,rmsdf,rmstf,rmszf,ssum,stps,stqf,vmax,ztodt
      integer irow,ismax,j,k,kfld,ktape,lat,llhbuf,hbuf_offset

#ifdef INTERVAL_TIMER
#include "timers.com"
#endif

C
C Set time increment.
C
      ztodt = twodt
      if (nstep.eq.0) ztodt = .5*twodt
C
C INITIALIZE STATISTICS AT BEGINNING OF TIMESTEP
C
      do 5 k=1,plev
         qflrat(k) = 1. - dqf(k)/(tqf(k)+dqf(k))
    5 continue
      do 10 j=1,plat
         rmsz(j) = 0.
         rmsd(j) = 0.
         rmst(j) = 0.
         stq(j) = 0.
         psurf(j) = 0.
   10 continue
C
C Write history tape header to separate unit for multitasking
C purposes.  Print later in writup.
C

#ifdef INTERVAL_TIMER
      call interval_timer( 1, TIMER_History_out, 0 )
#endif

#ifdef PROFILE
      call mark_event(6,1)
#endif

      kfld = 1
      do 15 ktape=1,ptapes
         if (whenwr(nstep, ktape)) then
             call wrthdr(ktape,         nstep,
     $                   mflds(1,kfld), mcflds(1,kfld))
         endif
         kfld = kfld + nflds(ktape)
   15 continue

#ifdef PROFILE
      call mark_event(6,0)
#endif

#ifdef INTERVAL_TIMER
      call interval_timer( 0, TIMER_History_out, 0 )
#endif

C
C Write slt data to restart file at appropriate times
C

#ifdef INTERVAL_TIMER
      call interval_timer( 1, TIMER_Restart_out, 0 )
#endif
#ifdef PROFILE
      call mark_event(7,1)
#endif
C
C Write restart file
C
      call wrtrs1

#ifdef PROFILE
      call mark_event(7,0)
#endif
#ifdef INTERVAL_TIMER
      call interval_timer( 0, TIMER_Restart_out, 0 )
#endif

C
C Advance time information
C
      call advnce(tdt)

CMIC$ DO ALL SHARED(TDT, ZTODT, WFLD, PSSLT, ETAMID, GR1LPS,
CMIC$1   GR1T, GR1Q, GR1Z,GR1D, GR1FU, GR1FV, GR1VT, GR1VQ, GR1RH,
CMIC$2   GR2LPS, GR2T, GR2Q,GR2Z, GR2D, GR2FU, GR2FV, GR2VT, GR2VQ,
CMIC$3   GR2RH)
CMIC$3   PRIVATE(IROW)
c
c The physics loop is split from the
c forward spectral transform code.
c
#ifdef BLOCK_FFT
      ip = 1
#endif

c This is the beginning of the split of physics-CMS

#ifdef PROFILE
      call mark_event(12,1)
#endif
      do 154 irow=1,plat/2
         call physdrv1(irow,tdt,ztodt,wfld,psslt,etamid,vcour,detam,
     $               gr1lps(1,irow),gr1t(1,1,irow),gr1q(1,1,irow),
     $               gr1z(1,1,irow),gr1d(1,1,irow),gr1fu(1,1,irow),
     $               gr1fv(1,1,irow),gr1vt(1,1,irow),gr1vq(1,1,irow),
     $               gr1rh(1,1,irow),
     $               gr2lps(1,irow),gr2t(1,1,irow),gr2q(1,1,irow),
     $               gr2z(1,1,irow),gr2d(1,1,irow),gr2fu(1,1,irow),
     $               gr2fv(1,1,irow),gr2vt(1,1,irow),gr2vq(1,1,irow),
     $               gr2rh(1,1,irow), hbuf, lhbuf,
#ifndef BLOCK_FFT
     $               vmax2d,vmax2dt)
#else
     $               vmax2d,vmax2dt,fft_buffer, ip )
#endif
  154 continue

#ifdef COUPLED
c Call to the coupler-CMS
# ifdef PROFILE
      call mark_event(12,0)
      call mark_event(4,1)
# endif

# ifdef UPSHOT
      call log_event(2,m_pin,'EndAtm',7)
      call log_event(3,m_pin,'StrtCoupl',9)
# endif

      call pcoupler()

# ifdef PROFILE
      call mark_event(4,0)
      call mark_event(12,1)
# endif

# ifdef UPSHOT
      call log_event(4,m_pin,'EndCoupl',8)
      call log_event(1,m_pin,'StrtAtm',8)
# endif
#endif

#ifdef BLOCK_FFT
      ip = 1
#endif

      do 152 irow=1,plat/2
         call physdrv2(irow,tdt,ztodt,wfld,psslt,etamid,vcour,detam,
     $               gr1lps(1,irow),gr1t(1,1,irow),gr1q(1,1,irow),
     $               gr1z(1,1,irow),gr1d(1,1,irow),gr1fu(1,1,irow),
     $               gr1fv(1,1,irow),gr1vt(1,1,irow),gr1vq(1,1,irow),
     $               gr1rh(1,1,irow),
     $               gr2lps(1,irow),gr2t(1,1,irow),gr2q(1,1,irow),
     $               gr2z(1,1,irow),gr2d(1,1,irow),gr2fu(1,1,irow),
     $               gr2fv(1,1,irow),gr2vt(1,1,irow),gr2vq(1,1,irow),
     $               gr2rh(1,1,irow), hbuf, lhbuf,
#ifndef BLOCK_FFT
     $               vmax2d,vmax2dt)
#else
     $               vmax2d,vmax2dt,fft_buffer, ip )
#endif
  152 continue
#ifdef PROFILE
      call mark_event(12,0)
#endif
c End of split of physics-CMS


#ifdef BLOCK_FFT
      nvect = ip - 1
      isign = -1
      if (nvect .gt. max_vects_fwd) then
#    ifdef PP_ERROR
	write(0,*) ' scan1 block_fft: too many vectors: ',nvect,' > ',
     &             max_vects_fwd
#    endif
	call abortf('scan1')
      endif
      call rftlon(fft_buffer, work1, work2, plond, plon, nvect, isign)
      ip = 1
#endif

#ifdef INTERVAL_TIMER
      call interval_timer( 1, TIMER_XFORMDRV, 0 )
#endif

#ifdef PROFILE
      call mark_event(13,1)
#endif
      do 151 irow=1,plat/2
         call xformdrv(irow,tdt,ztodt,wfld,psslt,etamid,vcour,detam,
     $               gr1lps(1,irow),gr1t(1,1,irow),gr1q(1,1,irow),
     $               gr1z(1,1,irow),gr1d(1,1,irow),gr1fu(1,1,irow),
     $               gr1fv(1,1,irow),gr1vt(1,1,irow),gr1vq(1,1,irow),
     $               gr1rh(1,1,irow),
     $               gr2lps(1,irow),gr2t(1,1,irow),gr2q(1,1,irow),
     $               gr2z(1,1,irow),gr2d(1,1,irow),gr2fu(1,1,irow),
     $               gr2fv(1,1,irow),gr2vt(1,1,irow),gr2vq(1,1,irow),
#ifndef BLOCK_FFT
     $               gr2rh(1,1,irow), vmax2d,vmax2dt)
#else
     $               gr2rh(1,1,irow), vmax2d,vmax2dt,
     $               fft_buffer, ip )
#endif
  151 continue

#ifdef PROFILE
      call mark_event(13,0)
#endif

#ifdef INTERVAL_TIMER
      call interval_timer( 0, TIMER_XFORMDRV, 0 )
#endif
C
C Compute maximum wind speed for each level
C
      do 160 k=1,plev
         vmax = 0.
         do 170 j=1,plat
            vmax = amax1(vmax,vmax2d(k,j))
  170    continue
         vmax1d(k) = sqrt(vmax)
#ifdef PP_PCCM
#ifdef LMAXWINDS
         write(0,*)'k=',k,' max wind speed=',vmax1d(k),' m/s'
#endif
#endif
  160 continue

#ifdef PP_PCCM
      if (p_nproc.gt.1) then
        call meshmax0(  vmax1d, vmax1dtmp, plev, m_type )
        m_type = m_type + 4*p_nproc
      endif
#endif
#ifdef MAXWINDS
      do k=1,plev
      write(6,*)'k=',k,' global max wind speed=',vmax1d(k),' m/s'
      enddo
#endif
C
C Compute maximum vertical Courant number (k is index to Model interfaces)
C (Note: vmax has not been computed globally for parallel code)
C
         vmax = 0.
         do lat=1,plat
            do k=2,plev
               vmax = amax1(vmax,vcour(k,lat))
            end do
         end do

C
C determine whether CFL limit has been exceeded at selected levels
C if so, fix it by setting up indicies for truncating spectrum
C in hordif (and grcalc to recover diffusion for diagnostics)
C JJH 1/91
C BAB: Change code to scan from bottom to top. Truncate all levels to th
C same wavenumber above where the courant limit is exceeded (unless more
C truncation is required). Therefore, the truncation wavenumber may decr
C but not increase with height. Never truncate bottom level.
C
C Determine whether the CFL limit has been exceeded for each level within
C the specified range (k<=kmxhdc). Set the truncation wave number so that
C the CFL limit will not be violated. Store the max courant number for
C printing on the stats line.
C
      cnmax = 0.
      do k=1,kmxhdc
         cn = vmax1d(k)*cnfac   ! estimate of Courant number
         cnmax = amax1(cnmax,cn)
         if (cn .gt. cnlim) then
            nindex(k) = int(nmaxhd*cnlim/cn + 1.)
            j = ismax(plat,vmax2d(k,1),plev)
            write(6,5050) k,j,cn,nindex(k)-1
         else
            nindex(k) = 2*nmaxhd
         endif
      end do
 5050 format(' *** Courant limit exceeded at k,j=',2i3,' (estimate = ',
     $       f6.3, '), solution has been truncated to wavenumber ',
     $       i3,' ***')

C
C WRITE OUT STATISITICS
C
#ifdef PP_PCCM

c at this point, stats has accumulated as much locally as it can
c in binary tree fashion.  Now, finish the longitudinal sums between
c processors and go on to do the latitudinal local and inerproc. sums.


c finish longitudinal sums
c pack
      k = 1
      do j = 1, plat
	    repro2_tmp(k  ) = psurf(j)
	    repro2_tmp(k+1) =   stq(j)
	    repro2_tmp(k+2) =  rmsz(j)
	    repro2_tmp(k+3) =  rmsd(j)
	    repro2_tmp(k+4) =  rmst(j)
	    k = k + 5
      enddo
c
      if (p_nproc_ln.gt.1) then
         call rowsum0( repro2_tmp, repro_tmp, 5*plat, m_type )
         m_type = m_type + 2*p_nproc
	 endif
c
      k = 1
      do j = 1, plat
	    if ( j .gt. plat/2 ) then
	        wgt = w(plat - j + 1)
	    else
	        wgt = w(j)
	    endif
	    psurf(j) = repro2_tmp(k  ) * wgt
	    stq(j)   = repro2_tmp(k+1) * wgt
	    rmsz(j)  = repro2_tmp(k+2) * wgt
	    rmsd(j)  = repro2_tmp(k+3) * wgt
	    rmst(j)  = repro2_tmp(k+4) * wgt
	    k = k + 5
      enddo

c do lat sums.
c 920921 -- note that the hemispheres must be summed separately
c and only added together at the top of the binary sum.  Otherwise
c the order of summation will differ with different numbers of
c processors in latitude because each processor has latitudes
c from each hemisphere
      r2plon = 1./(2.*p_glon)
      repro2_tmp(1)  = f_locsum( psurf(1), plat/2, repro_tmp )
      repro2_tmp(2)  = f_locsum(   stq(1), plat/2, repro_tmp )
      repro2_tmp(3)  = f_locsum(  rmsz(1), plat/2, repro_tmp )
      repro2_tmp(4)  = f_locsum(  rmsd(1), plat/2, repro_tmp )
      repro2_tmp(5)  = f_locsum(  rmst(1), plat/2, repro_tmp )
      repro2_tmp(6)  = f_locsum( psurf(plat/2+1), plat/2, repro_tmp )
      repro2_tmp(7)  = f_locsum(   stq(plat/2+1), plat/2, repro_tmp )
      repro2_tmp(8)  = f_locsum(  rmsz(plat/2+1), plat/2, repro_tmp )
      repro2_tmp(9)  = f_locsum(  rmsd(plat/2+1), plat/2, repro_tmp )
      repro2_tmp(10) = f_locsum(  rmst(plat/2+1), plat/2, repro_tmp )

      if (p_nproc_lt.gt.1) then
         call colsum0( repro2_tmp, repro_tmp, 10, m_type )
         m_type = m_type + 2*p_nproc
         endif

      stps  = (repro2_tmp(1) + repro2_tmp(6))       * r2plon
      stqf  = (repro2_tmp(2) + repro2_tmp(7)) * rga * r2plon
      rmszf = sqrt((repro2_tmp(3) + repro2_tmp(8))  * r2plon)
      rmsdf = sqrt((repro2_tmp(4) + repro2_tmp(9))  * r2plon)
      rmstf = sqrt((repro2_tmp(5) + repro2_tmp(10)) * r2plon)

      if ( m_pin .eq. mapmesh(0,0) ) then
#ifdef COUPLED
c	 write(0,*)'nstep =',nstep,calday
#endif
         if(mod(nstep,1).eq.0) then
            if (nstep.eq.0) write(6,900)
	 rmsz_d = rmszf
	 rmsd_d = rmsdf
	 rmst_d = rmstf
	 stps_d = stps
	 stq_d  = stqf
#   ifdef DEBUG_DBL_DIAGS
         write(6,901)nstep,rmsz_d,rmsd_d,rmst_d,stps_d,stq_d,cnmax
#ifdef PP_ERROR
         write(0,901)nstep,rmsz_d,rmsd_d,rmst_d,stps_d,stq_d,cnmax
#endif
#   else
         write(6,901)nstep,rmszf,rmsdf,rmstf,stps,stqf,cnmax
#ifdef PP_ERROR
         write(0,901)nstep,rmszf,rmsdf,rmstf,stps,stqf,cnmax
#endif
#   endif
         end if
      end if
#else
      r2plon = 1./(2.*plon)
      stps = r2plon*ssum(plat,psurf,1)
      stqf = r2plon*rga*ssum(plat,stq,1)
      rmszf = sqrt(r2plon*ssum(plat,rmsz,1))
      rmsdf = sqrt(r2plon*ssum(plat,rmsd,1))
      rmstf = sqrt(r2plon*ssum(plat,rmst,1))
      if(mod(nstep,1).eq.0) then
         if (nstep.eq.0) write(6,900)
	 rmsz_d = rmszf
	 rmsd_d = rmsdf
	 rmst_d = rmstf
	 stps_d = stps
	 stq_d  = stqf
#   ifdef DEBUG_DBL_DIAGS
         write(6,901)nstep,rmsz_d,rmsd_d,rmst_d,stps_d,stq_d,cnmax
#ifdef PP_ERROR
         write(0,901)nstep,rmsz_d,rmsd_d,rmst_d,stps_d,stq_d,cnmax
#endif
#   else
         write(6,901)nstep,rmszf,rmsdf,rmstf,stps,stqf,cnmax
#ifdef PP_ERROR
         write(0,901)nstep,rmszf,rmsdf,rmstf,stps,stqf,cnmax
#endif
#   endif
      end if
#endif
C
C Wrap up history tape. Any complete history tapes are written to the
C Mass Store and the regeneration files are also written if necessary.
C
      do ktape=1,mtapes
         if (whenwr(nstep, ktape)) then
            nfils(ktape) = nfils(ktape) + 1
         end if
      end do
      call wrapup(lhbuf)
C
      return
#ifdef DEBUG_DBL_DIAGS
  900 format(/8x,'NSTEP',4x,'RMSZ',19x,'RMSD',19x,'RMST',19x,'STPS',19x,
     $       'STQ',19x,'COURANT')
  901 format(' NSTEP =',i9,1x,1p6e23.15)
#else
  900 format(/8x,'NSTEP',4x,'RMSZ',19x,'RMSD',19x,'RMST',4x,'STPS',9x,
     $       'STQ',19x,'COURANT')
  901 format(' NSTEP =',i9,1x,1p2e23.15,0p1f8.3,1p1e13.5,e23.15,0p1f5.2)
#endif
      end
