#include "params.h"
      subroutine stepon(lhbuf, hbuf)
C-----------------------------------------------------------------------
C
C Loop over time, calling driving routines for physics, dynamics, transport
C
C-----------------------------------------------------------------------
      implicit none
      integer     lhbuf       ! Length of history tape buffer
      real        hbuf(lhbuf)     ! Pointer to history buffer
#include "pmgrid.com"
C-----------------------------------------------------------------------
#include "pagrid.com"
C-----------------------------------------------------------------------
#include "pspect.com"
C-----------------------------------------------------------------------
#include "comcon.com"
C-----------------------------------------------------------------------
#include "comctl.com"
C-----------------------------------------------------------------------
#include "comhyb.com"
C-----------------------------------------------------------------------
#include "commap.com"
C-----------------------------------------------------------------------
#include "comqfl.com"
C-----------------------------------------------------------------------
#include "comslt.com"
C-----------------------------------------------------------------------
#include "comspe.com"
C-----------------------------------------------------------------------
#include "comtim.com"
#ifdef PP_PCCM
C-----------------------------------------------------------------------
#include "comparll.com"
#endif
#ifdef INTERVAL_TIMER
#include "timers.com"
#endif
C-----------------------------------------------------------------------
C
C Local workspace: slt first
C
      integer pmap
      parameter ( pmap = 20000 )
      integer  kdpmpf(pmap),kdpmph(pmap)
      real etadot(plon,plevp,plat),   ! Vertical motion (slt)
     $     psslt(plond,plat),
     $     hyad (plev)              ! del (A)
#ifdef PP_PCCM
      real lam(plond),
     $     phi(platd,2),
     $     dphi(platd,2),
     $     gw(plat),
     $     sinlam(plon),
     $     coslam(plon),
     $     lbasdy(4,2,platd,2),
     $     lbasdz(4,2,plev),
     $     lbassd(4,2,plevp),
     $     lbasiy(4,2,platd,2),
     $     detam(plev),
     $     detai(plevp),
     $     dlam,
     $     cwava,
     $     etamid(plev),
     $     etaint(plevp)
#else
      real lam(plond),
     $     phi(platd),
     $     dphi(platd),
     $     gw(plat),
     $     sinlam(plon),
     $     coslam(plon),
     $     lbasdy(4,2,platd),
     $     lbasdz(4,2,plev),
     $     lbassd(4,2,plevp),
     $     lbasiy(4,2,platd),
     $     detam(plev),
     $     detai(plevp),
     $     dlam,
     $     cwava,
     $     etamid(plev),
     $     etaint(plevp)
#endif
C
C Spectral coefficient arrays which have a latitude index
C on them for multitasking
C
#ifdef PP_PCCM
c parallel fft needs full width
      real gr1lps(plon,plat/2),gr2lps(plon,plat/2),
     $     gr1t(plon,plev,plat/2),gr2t(plon,plev,plat/2),
     $     gr1q(plon,plev,plat/2),gr2q(plon,plev,plat/2),
     $     gr1z(plon,plev,plat/2),gr2z(plon,plev,plat/2),
     $     gr1d(plon,plev,plat/2),gr2d(plon,plev,plat/2),
     $     gr1fu(plon,plev,plat/2),gr2fu(plon,plev,plat/2),
     $     gr1fv(plon,plev,plat/2),gr2fv(plon,plev,plat/2),
     $     gr1vt(plon,plev,plat/2),gr2vt(plon,plev,plat/2),
     $     gr1vq(plon,plev,plat/2),gr2vq(plon,plev,plat/2),
     $     gr1rh(plon,plev,plat/2),gr2rh(plon,plev,plat/2)
#else
      real gr1lps(2*pmmax,plat/2),gr2lps(2*pmmax,plat/2),
     $     gr1t(2*pmmax,plev,plat/2),gr2t(2*pmmax,plev,plat/2),
     $     gr1q(2*pmmax,plev,plat/2),gr2q(2*pmmax,plev,plat/2),
     $     gr1z(2*pmmax,plev,plat/2),gr2z(2*pmmax,plev,plat/2),
     $     gr1d(2*pmmax,plev,plat/2),gr2d(2*pmmax,plev,plat/2),
     $     gr1fu(2*pmmax,plev,plat/2),gr2fu(2*pmmax,plev,plat/2),
     $     gr1fv(2*pmmax,plev,plat/2),gr2fv(2*pmmax,plev,plat/2),
     $     gr1vt(2*pmmax,plev,plat/2),gr2vt(2*pmmax,plev,plat/2),
     $     gr1vq(2*pmmax,plev,plat/2),gr2vq(2*pmmax,plev,plat/2),
     $     gr1rh(2*pmmax,plev,plat/2),gr2rh(2*pmmax,plev,plat/2)
#endif
      integer i,k,lat
C
C Define eta coordinates: Used as early as etadot called by linems
C
      do 10 k=1,plev
         etamid(k) = hyam(k) + hybm(k)
   10 continue
      do 20 k=1,plevp
         etaint(k) = hyai(k) + hybi(k)
   20 continue
c
C Set slt common block variables
c
      call grdini(pmap    ,etamid  ,etaint  ,gravit  ,dlam    ,
     $            lam     ,phi     ,dphi    ,gw      ,sinlam  ,
     $            coslam  ,lbasdy  ,lbasdz  ,lbassd  ,lbasiy  ,
     $            detam   ,detai   ,kdpmpf  ,kdpmph  ,cwava)
c
C Initial guess for trajectory midpoints in spherical coords.
C nstep = 0:  use arrival points as initial guess for trajectory midpoints.
C nstep > 0:  use calculated trajectory midpoints from previous time step as
C first guess.
C NOTE:  reduce number of iterations necessary for convergence after nstep = 1.
c
      if(nstep.eq.0) then
         do 175 lat=1,plat
            do 170 k=1,plev
               do 160 i=1,plon
#ifdef PP_PCCM
                  lammp(i,k,lat) = lam(i+i1-1)
#else
                  lammp(i,k,lat) = float(i-1)*dlam
#endif
                  phimp(i,k,lat) = clat(lat)
                  sigmp(i,k,lat) = etamid(k)
  160          continue
  170       continue
  175    continue
c
c Compute an initial mass fix factor
c
c         fixmas = (tmass0+qmass1)/(tmassf-qmass2)
         fixmas = (tmass0+qmass1+qmass2)/tmassf
      endif
c
c Compute pdel from "A" portion of hybrid vertical grid
c
      do 30 k=1,plev
         hyad(k) = hyai(k+1) - hyai(k)
   30 continue
      do 50 k=1,plev
         do 40 i=1,plon
            pdela(i,k) = hyad(k) * ps0
   40    continue
   50 continue
C
C Blank spectral fields before each gaussian scan
C
#ifdef INTERVAL_TIMER
      call reset_timer(1)
#endif
c
c  Top of timestep loop
c
  110 continue

#ifdef PROFILE
      call mark_event(2,1)
#endif

#ifdef PP_PCCM
      m_type = 5000		! reset at start of each new ts
#endif
#ifdef INTERVAL_TIMER
      call interval_timer( 1, TIMER_Main, 1 )
#endif

      call resetr(vz,pspl,0.)
      call resetr(d,pspl,0.)
      call resetr(t,pspl,0.)
      call resetr(q,pspl,0.)
      call resetr(alps,psp,0.)
C
C SCAN1: Driving routine for physics
C
#ifdef PROFILE
      call mark_event(14,1)
#endif
      call scan1(etadot    ,psslt   ,etamid  ,detam ,
     $           gr1lps  ,gr1t    ,
     $           gr1q    ,gr1z    ,gr1d    ,gr1fu   ,gr1fv   ,
     $           gr1vt   ,gr1vq   ,gr1rh   ,gr2lps  ,gr2t    ,
     $           gr2q    ,gr2z    ,gr2d    ,gr2fu   ,gr2fv   ,
     $           gr2vt   ,gr2vq   ,gr2rh   ,hbuf    ,lhbuf)
#ifdef PROFILE
      call mark_event(14,0)
#endif
c
c Quit after final scan1 call
c
#ifdef PROFILE
      if(nlend) then
        call mark_event(2,0)
        return
      endif
#else
      if(nlend) return
#endif

C
C SLT scan from south to north
C
      if(doslt) then
#ifdef INTERVAL_TIMER
	 call interval_timer( 1, TIMER_Scan1a, 1 )
#endif

#ifdef PROFILE
      call mark_event(15,1)
#endif

         call scan1a(pmap    ,etadot  ,psslt   ,kdpmpf  ,kdpmph  ,
     $               lam     ,phi     ,dphi    ,gw      ,sinlam  ,
     $               coslam  ,lbasdy  ,lbasdz  ,lbassd  ,lbasiy  ,
     $               detam   ,detai   ,dlam    ,cwava   ,etamid  ,
     $               etaint)

#ifdef PROFILE
      call mark_event(15,0)
#endif

#ifdef INTERVAL_TIMER
	 call interval_timer( 0, TIMER_Scan1a, 0 )
#endif
#ifdef PP_PCCM
         m_type = 10000		! scan1a has modified m_type ; reset
#endif
      end if
C
C Accumulate spectral coefficients in order
C
#ifdef INTERVAL_TIMER
      call interval_timer( 1, TIMER_DYNDRV, 1 )
#endif

#ifdef PROFILE
      call mark_event(5,1)
#endif

      call dyndrv(gr1lps  ,gr1t    ,gr1q    ,gr1z    ,gr1d    ,
     $            gr1fu   ,gr1fv   ,gr1vt   ,gr1vq   ,gr1rh   ,
     $            gr2lps  ,gr2t    ,gr2q    ,gr2z    ,gr2d    ,
     $            gr2fu   ,gr2fv   ,gr2vt   ,gr2vq   ,gr2rh)

#ifdef PROFILE
      call mark_event(5,0)
      call mark_event(16,1)
#endif

#ifdef INTERVAL_TIMER
      call interval_timer( 0, TIMER_DYNDRV, 0 )
#endif
C
C SECOND GAUSSIAN SCAN
C
#ifdef INTERVAL_TIMER
	 call interval_timer( 1, TIMER_SCAN2, 1 )
#endif
      call scan2(cwava)

#ifdef PROFILE
      call mark_event(16,0)
#endif

#ifdef INTERVAL_TIMER
	 call interval_timer( 0, TIMER_SCAN2, 0 )
#endif
      nstep = nstep + 1
C
C Test for and flag end of run for next time step
C
      if (nstep.eq.nstop) nlend = .true.
C
C Update restart time step
C
      nstepr = nstep
#ifdef INTERVAL_TIMER
      call interval_timer( 0, TIMER_Main, 1 )
C     if(m_pin.eq.mapmesh(0,0)) then 
        call dump_timer(nstep-1,1)
        call dump_timer(nstep-1,2)
        call dump_timer(nstep-1,3)
        call dump_timer(nstep-1,4)
        call dump_timer(nstep-1,5)
        call dump_timer(nstep-1,6)
        call dump_timer(nstep-1,7)
        call dump_timer(nstep-1,8)
        call dump_timer(nstep-1,9)
        call dump_timer(nstep-1,10)
        call dump_timer(nstep-1,11)
        call dump_timer(nstep-1,12)
        call dump_timer(nstep-1,13)
        call dump_timer(nstep-1,14)
        call dump_timer(nstep-1,15)
C     endif 
      call reset_timer(1)
      call reset_timer(2)
      call reset_timer(3)
      call reset_timer(4)
      call reset_timer(5)
      call reset_timer(6)
      call reset_timer(7)
      call reset_timer(8)
      call reset_timer(9)
      call reset_timer(10)
      call reset_timer(11)
      call reset_timer(12)
      call reset_timer(13)
      call reset_timer(14)
      call reset_timer(15)
#endif
c
#ifdef PROFILE
      call mark_event(2,0)
#endif
      go to 110
c
      end
