#include "params.h"
      subroutine tiread(iunit)
C-----------------------------------------------------------------------
C
C Read time-invariant boundary dataset (sdv and alb)
C
C---------------------------Code history--------------------------------
C
C Original version:  L. Bath
C Standardized:      L. Buja, June 1992
C
C-----------------------------------------------------------------------
      implicit none
#if ( defined RS6000 )
c      implicit automatic (a-z)
#endif
C------------------------------Arguments--------------------------------
C
C Input arguments
C
      integer iunit                     ! Logical unit number
C
C------------------------------Parameters-------------------------------
#include "pmgrid.com"
#include "pagrid.com"
C------------------------------Commons----------------------------------
#include "comhdt.com"
C-----------------------------------------------------------------------
#include "comsgh.com"
C-----------------------------------------------------------------------
#include "crdalb.com"
C---------------------------Local variables-----------------------------
C
      integer lat, ier,n, ii,           ! Indices
     $        hdi(ptilenis),            ! Integer header record scalars
     $        mtifl(3,ptifld),          ! Mflds array for header
     $        readl,                    ! Length of array read
     $        nlonwl,                   ! Local versions of header vars
     $        nfldhl,                   ! Number of fields on header
     $        flen                      ! Length of fldsin
      real fldsin(ptifld*plon),         ! Boundary data storage
     $     flat,                        ! Latitude  from dataset
     $     flon,                        ! Longitude from dataset
     $     hdr(plenhr)                  ! Real header record
      character*8 hdc(ptilencs),        ! Character header scalars
     $            mctifl(2,ptifld)      ! Mcflds array for header
C
C-----------------------------Externals---------------------------------
C
      external rdhdr, rdharr, mkslic, endrun
C
C-----------------------------------------------------------------------
C
C Read the history tape header
C
      call rdhdr(iunit   ,ptileni ,ptilenis,ptilenc ,ptilencs,
     $           plenhr  ,hdi     ,hdc     ,hdr     ,mtifl   ,
     $           mctifl  ,ier     )
      if (ier.ne.0) then
         write(6,*)'TIREAD: End-of-file reading header for ',
     $             'time-invariant dataset, record number ',ier
         call endrun
      end if
      readl = hdi(6) - 2
      nlonwl = hdi(10)
      nfldhl = hdi(16)
C
C Save dataset information for output header
C
      ldhstts = hdc(22)
      lthstts = hdc(23)
      lshstts = hdc(24)
C
      do 100 n=1,plat
C
C Read latitude record from boundary dataset
C
#ifdef PP_PCCM
         call rdharr(iunit,ptifld*plon,flat,flon,fldsin,n,plat)
#else
         call rdharr(iunit,readl,flat,flon,fldsin)
#endif
C
C Mkslic of albedo and surface fields now on initial dataset
C
         flen = ptifld*plon
         lat = nint(flat)
#ifdef PP_PCCM
         if ( lat .gt. p_glat/2 ) then  ! north
            lat = plat/2 + mod(lat-1,plat/2) + 1
         else                           ! south
            lat = mod(lat-1,plat/2) + 1
         endif
#endif
         call mkslic('ALBVSS',albvss(1,lat), 1 ,mtifl   ,mctifl  ,
     $                nfldhl ,fldsin  ,flen    ,plon    ,nlonwl  ,
     $                plond  ,plev    )
         call mkslic('ALBVSW',albvsw(1,lat), 1 ,mtifl   ,mctifl  ,
     $                nfldhl ,fldsin  ,flen    ,plon    ,nlonwl  ,
     $                plond  ,plev    )
         call mkslic('ALBNIS',albnis(1,lat), 1 ,mtifl   ,mctifl  ,
     $                nfldhl ,fldsin  ,flen    ,plon    ,nlonwl  ,
     $                plond  ,plev    )
         call mkslic('ALBNIW',albniw(1,lat), 1 ,mtifl   ,mctifl  ,
     $                nfldhl ,fldsin  ,flen    ,plon    ,nlonwl  ,
     $                plond  ,plev    )
         call mkslic('FRCTST',frctst(1,lat), 1 ,mtifl   ,mctifl  ,
     $                nfldhl ,fldsin  ,flen    ,plon    ,nlonwl  ,
     $                plond  ,plev    )
         call mkslic('RGHNSS',rghnss(1,lat), 1 ,mtifl   ,mctifl  ,
     $                nfldhl ,fldsin  ,flen    ,plon    ,nlonwl  ,
     $                plond  ,plev    )
         call mkslic('EVAPF' ,evapf(1,lat) , 1 ,mtifl   ,mctifl  ,
     $                nfldhl ,fldsin  ,flen    ,plon    ,nlonwl  ,
     $                plond  ,plev    )
         call mkslic('VEGTYP',vegtyp(1,lat), 1 ,mtifl   ,mctifl  ,
     $                nfldhl ,fldsin  ,flen    ,plon    ,nlonwl  ,
     $                plond  ,plev    )
         call mkslic('SNWJAN',snwjan(1,lat), 1 ,mtifl   ,mctifl  ,
     $                nfldhl ,fldsin  ,flen    ,plon    ,nlonwl  ,
     $                plond  ,plev    )
         call mkslic('SNWJLY',snwjly(1,lat), 1 ,mtifl   ,mctifl  ,
     $                nfldhl ,fldsin  ,flen    ,plon    ,nlonwl  ,
     $                plond  ,plev    )
C
C Mkslic of sgh formerly on standard deviation dataset
C
         call mkslic('SGH'   ,sgh(1,lat), 1    ,mtifl   ,mctifl  ,
     $                nfldhl ,fldsin  ,flen    ,plon    ,nlonwl  ,
     $                plond  ,plev    )
C
C Use twice the standard deviation in the Model
C
C  Don't double sgh here.  It is now doubled in mgwdrag.F
C  R. Jacob, Aug, 2001
C        do ii=1,plon
C           sgh(ii,lat) = 2.0*sgh(ii,lat)
C        end do
C
  100 continue
      close (iunit)
C  
      return
      end
