#include "params.h"
      subroutine tsinti(tmeltx  ,cpairx  ,epsilox ,gravitx ,latvapx ,
     $                  rairx   ,stebolx ,wssatx  ,clrh2ox ,dtimex  )
C-----------------------------------------------------------------------
C
C Initialize surface temperature calculation
C
C---------------------------Code history--------------------------------
C
C Original version:  B. Briegleb
C Standardized:      L. Buja, June 1992
C Reviewed:          B. Briegleb, J. Hack, August 1992
C
C-----------------------------------------------------------------------
      implicit none
C------------------------------Parameters-------------------------------
#include "pmgrid.com"
C------------------------------Commons----------------------------------
#include "comtim.com"
C-----------------------------------------------------------------------
#include "comtsc.com"
C------------------------------Arguments--------------------------------
C
C Input arguments
C
      real tmeltx,    ! Melting temperature of snow and ice
     $     cpairx,    ! Specific heat of dry air at constant pressure
     $     epsilox,   ! Ratio mean molecular weight of water to dry air
     $     gravitx,   ! Gravitational acceleration
     $     latvapx,   ! Latent heat of vaporization
     $     rairx,     ! Gas constant for dry air
     $     stebolx,   ! Stefan-Boltzmann constant
     $     wssatx,    ! Soil moisture capacity
     $     clrh2ox,   ! Ratio latent heat vaporization to H2O gas const
     $     dtimex     ! Model time step (delta-t)
C
C-----------------------------------------------------------------------
C
      latice = 3.336e5    ! Latent heat of fusion at 0-C = 3.336e5 J/Kg
      tmelt  = tmeltx
      cpair  = cpairx
      epsilo = epsilox
      gravit = gravitx
      latvap = latvapx
      rair   = rairx
      stebol = stebolx
      wssat  = wssatx
      qwssat = 1./(0.75*wssat)
      clrh2o = clrh2ox
      dtime  = dtimex
      snwedp = 10.0       ! 10:1 Snow:water equivalent depth factor
      zzocen = 0.0001
      zzsice = 0.0400
      xkar   = 0.4
      ric    = 3.05
      rimax  = 0.50*ric
C
      return
      end
