#include "params.h"
      logical function whenwr(kstep   ,ktape)
C-----------------------------------------------------------------------
C
C Determine whether it is time to write history tape ktape
C
C---------------------------Code history--------------------------------
C
C Original version:  L. Bath
C Standardized:      L. Bath, June 1992
C
C-----------------------------------------------------------------------
      implicit none
C------------------------------Arguments--------------------------------
C
C Input arguments
C
      integer kstep,         !  iteration number
     $        ktape          !  history tape number to test for
C
C------------------------------Parameters-------------------------------
#include "pmgrid.com"
#include "pagrid.com"
C------------------------------Commons----------------------------------
#include "comhst.com"
C-----------------------------------------------------------------------
#include "comtim.com"
C-----------------------------------------------------------------------
#include "comlun.com"
C-----------------------------------------------------------------------
#include "comhed.com"
C---------------------------Local variables-----------------------------
C
      integer jdcur,       ! current day
     $        jscur,       ! current seconds of current day
     $        jcdate,      ! current date (yymmdd format)
     $        jcsec        ! current seconds of current date
      real jlday           ! current julian day including fraction
      external caldyi
C
      whenwr = .false.
C
C For the monthly average tapes whenwr will calculate the current month
C and date from nstep-1 and set whenwr to true on the first timestep of 
C the month.  For normal tapes whenwr will be set true on according to
C nhtfrq.
C
      if (ninavg(ktape).eq.'Q') then
         call caldyi(kstep-1 ,dtime   ,mdbase  ,msbase  ,mbdate  ,
     $               mbsec   ,jdcur   ,jscur   ,jcdate  ,jcsec   ,
     $               jlday   )
         if (((mod(jcdate,100).eq.1) .and. jcsec.eq.0
     $       .and.(kstep.ne.nrstrt)) .or. kstep.eq.1) then
            whenwr = .true.
         end if
      else
        if(nhtfrq(ktape).ne.0) then
         if (kstep.ne.nrstrt .and. mod(kstep-1,nhtfrq(ktape)).eq.0) then
              whenwr = .true.
	 end if
        end if
      end if
C
      return
      end
