#include "params.h"
      subroutine xformdrv(irow,tdt,ztodt,wfld,psslt,etamid,
     $ 			vcour,detam,
     $                  gr1lps,gr1t ,gr1q ,
     $                  gr1z  ,gr1d ,gr1fu,
     $                  gr1fv ,gr1vt,gr1vq,
     $                  gr1rh ,
     $                  gr2lps,gr2t ,gr2q ,
     $                  gr2z  ,gr2d ,gr2fu,
     $                  gr2fv ,gr2vt,gr2vq,
#ifndef BLOCK_FFT
     $                  gr2rh, vmax2d, vmax2dt)
#else
     $                  gr2rh, vmax2d, vmax2dt,
     $                  fft_buffer, ip )
#endif
C---------------------------------------------------------------------
c inserted by implnone
      implicit none
#include "pmgrid.com"
C---------------------------------------------------------------------
#include "pagrid.com"
C---------------------------------------------------------------------
#include "pspect.com"
C---------------------------------------------------------------------
#include "comctl.com"
C-----------------------------------------------------------------------
#include "comgrd.com"
C-----------------------------------------------------------------------
#include "comhd.com"
C---------------------------------------------------------------------
#include "comlun.com"
C-----------------------------------------------------------------------
#include "comslt.com"
C---------------------------------------------------------------------
#include "comtim.com"
C---------------------------------------------------------------------
#include "com3d.com"
C---------------------------------------------------------------------
#include "abemub.com"
#include "incore.com"
C
C Input arguments
C
      real wfld(plon,plevp,plat),   ! Vertical motion (slt)
     $     psslt(plond,plat),
     $     etamid(plev),
     $     detam(plev)            ! intervals between vert.levels
      real vcour(plev,plat)         ! maximum Courant number in vert.
      real vmax2d(plev,plat),      ! Max. wind as function of level, latitude
     $     vmax2dt(plev,plat)      ! Max. truncated wind as funct of lvl, lat
#ifdef PP_PCCM
c parallel fft needs full size 
      real gr1lps(plon),gr2lps(plon),
     $     gr1t(plon,plev),gr2t(plon,plev),
     $     gr1q(plon,plev),gr2q(plon,plev),
     $     gr1z(plon,plev),gr2z(plon,plev),
     $     gr1d(plon,plev),gr2d(plon,plev),
     $     gr1fu(plon,plev),gr2fu(plon,plev),
     $     gr1fv(plon,plev),gr2fv(plon,plev),
     $     gr1vt(plon,plev),gr2vt(plon,plev),
     $     gr1vq(plon,plev),gr2vq(plon,plev),
     $     gr1rh(plon,plev),gr2rh(plon,plev)
#ifdef BLOCK_FFT
      real fft_buffer(plond,*)
      integer ip
#endif
C
C Local workspace
C
      real gr1ut(plon,plev),gr2ut(plon,plev),
     $     gr1uq(plon,plev),gr2uq(plon,plev)
      integer ih		! 1 = southern hemi, 2 = northern
#else
      real gr1lps(2*pmmax),gr2lps(2*pmmax),
     $     gr1t(2*pmmax,plev),gr2t(2*pmmax,plev),
     $     gr1q(2*pmmax,plev),gr2q(2*pmmax,plev),
     $     gr1z(2*pmmax,plev),gr2z(2*pmmax,plev),
     $     gr1d(2*pmmax,plev),gr2d(2*pmmax,plev),
     $     gr1fu(2*pmmax,plev),gr2fu(2*pmmax,plev),
     $     gr1fv(2*pmmax,plev),gr2fv(2*pmmax,plev),
     $     gr1vt(2*pmmax,plev),gr2vt(2*pmmax,plev),
     $     gr1vq(2*pmmax,plev),gr2vq(2*pmmax,plev),
     $     gr1rh(2*pmmax,plev),gr2rh(2*pmmax,plev)
C
C Local workspace
C
      real gr1ut(2*pmmax,plev),gr2ut(2*pmmax,plev),
     $     gr1uq(2*pmmax,plev),gr2uq(2*pmmax,plev)
#endif
      integer b1, b2    ! just pointers into storage
c declarations inserted by implnone
      real tdt,ztodt
c declarations inserted by implnone
      integer irow,iter,j,lat
c
c Begin executable code: loop over latitude pair.
c
      do 10 iter=1,2
#ifdef PP_PCCM
         if ( iter .eq. 1 ) then
	     lat = plat - irow + 1
	     ih = 2				! northern
	     j = j1m + p_lato2 - irow + 1
	 else
	     lat = irow
	     ih = 1				! southern
	     j = j1m + lat
	 endif
#else
         lat = plat - irow + 1
         if(iter.eq.2) lat = irow
#endif
         b1= incore_b+(lat-1)*pflenb
         b2= incore_a+(lat-1)*pflena
         call xform(irow,lat,tdt,ps(1,lat,n3),ps(1,lat,n3m1),
     $               u3(i1,1  ,j,ih,n3),u3(i1,1  ,j,ih,n3m1),
     $               v3(i1,1  ,j,ih,n3),v3(i1,1  ,j,ih,n3m1),
     $               t3(i1,1  ,j,ih,n3),t3(i1,1  ,j,ih,n3m1),
     $               q3(i1,1,1,j,ih,n3),q3(i1,1,1,j,ih,n3m1),
     $               wfld(1,1,lat),psslt(1,lat),etamid,
     $               ztodt,vmax2d(1,lat), vmax2dt(1,lat),
     $               vcour(1,lat),detam,
     $               gr1lps,gr1t ,gr1q ,gr1z ,gr1d ,gr1fu,gr1fv,
     $               gr1ut ,gr1uq,gr1vt,gr1vq,gr1rh,
     $               gr2lps,gr2t ,gr2q ,gr2z ,gr2d ,gr2fu,gr2fv,
     $               gr2ut ,gr2uq,gr2vt,gr2vq,gr2rh,
     $                  y(b1+npsm2) ,y(b1+npsm1)  ,y(b1+num2)   ,
     $     y(b1+nvm2)  ,y(b1+ntm2)  ,y(b1+nqm2)   ,y(b1+nqminus),
     $     y(b2+nzp1)  ,y(b1+nzm1)  ,y(b1+nztl)   ,y(b2+ndp1)   ,
     $     y(b1+ndm1)  ,y(b1+ndtl)  ,y(b2+ndpslp1),y(b2+ndpsmp1),
     $     y(b1+nts)   ,y(b1+nws)   ,y(b1+nsn)    ,y(b1+noro)   ,
     $     y(b1+nrnfp1),y(b1+nphis) ,y(b1+npblht) ,y(b1+nqpert) ,
     $     y(b1+ntpert),y(b2+nduhp1),y(b2+ndvhp1) ,y(b2+ndthp1) ,
     $     y(b1+nqrs)  ,y(b1+nqrl)  ,y(b1+nflwds) ,y(b1+nfsns)  ,
     $     y(b1+nplos)  ,
#   ifndef BLOCK_FFT
     $     y(b1+nplol) ,y(b1+ntssub))
#   else
     $     y(b1+nplol) ,y(b1+ntssub),
     $     fft_buffer, ip )
#   endif
   10 continue
      return
      end
