#include "params.h"
      subroutine attach(iu      ,mspath  ,locpth  ,bsiz    ,form    ,
     $                  chk)
C-----------------------------------------------------------------------
C
C Msread and open file to unit iu
C
C---------------------------Input arguments-----------------------------
c inserted by implnone
      implicit none
      integer iu             ! unit number
      character mspath*(*),  ! full mass store path name
     $          locpth*(*)   ! full Cray disk path name
      integer bsiz           ! buffer size in blocks
      character*1 form       ! U=unformatted, F=formatted
      logical chk            ! If true, check local file existence
C-------------------------- Local workspace-----------------------------
      character text*130,    ! Printed as msread command
     $          iuch*2,      ! Character unit number
     $          itmp*2,
     $          ibsz*3       ! Requested buffer size as character string
      character*80 errmsg    ! Message space for mserror
      integer klen,          ! Length of mass store path name
     $        kllen          ! Length of generated local path name
C-----------------------------externals---------------------------------
      external assign, ljust, lenchr, endrun, msread, mserror
C
C Get pathname lengths
C
c declarations inserted by implnone
      integer ierr,lenchr
C
C Assign unit
C
      klen = lenchr(mspath)
      kllen = lenchr(locpth)
      write(itmp,'(i2)') iu
      call ljust(itmp,iuch)
      write(ibsz,'(i3)') bsiz
#ifdef CRAY
      text = 'assign -b '//ibsz//' -a '//locpth(1:kllen)//' fort.'//iuch
      write(6,800) text
  800 format('ATTACH:Sending the following to assign:',a130)
      call assign(text)
C
C Call msread to get dataset
C
      if(chk) then                    ! Check for local dataset existence
         text = 'msread -f TR '//locpth(1:kllen)//' '//
     $                mspath(1:klen)
         write(6,*)'ATTACH:Calling msread as follows:',text
         call msread(ierr,locpth(1:kllen), mspath(1:klen),
     $               ' ','FORMAT=TR')
      else
         text = 'msread -f TR -R '//locpth(1:kllen)//' '//
     $                mspath(1:klen)
         write(6,*)'ATTACH:Calling msread as follows:',text
         call msread(ierr,locpth(1:kllen),mspath(1:klen),
     $               ' ','FORMAT=TR,REPLACE')
      endif
      if (ierr.eq.0) then
         write(6,*)' File ',locpth(1:kllen),' read from MSS'
      elseif (ierr.eq.3) then
         write(6,*)' Using existing disk copy of ',locpth(1:kllen)
      else
         call mserror(errmsg)
         write(6,*)'ATTACH:Error from msread -- ',errmsg
         write(6,*)'ATTACH:Local file =',locpth(1:kllen)
         write(6,*)'       Remote pathname= ',mspath(1:klen)
         call endrun
      endif
C
C Open file
C
      if (form.eq.'U'.or.form.eq.'u') then
         open (unit=iu,form='UNFORMATTED',iostat=ierr)
      else
         open (unit=iu,form='FORMATTED',iostat=ierr)
      endif
      if (ierr.ne.0) then
         write(6,*)'ATTACH:Error opening unit ',iu
    2    write(6,*)'       Message number = ',ierr
         call endrun
      endif
#else
      open(unit=iu,file=locpth,status='OLD',iostat=ierr)
      if(ierr.ne.0) then
         write(6,*)'Failed to open file ',locpth,' ierr=',ierr
         call endrun
      end if
      write(6,*)'Successfully opened file ',locpth,' on unit ',iu
#endif
      return
      end
