#include "params.h"
      subroutine bldfln(kfil)
C-----------------------------------------------------------------------
C
C Build next default history tape or regen file name in sequence
C
C---------------------------Code history--------------------------------
C
C Original version:  L. Bath, April 1992
C Standardized:      L. Bath, June 1992
C
C-----------------------------------------------------------------------
      implicit none
#if ( defined RS6000 )
c      implicit automatic (a-z)
#endif
C------------------------------Arguments--------------------------------
#include "pmgrid.com"
#include "pagrid.com"
#include "comtim.com"
#include "comhed.com"
#include "comctl.com"
C-----------------------------------------------------------------------
C
C Input/output arguments
C
      character kfil*(*)     ! On input, current file name
C                            ! On output, new name
C
C---------------------------Local variables-----------------------------
C
      character 
     $     chtem1*20,           ! Character temporary
     $     chtem2*20,           ! Character temporary
     $     chtem*20,            ! Character temporary
     $     tem*1,               ! Character temporary
     $     tema*2,              ! Character temporary
     $     kfil2*20 		! Temporary storage for file name
      integer 
     $     kfilno,              ! File number as integer
     $     ktem,                ! Temporary to get leading zeros
     $     klen,                ! Length of file name
     $     kyear,               ! Temp year var
     $     kmth                 ! Temp mnth var
      integer 
     $     jdcur,               ! current day
     $     jscur,               ! current seconds of current day
     $     jcdate,              ! current date (yymmdd format)
     $     mmdate,              ! current date (yymmdd format)
     $     jcsec                ! current seconds of current date
      real jlday                ! current julian day including fraction
C
C------------------------------Externals--------------------------------
C
      integer lenchr
      external lenchr           ! Find actual length of character string
      external caldyi           ! Calculate current date for mnthly avgs
      external endrun           ! error abort call
C
C-----------------------------------------------------------------------
C
C For monthly average history tape names we need to calculate the 
C current month and year.  MCDATE is not available on restart so 
C call caldyi to calculate it
C
      if (nlres.and.(nstep.eq.nrstrt)) then
         call caldyi(nstepr  ,dtime   ,ndbase  ,nsbase  ,nbdate  ,
     $               nbsec   ,jdcur   ,jscur   ,jcdate  ,jcsec   ,
     $               jlday   )
         mmdate = jcdate
      else
         mmdate = mcdate
      end if
      kyear = mmdate/10000
      kmth = mod(mmdate/100,100)
      write (chtem1,'(i2)') kyear 
      write (chtem2,'(i2)') kmth
      if (kyear.lt.10) chtem1(1:1) = '0'
      if (kmth.lt.10) chtem2(1:1) = '0'
      klen = lenchr(kfil)
C
C If input tape is monthly average history tape make mm-yy name
C
      if (kfil(3:3).eq.'-') then
         kfil2 = chtem2(1:2)//'-'//chtem1(1:2)
         kfil  = kfil2
C
C If input tape is monthly average regeneration tape make rmm-yy format
C
      else if (kfil(4:4).eq.'-') then
         kfil2 = 'r'//chtem2(1:2)//'-'//chtem1(1:2)
         kfil  = kfil2
C
C Input must be a normal history or regeneration tape
C
      else
         if (klen.eq.5 .or. klen .eq. 6 ) then
         if (klen .eq. 5) then
            read (kfil,'(a1,i4)') tem,kfilno
         else
            read (kfil,'(a2,i4)') tema,kfilno
         end if
         kfilno = kfilno + 1
         if (kfilno.gt.9999) then
            write(6,*)' BLDFLN: maximum output file number exceeded'
            call endrun
         end if
         ktem = kfilno + 10000
         write (chtem,'(i5)') ktem
         if (klen.eq.5) then
            kfil2 = tem//chtem(2:lenchr(chtem))
            kfil  = kfil2
         else
            kfil2 = tema//chtem(2:lenchr(chtem))
            kfil  = kfil2
         end if
      end if
      end if
C        
      return
      end

