#include "params.h"
      subroutine inifld(fieldn  ,iflds   ,hacc    ,hbufpt  ,nden    ,
     $                  ktape   ,nrlen   ,nplen   ,nflds   ,mfld    ,
     $                  mcfld   ,npt     ,nppt    )
C-----------------------------------------------------------------------
C
C Store field list information for field fname, as follows:
C
C  mflds(3,nflds)  (integer array)
C  mflds(1,if) = layer location flag and instantaneous
C                or accumulated field flag.
C  mflds(2,if) = pointer to first value for field(if) in data
C                record
C  mflds(3,if) = data packing density (1-4)
C
C  mcflds(2,nflds)  (character array)
C  mcflds(1,if) = name of field(if)
C  mcflds(2,if) = units of field(if)
C
C---------------------------Code history--------------------------------
C
C Original version:  L. Bath  
C Standardized:      L. Bath, June 1992
C
C-----------------------------------------------------------------------
      implicit none
#if ( defined RS6000 )
c      implicit automatic (a-z)
#endif
C------------------------------Parameters-------------------------------
#include "pmgrid.com"
#include "pagrid.com"
#include "comlun.com"
C------------------------------Arguments--------------------------------
C
C Input arguments
C
      character*8 fieldn(2)   ! Character field info from bldfld
      integer iflds(3)        ! Integer field info from bldfld
      character*1 hacc        ! Accumulation indicator
C                             !   'I' = instantaneous, 'A' = averaged
C                             !   'M' = minimum,       'X' = maximum
      integer nden,           !  Packing density, 1,2,3 or 4
     $        ktape           !  History tape number
C
C Input/output arguments
C
      integer hbufpt(ptapes), !  History tape buffer pointers
     $        nrlen,          !  Actual length of data record
     $        nplen,          !  Length of packed data record
     $        nflds           !  Number of fields on tape
C
C Output arguments
C
      integer mfld(3),        !  Integer field list information
     $        npt,            !  Unpacked field pointer
     $        nppt            !  Packed field pointer
      character*8 mcfld(2)    !  Character field list information
C
C---------------------------Local variables-----------------------------
C
      integer ilen,           ! Length of slice of unpacked field
     $        iplen,          ! Length of slice of packed field.
     $        ihacc,          ! Integer form of accumulation indicator
     $        itape           ! Index for history tape pointers
C
C------------------------------Externals--------------------------------
C
      external endrun         !  Abnormal termination
C
C-----------------------------------------------------------------------
C
C Convert input types
C
      ihacc = 0
      if (hacc.eq.'A') ihacc = 1
      if (hacc.eq.'M') ihacc = 2
      if (hacc.eq.'X') ihacc = 3
C
C Monthly average tapes are treated like normal average tapes
C
      if (hacc.eq.'Q') ihacc = 1
C
C Save pointer to field
C
      npt = nrlen + 1
      nppt = nplen + 1
C
C Figure lengths of field (unpacked and packed)
C
      ilen = plon
      if (iflds(1).ge.1) ilen = ilen*plev
      if (nden.eq.1) then
         iplen = ilen
      else
         iplen = 2+(plon+nden-1)/nden
         if (iflds(1).ge.1) iplen = plev*iplen
      end if
C
C Reset lengths
C
      nrlen = nrlen + ilen
      nplen = nplen + iplen
      nflds = nflds + 1
C
C Set field information
C
      mcfld(1) = fieldn(1)
      mfld(1)  = ihacc*10 + iflds(1)
C
C Set mfld(2) in fldlst after all fields are defined
C
      mfld(3) = nden
      mcfld(2) = fieldn(2)
C
C Update history tape buffer pointer for all tapes beyond this one
C
      do itape = ktape+1,ptapes
         hbufpt(itape) = hbufpt(itape) + ilen
      end do
C
C Update history tape buffer lengths for monthly average restarts
C
      rg3buf(ktape) = rg3buf(ktape) + ilen
C
      return
      end






