#include "params.h"
      subroutine inthed(mtapes  ,caseid  ,ctitle  )
C-----------------------------------------------------------------------
C
C Initialize history tape header values common to all of mtapes
C
C---------------------------Code history--------------------------------
C
C Original version:  L. Bath, April 1992
C Standardized:      L. Bath, June 1992
C
C-----------------------------------------------------------------------
      implicit none
#if ( defined RS6000 )
c      implicit automatic (a-z)
#endif
C------------------------------Arguments--------------------------------
C
C Input arguments
C
      integer      mtapes   ! Number of declared tapes
      character*8  caseid   ! Case identifier
      character*80 ctitle   ! Case title
C
C------------------------------Parameters-------------------------------
#include "pmgrid.com"
#include "pagrid.com"
C-----------------------------------------------------------------------
#include "pspect.com"
C------------------------------Commons----------------------------------
#include "comctl.com"
C-----------------------------------------------------------------------
#include "comhed.com"
C-----------------------------------------------------------------------
#include "comhdt.com"
C-----------------------------------------------------------------------
#include "comhyb.com"
C-----------------------------------------------------------------------
#include "commap.com"
C-----------------------------------------------------------------------
#include "commss.com"
C-----------------------------------------------------------------------
#include "comtim.com"
C---------------------------Local variables-----------------------------
C
      integer i,            ! Mtapes index
     $        j,            ! Latitude index
     $        k,            ! Level index
     $        klen          ! Length of character variable
      real    pie           ! Value of pi
      character*8 blkfil    ! Word of blanks for filling
C
C------------------------------Externals--------------------------------
C
      character*8 hchar, igtseq
      integer lenchr
      external hchar,       ! Convert Hollerith string to character type
     $         igtseq,      ! Get sequence number
     $         lenchr       ! Actual length of character string
#if ( defined CRAY )
      real date, clock
#else
      character*8 date,clock
#endif 
      external date, clock  ! System time routines
C
C-----------------------------------------------------------------------
C
      blkfil = '        '
      mlon   = plon
      nlonw  = plon
      morec  = plat
      mlev   = plev
      mxxx   = 0
      mtrk   = ptrk
      mtrm   = ptrm
      mtrn   = ptrn
      nsteph = 0
C
      lenhdr = 3*( 2*mlev + 1 ) + morec + morec
#if ( defined CRAY )
      mftyp  = 43
#else
      mftyp  = 1043
#endif
      nrbd   = 3
      mpflds = 38
      mpcfld = 90
      mpsig  = 1
      mplat  = 3*(2*plev+1) + 1
      mpwts  = mplat + plat
C
C Time values
C
      ndbase = mdbase
      nsbase = msbase
      nbdate = mbdate
      nbsec  = mbsec
      mdt    = twodt/2
C
C Values in record 2
C
      klen   = lenchr(caseid)
      mcase  = caseid(1:klen)//blkfil(klen+1:8)
      mcstit = ctitle
      if (.not.nlres) then
#if ( defined CRAY )
         ldhstf = hchar(date())
         lthstf = hchar(clock())
#else
         ldhstf = date()
         lthstf = clock()
#endif
         lshstf = igtseq()
      else if (lbrnch) then
         ldhstf = '        '
         lthstf = '        '
         lshstf = '        '
      end if
C
C Set initial dataset information from initial dataset header
C now resident in comhed
C
      if (nsrest.eq.0) then
         lnhsti = lnhstc
         ldhsti = ldhstc
         lthsti = lthstc
         lshsti = lshstc
      end if
C
      nstprh = nstepr
      do i=1,mtapes
         nstepht(i) = max0(0,nrstrt-1)
      end do
C
C Set current history tape info for first header
C
#if ( defined CRAY )
      ldhstc = hchar(date())
      lthstc = hchar(clock())
#else
      ldhstc = date()
      lthstc = clock()
#endif
      lshstc = igtseq()
C
C Set boundary dataset information
C
      lnhstt  = bndti
      ldhstt  = ldhstts
      lthstt  = lthstts
      lshstt  = lshstts
      lnhstvs = bndtvs
      ldhstvs = ldhstvss
      lthstvs = lthstvss
      lshstvs = lshstvss
      lnhstvo = bndtvo
      ldhstvo = ldhstvos
      lthstvo = lthstvos
      lshstvo = lshstvos
C
C Initialize current times to base times for first header
C
      ndcur  = ndbase
      nscur  = nsbase
      ncdate = nbdate
      ncsec  = nbsec
C
      mfstrt = nsrest
C
C Set header real array from lats calculated in inti
C
      pie = 4.*atan(1.)
      do j=1,plat
         hdlat(j) = (180./pie)*clat(j)
      end do
C
C Create sigma arrays from /comhyb/
C
      do k=1,plev
         siga(2*k-1) = hyai(k)
         sigb(2*k-1) = hybi(k)
         siga(2*k)   = hyam(k)
         sigb(2*k)   = hybm(k)
      end do
      siga(2*plevp-1) = hyai(plevp)
      sigb(2*plevp-1) = hybi(plevp)
      do k=1,2*plev+1
         sigapb(k) = siga(k) + sigb(k)
      end do
C
      return
      end
