#include "params.h"
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#ifdef PP_INTEL_PFS
extern int      gopen();
#define M_RECORD 3      /* Unshared file pointer, fixed record length,
                         * access in first come first served order, records
                         * are position dependent by logical node number.
                         */
#endif

#ifdef RS6000
void write_restart( fd, buf, n, retval )
#else
# ifdef T3E
void WRITE_RESTART( fd, buf, n, retval )
# else
void write_restart_( fd, buf, n, retval )
# endif
#endif
int * fd ;
int * n ;
char *buf ;
int * retval ;
{
    if ( *fd < 0 ) 
    {
	fprintf(stderr,"write_rstrt: restart file not opened.\n") ;
    }
    write( *fd, buf, *n ) ;

    *retval =  *fd ;		/* return file descriptor so it */
 				/* can be used to fsync file */
}

#ifdef RS6000
void iwrtend( id )
int * id ;
{
    fsync( *id ) ;		/* force file to be written  */
}
#else
# ifdef T3E
void IWRTEND( id )
# else
void iwrtend_( id )
# endif
int * id ;
{
/* cjd
    iowait( *id ) ;
*/
}
#endif

#ifdef RS6000
void restart_wopen(fd, name, len, me0, nodes0 )
    int * fd ;
    char * name ;
    int * len ;
    int * me0 ;
    int * nodes0 ;
{
    int me, dum ;
    char fname[100] ;
    char tname[100] ;

    me = *me0 ;
    strncpy( tname, name, *len ) ;
    tname[*len] = '\0' ;
#ifdef SIMPLE_OUTPUT
    sprintf(fname,"restart/atmos/%s.A.%04d",tname,me) ;
#else
    sprintf(fname,"%s.A.%04d",tname,me) ;
#endif

#ifdef RS6000
/* O_DEFER is an IBM asynchronous mode that causes the file to 
   not be updated on disk immediately.  It does *not* work over
   NFS.  See "man 2 open" on ibms.  To force writing, we use the
   fsync routine ("man 2 fsync") .  */
    if (( *fd = open( fname, (O_WRONLY|O_CREAT|O_DEFER), 0644 )) < 0 )
#else
    if (( *fd = open( fname, (O_WRONLY|O_CREAT), 0644 )) < 0 )
#endif
    {
        fprintf(stderr,"cannot open %s for writing\n",fname ) ;
        perror("") ;
        exit(2) ;
    }
#ifdef PP_ERROR
    else
    {
        fprintf(stderr,"successfully opened %s for writing\n",fname ) ;
    }
#endif
}

#else

/* NOTE THAT THE LOGIC TO ALTNERNATE RESTART DATA SETS IS
   IN THE CALLING FORTRAN ROUTINE */
# ifdef T3E
void RESTART_WOPEN(fd, name, len, me0, nodes0 )
# else
void restart_wopen_(fd, name, len, me0, nodes0 )
# endif
    int  * fd ;
    char * name ;
    int  * len ;
    int  * me0;
    int  * nodes0;
{
    int i ;
    int me ;
    int nodes ;
    int numvols ;
    int vollst[128] ;
    char fname[100] ;
    char tname[100] ;

    me = *me0 ;
    nodes = *nodes0 ;

    strncpy( tname, name, *len ) ;
    tname[*len] = '\0' ;

#ifdef PP_INTEL_PFS
    sprintf(fname,"%s.A",tname) ;
#else
# ifdef SIMPLE_OUTPUT
    sprintf(fname,"restart/atmos/%s.A.%04d",tname,me) ;
# else
    sprintf(fname,"%s.A.%04d",tname,me) ;
# endif
#endif

#ifndef PP_INTEL_PFS
/* for cfs only - not applicable to pfs on paragon */
/* cjd
    numvols = restrictvol( -1, -1, vollst ) ;
*/

/* compute the volume I am to use -- note assumption that
       volumes are numbered beginning with zero.  */
/* for cfs only - not applicable to pfs on paragon */
    if (numvols == 0)
    {
       vollst[0] = me ;
    } else if ( nodes / numvols > 0 )
    {
        vollst[0] = me / ( nodes / numvols ) ;
    }
    else
    {
        vollst[0] = me ;
    }

/* cjd
    if ( restrictvol( -1, 1, vollst ) < 0 )

    {
	fprintf(stderr,"node %d: could not restrict volumes on %s.",
		       me, fname ) ;
	fprintf(stderr,"  Continuing anyway.\n") ;
    }
#   ifdef PP_ERROR
    else
    {
	fprintf(stderr,"node %d: successfully restricts to vol %d.\n",
			me, vollst[0] ) ;
    }
#   endif
*/
#endif


#ifdef PP_INTEL_PFS
    if (( *fd = gopen( fname, (O_WRONLY|O_CREAT|O_TRUNC), M_RECORD, 0644 )) < 0 )
#else
/*    if (( *fd = open( fname, (O_WRONLY|O_CREAT|O_TRUNC), 0644 )) < 0 )*/
    if (( *fd = open( fname, (O_WRONLY|O_CREAT), 0644 )) < 0 )
#endif
    {
	fprintf(stderr,"cannot open %s for writing\n",fname ) ;
	perror("") ;
	exit(2) ;
    }
#   ifdef PP_ERROR 
    else
    {
	fprintf(stderr,"successfully opens %s for writing\n",fname ) ;
    }
#   endif
}
#endif

#ifdef RS6000
void restart_wclose( fd )
#else
# ifdef T3E
void RESTART_WCLOSE( fd )
# else
void restart_wclose_( fd )
# endif
#endif
    int * fd ;
{
    close( *fd ) ;
}
