#include "params.h"
      subroutine outfld(fname  ,field  ,idim  ,lat ,hbuf, lhbuf )
C-----------------------------------------------------------------------
C
C Store field from karray in history tape buffer
C
C---------------------------Code history--------------------------------
C
C Original version:  L. Bath
C Standardized:      L. Bath, June 1992
C
C-----------------------------------------------------------------------
      implicit none
C------------------------------Parameters-------------------------------
#include "pmgrid.com"
#include "pagrid.com"
C------------------------------Commons----------------------------------
#include "comhed.com"
C-----------------------------------------------------------------------
#include "comhst.com"
C------------------------------Arguments--------------------------------
C
C Input arguments
C
      character*8 fname    ! Field name
      integer idim,        ! Longitude dimension of field array
     $        lat          ! Latitude index
      real field(idim,*)   ! Array containing field values   
      integer lhbuf        ! length of history buffer
C
C Output arguments
C
      real hbuf(lhbuf)         ! History tape buffer
      integer phfield, offset
C
C---------------------------Local variables-----------------------------
C
      integer itape,       ! History tape number index
     $        ifld,        ! Field index on individual history tape
     $        ifldtot,     ! Field index for entire history buffer
     $        numlev,      ! Number of vertical levels in field
     $        itens,       ! Tens digit of array mflds
     $        i,k          ! Longitude, level indices
      integer ifldtst,istart

      integer   ifname
      integer   kfld

C
C------------------------------Externals--------------------------------
C
      external endrun      ! Called on error abort
      external resetr
      external resetr_sub

C
C Search for field fname in all defined tapes.  Only need to look through
C list defined by "mcflds" starting with the same 1st character as "fname"
C
      istart = ichar(fname(1:1)) + ichar(fname(2:2)) +
     $         ichar(fname(3:3)) + ichar(fname(4:4))
      ifldtot = 0

      do 40 itape=1,mtapes
         ifld = 0
         do i=1,nfldsc(istart,itape)
            ifldtst = islocc(istart,itape) + i
            if (mcflds(1,ifldtot+ifldtst).eq.fname) then
               ifld = ifldtst
               goto 10
            end if
         end do
   10    if (ifld.ne.0) then
C
C Field name found.  Position pointer into history buffer
C
            ifldtot = ifldtot + ifld
            if (mod(mflds(1,ifldtot),10).ge.1) then ! Multi-level field
               numlev = plev
            else                                    ! Single-level field
               numlev = 1
            end if
            itens = mflds(1,ifldtot)/10
            phfield = hbufpt(itape)+nupnt(ifld,itape)-1
            if (itens.eq.1) then
C
C Time averaged field
C
               nacs(ifldtot,lat) = nacs(ifldtot,lat) + 1
               do k=1,numlev
                  do i=1,plon
                     offset = (i-1)+((k-1)*plon)+phfield
                     hbuf(offset) = hbuf(offset) + field(i,k)
                  end do
               end do
            else if (itens.eq.0) then
C
C Instantaneous field
C
               do k=1,numlev
                  do i=1,plon
c                     hfield(i,k) = field(i,k)
                     offset = phfield+(i-1)+((k-1)*plon)
                     hbuf(offset) = field(i,k)
                  end do
               end do
            else if (itens.eq.2) then
C
C Point-by-point minimum of field.  On first time step after history tape 
C write, set buffer space to very large positive number.
C
               if (nacs(ifldtot,lat).eq.0) then
c                  call resetr(hfield,numlev*plon,1.e36)
                  call resetr_sub( hbuf, phfield+numlev*plon, phfield,
     $                             numlev*plon, 1.e36)
                  nacs(ifldtot,lat) = 1
               end if
               do k=1,numlev
                  do i=1,plon
c                     hfield(i,k) = amin1(hfield(i,k),field(i,k))
                     offset = phfield+(i-1)+((k-1)*plon)
                     hbuf(offset) = amin1(hbuf(offset),field(i,k))
                  end do
               end do
            else if (itens.eq.3) then
C
C Point-by-point maximum of field.  On first time step after history tape 
C write, set buffer space to very large negative number.
C
               if (nacs(ifldtot,lat).eq.0) then
c                  call resetr(hfield,numlev*plon,-1.e36)
                  call resetr_sub(hbuf, phfield+numlev*plon, phfield,
     $                            numlev*plon, -1.e36)
                  nacs(ifldtot,lat) = 1
               end if
               do k=1,numlev
                  do i=1,plon
c                     hfield(i,k) = amax1(hfield(i,k),field(i,k))
                     offset = phfield+(i-1)+((k-1)*plon)
                     hbuf(offset) = amax1(hbuf(offset),field(i,k))
                  end do
               end do
            else
               write(6,*)'OUTFLD: Bad tens digit in mflds=',itens
               call endrun
            end if
         end if
C
C Position pointer for next tape
C
         ifldtot = ifldtot + (nflds(itape) - ifld)
   40 continue
C
      return
      end

