#include "params.h"
      subroutine prnthd(ktape   ,lenhi   ,lenhc   ,lenhr   ,hedi    ,
     $                  hedc    ,hedr    ,mhflds  ,mchflds ,full    )
C-----------------------------------------------------------------------
C
C Print the CCM2 history tape header for tape ktape to unit 6
C
C---------------------------Code history--------------------------------
C
C Original version:  CCM1
C Standardized:      L. Bath, June 1992
C
C-----------------------------------------------------------------------
      implicit none
C------------------------------Parameters-------------------------------
#include "pmgrid.com"
#include "pagrid.com"
C-----------------------------------------------------------------------
#include "pspect.com"
C------------------------------Arguments--------------------------------
C
C Input arguments
C
      integer ktape             ! History tape number
      integer lenhi,            ! Length of integer header record hedi
     $        lenhc,            ! Length of character header record hedc
     $        lenhr             ! Length of real header record hedr
      integer hedi(lenhi)       ! Integer header array
      character*8 hedc(lenhc)   ! Character header array
      real hedr(lenhr)          ! Real header array
      integer mhflds(3,*)       ! Integer level,pointer,packing array
      character*8 mchflds(2,*)  ! Character field-name,units array
      logical full              ! Printout selection flag
C                               !  = .true.  - all values are printed
C                               !  = .false. - only scalars are printed
C
C---------------------------Local workspace-----------------------------
C
      integer nfldh,            ! Number of fields from header
     $        mpsig,            ! Pointer to sigmas in record 3
     $        mplat,            ! Pointer to latitudes in record 3
     $        mpwts,            ! Pointer to weights in record 3
     $        j,jj,jstrt,jend,k ! Indices
C
C-----------------------------------------------------------------------
C
#ifdef PP_PCCM
        hedi( 6) = (hedi( 6)-2) * p_nproc_ln + 2
        hedi( 7) = (hedi( 7)-2) * p_nproc_ln + 2
        hedi( 9) = hedi( 9) * p_nproc_ln
        hedi(10) = hedi(10) * p_nproc_ln
        hedi(11) = hedi(11) * p_nproc_lt
#endif
      write (6,9010)
      if (ktape.eq.1) then
         write(6,9012)
      else if (ktape.gt.1) then
         write(6,9015) ktape-1
      end if
      write (6,9020) (hedc(j),j=1,11)
      write (6,9030)
      write (6,9040) (hedi(j),j=1,10)
      write (6,9050)
      write (6,9040) (hedi(j),j=11,20)
      write (6,9055)
      write (6,9057) (hedi(j),j=21,30)
      write (6,9060)
      write (6,9070) (hedi(j),j=31,37)
      write (6,9080)
      write (6,9090) (hedc(j),j=12,89)
C
C Values printed only if full header requested
C
      if (full) then
         nfldh = hedi(16)
         write (6,9100)
         write (6,9110)
         jstrt = 1
         jend  = nfldh
         jj = 1
         do j=jstrt,jend
            write(6,9120) jj,mchflds(1,j),(mhflds(k,j),k=1,3),
     $                       mchflds(2,j)
            jj = jj + 1
         end do
         write (6,9140)
      end if
C
C Print real arrays only for full printout
C
      if (full) then
         mpsig = hedi(33)
         mplat = hedi(34)
         mpwts = hedi(35)
         write(6,9910)
         write (6,9920) (hedr(j),j=mpsig+1,mpsig+2*plev-1,2)
         write (6,9930)
         write (6,9920) (hedr(j),j=mpsig,mpsig+2*plev,2)
         write (6,9950)
#ifdef PP_PCCM
         write (6,9960) (hedr(j),j=mplat,mplat+p_glat-1)
         write (6,9970)
         write (6,9920) (hedr(j),j=mpwts,mpwts+p_glat-1)
#else
         write (6,9960) (hedr(j),j=mplat,mplat+plat-1)
         write (6,9970)
         write (6,9920) (hedr(j),j=mpwts,mpwts+plat-1)
#endif
      end if
#ifdef PP_PCCM
        hedi( 6) = (hedi( 6)-2) / p_nproc_ln + 2
        hedi( 7) = (hedi( 7)-2) / p_nproc_ln + 2
        hedi( 9) = hedi( 9) / p_nproc_ln
        hedi(10) = hedi(10) / p_nproc_ln
        hedi(11) = hedi(11) / p_nproc_lt
#endif
C
      return
 9010 format(//'     ***  HEADER FOR CCM2 HISTORY TAPE  *** ',/)
 9012 format(  '     ***   Primary History Tape   ***'//)
 9015 format(  '     ***   Auxiliary History Tape no. ',i3,'   ***'//)
 9020 format(2x,'CASE: ',4x,a8,/,1x,'TITLE: ',3x,10a8,/)
 9030 format(t6, 'LENHDI' ,t15,'MFTYP'  ,t24,'MFILH'  ,t33,'MFILTH',
     $       t42,'NRBD'   ,t51,'MAXSIZ' ,t60,'NDAVU'  ,t69,'MXXX'  ,
     $       t78,'NLON'   ,t87,'NLONW'  )
 9040 format(10i9,/)
 9050 format(t6, 'PLAT'   ,t15,'PLEV'   ,t24,'PTRM'   ,t33,'PTRN'  ,
     $       t42,'PTRK'   ,t51,'NFLDH'  ,t60,'NSTEPH' ,t69,'NSTPRH',
     $       t78,'NITSLF' ,t87,'NDBASE' )
 9055 format(t6,'NSBASE'  ,t15,'NNDCUR' ,t24,'NSCUR'  ,t33,'NBDATE',
     $       t42,'NBSEC'  ,t51,'NCDATE' ,t60,'NCSEC'  ,t69,'MDT'   ,
     $       t78,'MHISF'  ,t87,'MFSTRT' )
 9057 format(3i9,i9.6,i9,i9.6,4i9,/)
 9060 format(t6,'LENHDC'  ,t15,'LENHDR' ,t24,'MPSIG'  ,t33,'MPLAT' ,
     $       t42,'MPWTS'  ,t51,'MPFLDS' ,t60,'MPHFLD' )
 9070 format(7i9,/)
 9080 format(17x,'MSS PATH NAME',70x,'DATE',5x,'TIME',3x,'SEQ NO.')
 9090 format(' CURRENT        ',9a8,4a9 ,/,' FIRST          ',9a8,4a9,/,
     $       ' INITIAL        ',9a8,4a9 ,/,' TI BOUNDARY    ',9a8,4a9,/,
     $       ' SST BOUNDARY   ',9a8,4a9 ,/,' OZONE BOUNDARY ',9a8,4a9)
 9100 format(//' FIELD LIST '/)
 9110 format(' FLD NO.     NAME     FLG. FLD PT.  PACK.  UNITS',/)
 9120 format(i5,8x,a8,i3,i8,i7,5x,a8)
 9140 format(1x,/)
 9910 format(' SIGMA VALUES AT FULL LEVELS',/)
 9920 format(1x,1p5e22.14)
 9930 format(/,' SIGMA VALUES AT HALF LEVELS',/)
 9950 format(//,' LATITUDES',/)
 9960 format(1x,10f12.5)
 9970 format(//,' GAUSIAN WEIGHTS',/)
      end
