#include "params.h"
#ifdef PP_PCCM
      subroutine rdharr(iu, len, flat, flon, buf, ilat, endlat )
C----------------------------------------------------------------------
C
C Array read for boundary datasets
C
C----------------------------------------------------------------------
      implicit none
#include "pmgrid.com"
#include "pagrid.com"
#include "pspect.com"
#include "comrdhdr.com"
#include "comparll.com"
#include "comlun.com"
C--------------------------input parameters----------------------------
      integer iu,          ! Logical unit number
     $        len,         ! Length of array read
     $        endlat
C--------------------------output parameters---------------------------
      real flat            ! Latitude index     !global latitude 
      real flon            ! Number of longitudes
      real buf(len)
C----------------------------------------------------------------------
c added fields for decomposing latitude records in longitude
      integer ilat              ! when ilat == 1, initialize g_latcnt
      integer g_latcnt		! used to step through global # of lats
      save g_latcnt
      integer
     $     nfldh,               ! number of fields in input record
     $     nlon,                ! number of longitudes (distinct)
     $     nlond,               ! number of longitudes (dimension)
     $     nlonh,               ! number of longitudes (input record)
     $     nlev,                ! number of levels (multilevel fields)
     $     maxsiz               ! length of an input latitude rec

      logical no_decomp		! if true, no longitudinal decomp.
      integer idex, info
      integer p_ghtbf
      integer gnlon, gnlonh
      parameter ( p_ghtbf = phtbf * p_nproc_ln )
      real locbuf( p_ghtbf + 2 )    ! local to rdharr only
      logical copied 
      integer i, ip, jp, nint, n
      integer from, dest, tag, globlat
      integer nfac
      real handshake
      real tmpbuf( p_ghtbf )	! temporary buffer
      real sendbuf( p_ghtbf+4 )	! temporary buffer
      real flat_tmp, flon_tmp	! temporaries
c-------------------------------------------------------------------
c
      if ( ilat .eq. 1 ) then
	 g_latcnt = 1		! intialize to first lat
	 m_type = m_type + 2*p_nproc
      endif
c
c code to execute on root processor
c
      if (m_pin .eq. mapmesh(0,0) ) then
c
      idex = fldinfo_list( iu )
      if ( idex .lt. 0 ) then
	 write(6,*) 'RDHARR: File never read by rdhdr.  Unit: ',iu
	 call endrun
      endif
#ifdef BOGUS
C  BOGUS is only for starting T85 or T170
c  from a T42 dataset.
#if(PP_TRIANG_TRUNC==85)
        nfac=2
#endif
#if(PP_TRIANG_TRUNC==170)
        nfac=4
#endif
#else 
	nfac=1
#endif


      maxsiz = fldinfo_maxsiz( idex )
      nfldh  = fldinfo_nfld( idex )
      nlev   = fldinfo_nlev( idex )
      gnlon  = fldinfo_nlon( idex )
      gnlonh = fldinfo_nlonw( idex )

      if ( iu .ne. nozone ) then
         nlon   = gnlon*nfac / p_nproc_ln
         nlonh  = nlon + gnlonh - gnlon
	 no_decomp = .false.
      else
         nlon   = gnlon*nfac		! ozone is not decomposed in longitude
         nlonh  = gnlonh*nfac
	 no_decomp = .true.
      endif
c
         do while ( g_latcnt .le. p_glat )
            if(mod(g_latcnt-1,nfac).eq.0)then
              call resetr( locbuf, p_ghtbf+2, 0.0 )
              read(iu,end=99) flat, flon, (locbuf(i),i=1,maxsiz-2)
	      flat=(flat-1)*nfac+1
              flon=flon*nfac
            else
              flat=flat+1
            endif
	    sendbuf(1) = flat
	    sendbuf(2) = flon
	    g_latcnt = g_latcnt + 1

	    globlat = nint( flat )
            if ( globlat .le. p_glat/2 ) then	! southern latitude
	       jp = (globlat - 1)/p_lato2
	    else				! northern latitude
	       jp = (p_glat - globlat)/p_lato2
	    endif

            if (p_nproc_ln.gt.1) then
	      do ip = p_nproc_ln-1, 1, -1
	       dest = mapmesh(ip,jp)
               tag  = m_type
               call extract_hrec( ip,      locbuf, sendbuf(3),
     $                            p_ghtbf, len,  nfldh, nlev,
     $                            nlon,    nlonh,  gnlon, gnlonh,
     $                            fldinfo( 1, idex, 2 ), ! global
     $                            fldinfo( 1, idex, 1 ), !local
     $                            no_decomp , nfac)
c              using ordered, synchronous swaps to implement one-to-all
c              scatter, so that can control message buffering
               call swap(1, 6, 0, m_pin, tag, dest, (len+2)*R_SIZE,
     &                   sendbuf, R_SIZE, handshake)
c
	      enddo  ! end of loop over longitudinal procs
c
	    endif
            ip = 0
            call extract_hrec( ip,      locbuf, sendbuf(3), 
     $                         p_ghtbf, len,  nfldh, nlev,
     $                         nlon,    nlonh,  gnlon, gnlonh,
     $                         fldinfo( 1, idex, 2 ), ! global
     $                         fldinfo( 1, idex, 1 ), ! local
     $                         no_decomp ,nfac)
c
	    if ( jp .eq. 0 ) then
c
c	       I ve got mine.  Now either return or finish up and return
	       if ( ilat .eq. plat .and. g_latcnt .le. p_glat*nfac ) then
		  call copyac(sendbuf(3), tmpbuf, len )
		  flat_tmp = flat
		  flon_tmp = flon
		  copied = .true.
	          goto 200	! continue
	       else
		  copied = .false.
		  goto 300 	! break
	       endif
            else 
	       dest = mapmesh(0,jp)
               tag  = m_type
               call swap(1, 6, 0, m_pin, tag, dest, (len+2)*R_SIZE,
     &                   sendbuf, R_SIZE, handshake)
	    endif
c
  200       continue
c
         enddo  ! end of do while
c
  300    continue
c
	 if ( copied ) then
	    flon = flon_tmp
	    flat = flat_tmp
	    call copyac(tmpbuf, buf, len )
	 else
	    call copyac(sendbuf(3), buf, len)
	 endif
	 if ( ilat .eq. endlat ) m_type = m_type + 2*p_nproc ! bump
      else
c
c code to execute on all other processors
c
        dest = mapmesh(0,0)
c       go "first" in synchronous swap, waiting for ready signal, then
c         sending request for data
        call swap(1, 6, 1, m_pin, m_type, dest, R_SIZE, handshake,
     &            (len+2)*R_SIZE, sendbuf)
c
        flat = sendbuf(1)
	flon = sendbuf(2)
	call copyac( sendbuf(3), buf, len )

	if ( ilat .eq. plat ) then
	  m_type = m_type + 2*p_nproc ! bump
	endif

      endif
c
      return		! normal return
c
   99 continue
      write(6,*)'RDHARR:end of file on unit ',iu
#ifdef PP_ERROR
      write(0,*)'RDHARR:end of file: flat ',flat, ' flon ', flon
#endif
      call endrun
c
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine extract_hrec( p_ln,    gbuf,   buf, 
     $                         glen,    len,    nfldh, nlev,
     $                         nlon,    nlonh,  gnlon, gnlonh, 
     $                         mflds_g, mflds_l,
     $                         no_decomp , nfac)

      implicit none
#include "pmgrid.com"
#include "pagrid.com"
      integer p_ln
      integer len,        glen
      integer
     $     nfldh,               ! number of fields in input record
     $     nlon,     gnlon,     ! number of longitudes (distinct)
     $     nlonh,    gnlonh,    ! number of longitudes (input record)
     $     nlev,                ! number of levels (multilevel fields)
     $     mflds_g(3,nfldh),    ! integer field list from input header
     $     mflds_l(3,nfldh)     ! integer field list from input header
      logical no_decomp		! if .true., no longit. decomp (ozone)

      real    buf(len),   gbuf(glen)
      integer if, nlevfi
      integer i, ii, l, g, k
      integer nfac

      call resetr( buf, len, 0.0 )
      do if = 1, nfldh

	 if ( no_decomp ) then
             g = mflds_g( 2, if ) - 2
	 else
             g = mflds_g( 2, if ) + p_ln * nlon/nfac - 2
	 endif
	 l = mflds_l( 2, if ) - 2

         if (mod(mflds_g(1,if),10).lt.1) then
            nlevfi = 1
         else
            nlevfi = nlev
         endif

         do k = 1, nlevfi
            do i = 1, nlon/nfac
              do ii=nfac*(i-1)+1,nfac*i
	       buf( l + ii - 1 ) = gbuf( g + i - 1)
              enddo
            enddo
	    l = l + nlonh
            g = g + gnlonh
         enddo

      enddo
      return
      end


#else
      subroutine rdharr(iu      ,len     ,flat    ,flon    ,buf)
C----------------------------------------------------------------------
C
C Array read for boundary datasets
C
C----------------------------------------------------------------------
      implicit none
C--------------------------input parameters----------------------------
      integer iu,          ! Logical unit number
     $        len          ! Length of array read
C--------------------------output parameters---------------------------
      real flat            ! Latitude index
      real flon            ! Number of longitudes
      real buf(len)
C
      read(iu,end=99) flat,flon,buf
      return
   99 continue
      write(6,*)'RDHARR:end of file on unit ',iu
      call endrun
      end
#endif
