#include "params.h"
#ifdef PP_PCCM
      subroutine rdhdr(kunit   ,lenhi   ,lenhis  ,lenhc   ,lenhcs  ,
     $                 lenhr   ,hedi    ,hedc    ,hedr    ,mhflds  ,
     $                 mchflds ,kerr    )
C-----------------------------------------------------------------------
C
C Read the history tape header.
C
C---------------------------Code history--------------------------------
C
C Original version:  CCM1
C Standardized:      L. Bath, June 1992
C
C-----------------------------------------------------------------------
      implicit none
C------------------------------Parameters-------------------------------
#include "pmgrid.com"
#include "pagrid.com"
#include "pspect.com"
#include "comparll.com"
#include "comlun.com"
C
C Input arguments
C
      integer kunit           ! History tape unit
      integer lenhi,          ! Declared length of integer header hedi
     $        lenhis,         ! Length of integer scalar portion
     $        lenhc,          ! Declared length of character header hedc
     $        lenhcs,         ! Length of character scalar portion
     $        lenhr           ! Declared length of real header hedr
C
C Output arguments
C
      integer hedi(*)         ! Array to store integer header record
      character*8 hedc(*)     ! Character header record
      real hedr(*)            ! Real header record
      integer mhflds(*)       ! Kunit portion of mflds array
      character*8 mchflds(*)  ! Kunit portion of mcflds array
      integer kerr            ! Error return
C--------------------------local variables------------------------------
      integer len, jend, j, i, jlen
      character*4 savetype
C---------------------data shared with rdharr.F-------------------------
#include "comrdhdr.com"
      logical first
      save first
      data first /.true./
c some misc. integer variables
      integer prev_glen       ! previous global field length
      integer prev_llen       ! previous local field length
      integer prev_pad        ! previous addtnl. length (same for glob & loc)
      integer jj, mlen
      integer nfac
C----------------------------externals----------------------------------
      external endrun
c
c Save current data type
c
      call getdataf(savetype)
C
C Check header lengths and then read header
C
#ifdef BOGUS
C  BOGUS is only for starting a T85 or T170 from
c  a T42 dataset.
#if(PP_TRIANG_TRUNC==85)
        nfac=2
#endif
#if(PP_TRIANG_TRUNC==170)
        nfac=4
#endif
#else
	nfac=1
#endif
      kerr = 0
      if ( m_pin .eq. mapmesh(0,0) ) then      ! only processor 0 reads

         if ( first ) then
            first = .false.
            do j = 1, p_listmax
               fldinfo_list(j) = -1
            enddo
            fldinfo_ctr = 1
         endif
         fldinfo_dex = fldinfo_list( kunit )  ! get entry for this unit
         if ( fldinfo_dex .lt. 0 ) then       ! new unit being read
            fldinfo_dex = fldinfo_ctr
            fldinfo_ctr = fldinfo_ctr + 1
            fldinfo_list( kunit ) = fldinfo_dex
         endif
         if ( fldinfo_dex .gt. p_unitmax ) then
            write(6,*)'RDHDR: too many input units; increase p_unitmax.'
            call endrun
         endif
         read(kunit,end=99)len
         if (len.gt.lenhi) then
            write(6,*)'RDHDR: integer header record too long.'
            write(6,*)'allocated space =',lenhi,', actual length= ',len
            call endrun
         endif
         backspace(kunit)
C
C Check header lengths and then read header
C
         read(kunit,end=99)len
         if (len.gt.lenhi) then
         write(6,*)'RDHDR: integer header record too long.'
         write(6,*)'Allocated space = ',lenhi,', Actual length = ',len
         call endrun
         end if
         backspace(kunit)
C
C Calculate buffer length for integer record
C
         jend = len - lenhis
         read(kunit,end=99)(hedi(i),i=1,lenhis),
     $                     (fldinfo(j,fldinfo_dex,2),j=1,jend)
         if (hedi(31).gt.lenhc) then
            write(6,*)'RDHDR: character header record too long.'
            write(6,*)'allocated space =',lenhc,', actual length= ',
     $                 hedi(31)
            call endrun
         elseif (hedi(32).gt.lenhr) then
            write(6,*)'RDHDR: real header record too long.'
            write(6,*)'allocated space =',lenhr,', actual length= ',
     $                 hedi(32)
            call endrun
         endif
c
         fldinfo_maxsiz( fldinfo_dex )  = hedi( 6)
         fldinfo_nlon( fldinfo_dex )  = hedi( 9)
         fldinfo_nlonw( fldinfo_dex ) = hedi(10)
         fldinfo_nlev( fldinfo_dex )  = hedi(12)
         fldinfo_nfld( fldinfo_dex )  = hedi(16)
c decompose header fields over longitude
c note that maxsiz assumes always have extra two words for flat and flon
c note watch out for ozone file, which should NOT be decomposed in lat
	 if ( kunit .ne. nozone ) then
            hedi( 6 ) = ((hedi(6)-2)*nfac)/p_nproc_ln +
     $               mod((hedi(6)-2)*nfac, ((hedi(6)-2)*nfac)
     $       /p_nproc_ln) + 2
            hedi( 9 ) = hedi(9)*nfac/p_nproc_ln +
     $               mod(hedi(9)*nfac, hedi(9)*nfac/p_nproc_ln)
            hedi( 10 ) = hedi(10)*nfac/p_nproc_ln +
     $                mod(hedi(10)*nfac, hedi(10)*nfac/p_nproc_ln)
	 endif
c decompose header fields over latitude
         hedi( 11 ) = hedi(11)*nfac/p_nproc_lt +
     $                mod(hedi(11)*nfac, hedi(11)*nfac/p_nproc_lt)
c calculate the local offsets into the decomposed fields
         mhflds(1) = fldinfo(1,fldinfo_dex,2)
         mhflds(2) = fldinfo(2,fldinfo_dex,2)
         mhflds(3) = fldinfo(3,fldinfo_dex,2)
         j = 4
         do jj = 2, hedi(16)
	    if ( kunit .ne. nozone ) then
               mhflds(j) = fldinfo(j,fldinfo_dex,2)           ! level info
               prev_glen = fldinfo(j+1,fldinfo_dex,2)-
     $                  fldinfo(j-2,fldinfo_dex,2)
               prev_llen = (prev_glen*nfac) / p_nproc_ln
               prev_pad  = prev_glen - (prev_llen/nfac)*p_nproc_ln
               prev_llen = prev_llen + prev_pad
               mhflds(j+1) = mhflds(j-2) + prev_llen          ! len info
               mhflds(j+2) = fldinfo(j+2,fldinfo_dex,2)       ! pack info
	    else
c just copy in the case of ozone
	       mhflds(j)  =fldinfo(j,  fldinfo_dex,2)   ! level info
	       mhflds(j+1)=fldinfo(j+1,fldinfo_dex,2)   ! level info
	       mhflds(j+2)=fldinfo(j+2,fldinfo_dex,2)   ! level info
	    endif
            j = j + 3
         enddo
         do j = 1, jend
            fldinfo( j, fldinfo_dex, 1 ) = mhflds(j)
         enddo
C
C Calculate scalar and buffer lengths for character record
C
         jend = 2*hedi(16)
         read(kunit,end=991) (hedc(i),i=1,lenhcs), (mchflds(j),j=1,jend)
         read(kunit,end=992) (hedr(i),i=1,hedi(32))
      endif
c
c send to other procs
c
      mlen = lenhi * I_SIZE
      call setdataf('integer')
      call bcast0f( hedi, mlen, m_type, mapmesh(0,0) )
      m_type = m_type + 1

      mlen = 8 * lenhc
      call bcastcf( hedc, mlen, m_type, mapmesh(0,0) )
      m_type = m_type + 1

      mlen = lenhr * R_SIZE
#if defined(WORD4)
      call setdataf('real')
#else
      call setdataf('double')
#endif
      call bcast0f( hedr, mlen, m_type, mapmesh(0,0) )
      m_type = m_type + 1

      mlen = 3 * hedi(16) * I_SIZE
      call setdataf('integer')
      call bcast0f( mhflds, mlen, m_type, mapmesh(0,0) )
      m_type = m_type + 1

      mlen = 2 * hedi(16) * 8
      call bcastcf( mchflds, mlen, m_type, mapmesh(0,0) )
      m_type = m_type + p_nproc
c
c Restore default data type
c
      call setdataf(savetype)
c
      return
   99 kerr = 1
      return
  991 kerr = 2
      return
  992 kerr = 3
      return
      end
#else
      subroutine rdhdr(kunit   ,lenhi   ,lenhis  ,lenhc   ,lenhcs  ,
     $                 lenhr   ,hedi    ,hedc    ,hedr    ,mhflds  ,
     $                 mchflds ,kerr    )
C-----------------------------------------------------------------------
C
C Read the history tape header.
C
C---------------------------Code history--------------------------------
C
C Original version:  CCM1
C Standardized:      L. Bath, June 1992
C
C-----------------------------------------------------------------------
      implicit none
C------------------------------Parameters-------------------------------
#include "pmgrid.com"
#include "pagrid.com"
C------------------------------Arguments--------------------------------
C
C Input arguments
C
      integer kunit           ! History tape unit
      integer lenhi,          ! Declared length of integer header hedi
     $        lenhis,         ! Length of integer scalar portion
     $        lenhc,          ! Declared length of character header hedc
     $        lenhcs,         ! Length of character scalar portion
     $        lenhr           ! Declared length of real header hedr
C
C Output arguments
C
      integer hedi(*)         ! Array to store integer header record
      character*8 hedc(*)     ! Character header record
      real hedr(*)            ! Real header record
      integer mhflds(*)       ! Kunit portion of mflds array
      character*8 mchflds(*)  ! Kunit portion of mcflds array
      integer kerr            ! Error return
C                                
C---------------------------Local variables-----------------------------
C                                
      integer len,            ! Length of integer header record
     $        jend,           ! Length of vectors in record
     $        j, i            ! Indices
C
C------------------------------Externals--------------------------------
C
      external endrun         ! Abnormal termination
C
C-----------------------------------------------------------------------
C
      kerr = 0
C
C Check header lengths and then read header
C
      read(kunit,end=99)len
      if (len.gt.lenhi) then
         write(6,*)'RDHDR: integer header record too long.'
         write(6,*)'Allocated space = ',lenhi,', Actual length = ',len
         call endrun
      end if
      backspace(kunit)
C
C Calculate buffer length for integer record
C
      jend = len - lenhis
      read(kunit,end=99) (hedi(i),i=1,lenhis), (mhflds(j),j=1,jend)
      if (hedi(31).gt.lenhc) then
         write(6,*) 'RDHDR: character header record too long.'
         write(6,*) 'Allocated space = ',lenhc,', Actual length = ',
     $                hedi(31)
         call endrun
      else if (hedi(32).gt.lenhr) then
         write(6,*) 'RDHDR: real header record too long.'
         write(6,*) 'Allocated space = ',lenhr,', Actual length = ',
     $               hedi(32)
         call endrun
      end if
C
C Calculate buffer length for character record
C
      jend = 2*hedi(16)
      read(kunit,end=991) (hedc(i),i=1,lenhcs), (mchflds(j),j=1,jend)
      read(kunit,end=992) (hedr(i),i=1,hedi(32))
C
      return
   99 kerr = 1
      return
  991 kerr = 2
      return
  992 kerr = 3
      return
      end
#endif
