#include "params.h"
      subroutine rdrs1( id )
C-----------------------------------------------------------------------
C
C Restore nra1,nra2 and nsre from restart dataset
c The number passed into id was returned by restart_ropen
C
C -----------------------------parameters-------------------------------
      implicit none
#include "pmgrid.com"
#include "pagrid.com"
#include "pspect.com"
C-------------------------------commons---------------------------------
#include "comctl.com"
C-----------------------------------------------------------------------
#include "comhed.com"
C-----------------------------------------------------------------------
#include "comhst.com"
C-----------------------------------------------------------------------
#include "comloc.com"
C-----------------------------------------------------------------------
#include "comlun.com"
C-----------------------------------------------------------------------
#include "commss.com"
C-----------------------------------------------------------------------
#include "comqfl.com"
C-----------------------------------------------------------------------
#include "comslt.com"
C-----------------------------------------------------------------------
#include "comtfc.com"
C-----------------------------------------------------------------------
#include "comtim.com"
C-----------------------------------------------------------------------
#include "com3d.com"
C-----------------------------------------------------------------------
#include "crdalb.com"
C-----------------------------------------------------------------------
#include "comparll.com"
#include "abemub.com"
#include "incore.com"
#include "restart_fil.com"
#include "restart_buf.com"
      integer curs

C------------------------------Local workspace--------------------------
      integer id, icnt, loclat, loclon, field, b1, b2, b3, lath
      integer i,j,lngth,m
      integer jj,ih,jc,nread
      real    dr(4)
      integer d(4)
c
      integer d_sn, d_nwords, d_glat, d_glon, lb, ub
      parameter (d_sn=1,d_nwords=2,d_glat=3,d_glon=4)
      real col_buf( rstrt_words )

#ifdef PP_NORESTART
#ifdef PP_ERROR
      write(0,*)'RESTARTS DISABLED'
#endif
      return
#endif


C this reads the data set for this processor entirely into memory
      call read_length_info( id, nread )
      call read_restart( id, rstrt_buf, 
     $                   R_SIZE*rstrt_words*plon*plat, nread )

#ifdef PP_ERROR
      write(0,*)' read restart file '
#endif

      curs = 0

 100  continue   ! main loop
		 ! get descriptor

      call get_column( rstrt_buf, curs, dr, R_SIZE*4, nread )

      do i = 1, 4
	  d(i) = dr(i)
      enddo

      if ( nread .le. 0 ) goto 200 ! end of file (i hope!)

      call get_column( rstrt_buf, curs, col_buf,
     $                 R_SIZE*d(d_nwords), nread)

c is this one of my lats?

      if ( d(d_glat) .le. p_glat/2 ) then
	  lb = m_pin_lt * plat/2 + 1
	  ub = lb + plat/2 - 1
      else
	  lb = p_glat/2+(plat/2)*(p_nproc_lt-m_pin_lt-1)+1
	  ub = lb + plat/2 - 1
      endif
      if ( (d(d_glat) .lt. lb ) .or. (d(d_glat).gt.ub)) then
	  goto 100   ! no, continue reading points
      endif

c is this one of my lons?

      lb = m_pin_ln * plon + 1
      ub = m_pin_ln * plon + plon
      if ( (d(d_glon) .lt. lb ) .or. (d(d_glon).gt.ub)) then
	  goto 100   ! no, continue reading points
      endif

c if I get to here, then yes, this is one of my points
#ifdef PP_ERROR
c      write(0,*)'unpck_rstrt_b: accepted',d
#endif

      lath = mod( d(d_glat)-1, plat/2 ) + 1
      jc = j1m+lath		
      if ( d(d_glat) .gt. p_glat/2 ) then
	  ih = 2
          loclat = plat/2 + lath
      else
	  ih = 1
          loclat = lath
      endif
      loclon = d(d_glon) - m_pin_ln * plon


#if 0
#ifdef PP_ERROR
      write(0,*)'loclat = ',loclat,
     $          '  loclon = ',loclon,d
#endif
#endif

      if      ( d(d_sn) .eq. 1 ) then  !
	  icnt = 1
	  b1 = incore_b+(loclat-1)*pflenb - 1
	  do field = 0, (pbflnb+pbflna)/plond - 1
	      y(b1+field*plond+loclon) = col_buf( icnt )
	      icnt = icnt + 1
	  enddo
	  b2 = incore_a+(loclat-1)*pflena - 1
	  do field = 0, pbflna/plond - 1
	      y(b2+field*plond+loclon) = col_buf( icnt )
	      icnt = icnt + 1
	  enddo
	  do field = 0, plev*(3+pcnst) - 1
	      x(i1-1+loclon+field*plond,1,1,jc,ih,n3) = 
     $            col_buf(icnt)
	      icnt = icnt + 1
	  enddo
	  do field = 0, plev*(3+pcnst) - 1
	      x(i1-1+loclon+field*plond,1,1,jc,ih,n3m1) =
     $            col_buf(icnt)
	      icnt = icnt + 1
	  enddo
	  do field = 0, plev - 1
	      lammp(field*plon+loclon,1,loclat) = col_buf(icnt)
	      icnt = icnt + 1
	  enddo
	  do field = 0, plev - 1
	      phimp(field*plon+loclon,1,loclat) = col_buf(icnt)
	      icnt = icnt + 1
	  enddo
	  do field = 0, plev - 1
	      sigmp(field*plon+loclon,1,loclat) = col_buf(icnt)
	      icnt = icnt + 1
	  enddo
	  do m = 1, pcnst
	      do field = 1, plev
		  hqfcst(loclon,field,m,loclat) = col_buf(icnt)
	          icnt = icnt + 1
	      enddo
	      do field = 1, plev
		  qfcst(i1-1+loclon,field,m,jc,ih) =
     $              col_buf(icnt)
	          icnt = icnt + 1
	      enddo
	  enddo
	  ps(loclon,loclat,n3) = col_buf(icnt)
	  icnt = icnt + 1
	  ps(loclon,loclat,n3m1) = col_buf(icnt)
	  icnt = icnt + 1
      else if ( d(d_sn) .eq. 2 ) then
	  icnt = 1
	  do m = 1, pcnst
	      hw1(m) = col_buf(icnt)
	      icnt = icnt + 1
	      hw2(m) = col_buf(icnt)
	      icnt = icnt + 1
	      hw3(m) = col_buf(icnt)
	      icnt = icnt + 1
	      alpha(m) = col_buf(icnt)
	      icnt = icnt + 1
	  enddo
      else if ( d(d_sn) .eq. 3 ) then
	  icnt = 1
	  b3 = incore_ems+(loclat-1)*plngbuf
	  do field = 0, plngbuf/plond - 1
	      y(b3-1+field*plond+loclon) = col_buf( icnt )
	      icnt = icnt + 1
	  enddo
      endif

      goto 100

 200  continue   ! end of main loop

#if 0
#ifdef PP_ERROR
      write(0,*)((ps(i,j,n3),i=1,plon),j=1,plat)
      write(0,*) d
      write(0,*) col_buf
#endif
      stop 29292
#endif
#ifdef PP_ERROR
      write(0,*)'finished with restart data'
#endif


      return
      end
