#include "params.h"
      subroutine splitg(hbuf,lhbuf)
C-----------------------------------------------------------------------
C
C Restore hbuf regeneration dataset
C
C---------------------------Code history--------------------------------
C
C Original version:  CCM2
C
C-----------------------------------------------------------------------
      implicit none
C#if ( defined RS6000 )
C      implicit automatic (a-z)
C#endif
C------------------------------Parameters-------------------------------
#include "pmgrid.com"
#include "pagrid.com"
C------------------------------Commons----------------------------------
#include "comctl.com"
C-----------------------------------------------------------------------
#include "comhst.com"
C-----------------------------------------------------------------------
#include "comhed.com"
C-----------------------------------------------------------------------
#include "comlun.com"
C-----------------------------------------------------------------------
#include "commss.com"
C-----------------------------------------------------------------------
#include "comslt.com"
C-----------------------------------------------------------------------
#include "comtim.com"
C-----------------------------------------------------------------------
#include "com3d.com"
C-----------------------------------------------------------------------
C
C Input arguments
C
      integer  lhbuf         ! Hbuf length: MUST be declared BEFORE coreiohst
      real     hbuf(lhbuf)
C
C---------------------------Local workspace-----------------------------
C
      integer lurd,         ! Logical unit to read
     $        nf,           ! File number
     $        j,k,kk,ii,jj, ! Indices
     $        lngth,        ! Length of record
     $        kflds,        ! local field index
     $        itape,        ! local tape index
     $        tape,         ! local tape index
     $        num,          ! local file index
     $        flds(ptapes)  ! local file index
C------------------------------Externals--------------------------------
C
      external resetr,      ! Set real array to specified value
     $         readarr,     ! Array read
     $         endrun       ! error, end run 
C
C-----------------------------------------------------------------------
C
C Get space for history buffer
C
C
C Read a latitude at a time across all the tapes and fill in the 
C appropriate parts of the history buffer. After a full latitude 
C is constructed from a number of tapes then write this latitude 
C to the history buffer.
C
      do j=1,plat
         do itape=1,mtapes
            if (nnrg3(itape).gt.0) then
C 
C Calculate the unit number which contains this latitude. The rg3lat
C variable contains the starting latitude for that unit number.
C
               nf=0
               do num=1,nnrg3(itape)
                  if (rg3lat(num,itape).le.j) nf=nf+1
               end do
C
C Read the unit numbers for this latitude into the correct area of 
C a one latitude buffer
C
               lurd = nrg3(nf,itape)
               lngth = rg3buf(itape)
               call readarr (lurd   ,hbuf ,lngth  )
               if (j.eq.plat)then
                  read(lurd) flds
                  kflds=0
                  do tape=1,mtapes
                     kflds=kflds+flds(tape)
                  end do
                  read (lurd) (mflds(1,kk),mflds(2,kk),
     $                 mflds(3,kk),kk=1,kflds)
                  read (lurd) (mcflds(1,k),mcflds(2,k),k=1,kflds)
                  read(lurd) ((nacs(ii,jj),ii=1,kflds),
     $                 jj=1,plat)
                  close (lurd)
               end if
            end if
         end do
C
C One latitude is complete, write it to the ssd.  Note: need not be done
C for INCORE case.
C
      end do
      return
      end


