#include "params.h"
      subroutine wrtharr(iu,hbuf,iln,lat,nlonh)
C--------------------------------------------------------------------
C
C Array write for output history tape
C
C--------------------------------------------------------------------
      implicit none
#  ifdef PP_PCCM
#    include "pmgrid.com"
#    include "pagrid.com"
#    include "pspect.com"
#    include "comctl.com"
#    include "comparll.com"
#  endif
C----------------------------arguments-------------------------------
      integer iu,        ! Logical unit for history tape
     $        iln        ! Length of history tape buffer
      real hbuf(iln)     ! History tape buffer
      integer lat        ! South-to-north latitude index
      integer nlonh      ! Number of longitudes in this latitude
      integer p_ghtbf
      parameter (p_ghtbf = phtbf*p_nproc_ln)
      real htape_buf(p_ghtbf)
      real hbuf2(phtbf),rdum
      integer  ip,i,ii
      integer len, globlat,node ,idum
      character*4 savetype
#ifdef PP_INTEL_PFS
      real xhtape_buf(p_ghtbf+2)
      equivalence (xhtape_buf(3),htape_buf(1))
#endif
c
      if ( lat .le. plat/2 ) then   ! southern latitude
        globlat = m_pin_lt * plat / 2 + lat
      else                                ! northern latitude
        globlat = p_glat-(m_pin_lt*plat/2)-(plat-lat)
      endif
      idum = iln 
      rdum = iln 
c      
      if (m_pin_ln .eq. 0 ) then
        do ii=0,iln/plon-1
          do i=1,plon
            htape_buf(i+ii*p_glon) = hbuf(i+ii*plon)
          enddo
        enddo
c
        do ip=1,p_nproc_ln-1
         node =	  mapmesh(ip,m_pin_lt)
         call swap(1, 0, 1, m_pin, m_type, node, R_SIZE, rdum, 
     &             iln*R_SIZE, hbuf2)
c--         call send0f(iln,I_SIZE,m_type,node)
c--          call recv0f(hbuf2,iln*R_SIZE,m_type)
          do ii=0,iln/plon-1
            do i=1,plon
              htape_buf(i+ii*p_glon+ip*plon) = hbuf2(i+ii*plon)
            enddo
          enddo
        enddo
      else
        call swap(1, 0, 0, m_pin, m_type, mapmesh(0,m_pin_lt),
     &            iln*R_SIZE, hbuf, R_SIZE, rdum)
c--        call recv0f(iln,I_SIZE,m_type)
c--        call send0f(hbuf,iln*R_SIZE,m_type,mapmesh(0,m_pin_lt)) 
      endif
c
      m_type = m_type + 1
      len = iln*p_nproc_ln
c   
c     First, node 0 writes his latitude record
c   
      if ((.not. parhist .and. (m_pin .eq. mapmesh(0,0))) .or.
     $    (parhist .and. (m_pin_ln .eq. 0))) then
#ifdef PP_INTEL_PFS
        xhtape_buf(1) =  float(globlat)
        xhtape_buf(2) = float(nlonh*p_nproc_ln)
        call cwrite(iu, xhtape_buf, R_SIZE*(len + 2))
#else
        write(iu) float(globlat),float(nlonh*p_nproc_ln),
     &                           (htape_buf(i),i=1,len)
#endif
      endif

c at this point, if we are not doing single writer, the routine
c is finished -- all the processors on the western edge have 
c written to their file.

c
c  Now node 0 writes all the other latitude records
c
      if ( .not. parhist ) then
        if (m_pin_ln .eq. 0 ) then
          if (m_pin .eq. mapmesh(0,0)) then
            do ip = 1,p_nproc_lt-1
              node=  mapmesh(0,ip)
c
c Save current data type
c
              call getdataf(savetype)
              call setdataf('integer')
              call swap(1, 0, 1, m_pin, m_type, node, I_SIZE,
     &                  idum, I_SIZE, globlat)
              call setdataf(savetype)
              call swap(1, 0, 1, m_pin, m_type+1, node, R_SIZE,
     &                  rdum, len*R_SIZE, htape_buf)
c--              call send0f(dum,I_SIZE,m_type,node)
c--              call recv0f(globlat,I_SIZE,m_type)
c--              call recv0f(htape_buf,len*R_SIZE,m_type+1)
              write(iu) float(globlat),float(nlonh*p_nproc_ln),
     &                           (htape_buf(i),i=1,len)
            enddo
          else
c--            call recv0f(dum,I_SIZE,m_type)
            node= mapmesh(0,0)
c
c Save current data type
c
            call getdataf(savetype)
            call setdataf('integer')
            call swap(1, 0, 0, m_pin, m_type, node, I_SIZE,
     &                globlat, I_SIZE, idum)
            call setdataf(savetype)
            call swap(1, 0, 0, m_pin, m_type+1, node, len*R_SIZE,
     &                htape_buf, R_SIZE, rdum)
c--            call send0f(globlat,I_SIZE,m_type,node)
c--            node=	 mapmesh(0,0)
c--            call send0f(htape_buf,len*R_SIZE,m_type+1,node)
          endif
        endif
        m_type = m_type + 2
      endif
      return
      end

