#include "params.h"
      subroutine wrthdr(ktape   ,kstep   ,mhflds  ,mchflds )
C-----------------------------------------------------------------------
C
C Update and write out the history tape header for CCM2.
C There are 4 time levels for updating header information:
C   1. beginning of case (initial run,now done in inthed)
C   2. beginning of job (now done in inthed)
C   3. beginning of new history volume
C   4. any time header is to be written
C
C---------------------------Code history--------------------------------
C
C Original version:  CCM1
C Standardized:      L. Bath, June 1992
C
C-----------------------------------------------------------------------
      implicit none
#if ( defined RS6000 )
c      implicit automatic (a-z)
#endif
C------------------------------Arguments--------------------------------
C
C Input arguments
C
      integer ktape,              ! History tape number
     $        kstep,              ! Current time step
     $        mhflds(3,*)         ! Ktape portion of mflds array
      character*8 mchflds(2,*)    ! Ktape portion of mcflds array
C
C------------------------------Parameters-------------------------------
#include "pmgrid.com"
#include "pagrid.com"
C------------------------------Commons----------------------------------
#include "comctl.com"
C-----------------------------------------------------------------------
#include "comhed.com"
C-----------------------------------------------------------------------
#include "comhdt.com"
C-----------------------------------------------------------------------
#include "comhst.com"
C-----------------------------------------------------------------------
#include "comtim.com"
C-----------------------------------------------------------------------
#include "comhyb.com"
C-----------------------------------------------------------------------
#ifdef PP_PCCM
#include "pspect.com"
#include "comparll.com"
#include "comglb.com"
      real xlat
# ifdef PP_INTEL_PFS
      integer nbytes1,nbytes2,nbytes3
      integer ihrec(plenhi)
      character*8 chrec(plenhc)
      real rhrec(plenhr)
# endif
      integer m_ghflds(pflds)
#endif
C---------------------------Local variables-----------------------------
C
      character*8 hdc(plenhcs)    ! Allows array write of character
      equivalence (hdc(1),mcase)  !                   header record
      integer klen,               ! Length of character string
     $        k, i, kk            ! Indices
      logical first(ptapes)       ! First time through for each tape
      character*80 blkfil         ! 80 blank spaces
      integer j
      real pie
C
C------------------------------Externals--------------------------------
C
      character*8 hchar, igtseq
      integer lenchr
      external hchar,         ! Convert Hollerith string to character
     $         caldyi,        ! Compute calendar day
     $         igtseq,        ! Get sequence number
     $         prnthd,        ! Print history tape header
     $         endrun,        ! Abnormal termination
     $         lenchr         ! Return actual length of character string
#if ( defined CRAY )
      real date, clock
#else
      character*8 date,clock
#endif
      external date, clock ! System time routines
C
C------------------------------Data-------------------------------------
C
      data first /ptapes*.true./
      save first


C
C-----------------------------------------------------------------------
C
#ifndef NOOUT
      do i=1,80
         blkfil(i:i) = ' '
      end do
C
C Variables for the first header on a new volume
C
      mpflds = 38
      lenhdr = plenhr
      mpsig  = 1
      mplat  = 3*(2*plev+1) + 1
      mpwts  = mplat + p_glat

      mfilth = mfilt(ktape)
      nfldh  = nflds(ktape)
      lenhdi(1) = plenhis + 3*nfldh
      lenhdc = plenhcs + 2*nfldh
      mhisf  = nhtfrq(ktape)
      klen   = lenchr(nfpath(ktape))
      lnhstf = nfpath(ktape)(1:klen)//blkfil(klen+1:80)
      lnhstc = cpath(ktape)
C
C These variables changed for each header
C
      mfilh = nfils(ktape) + 1     ! nfils not set until file is written
C
C Include latitude index and longitude count in record length
C
      ndavu = nrlen(ktape) + 2
      maxsiz = nplen(ktape) + 2
      nitslf = kstep-1-nstepht(ktape)
      nsteph = kstep - 1
      nstepht(ktape) = nsteph
C
C Set header current time variables for kstep-1
C
      if(anncyc) then
         call caldyi(kstep-1 ,dtime   ,mdbase  ,msbase  ,mbdate  ,
     $               mbsec   ,ndcur   ,nscur   ,ncdate  ,ncsec   ,
     $               calday  )
      else
C
C Perpetual: Current date,day = base date,day
C
        call caldyi(0       ,dtime   ,mdbase  ,msbase  ,mbdate  ,
     $              mbsec   ,ndcur   ,nscur   ,ncdate  ,ncsec   ,
     $              calday  )
      end if
C
C Save date and day info from first header
C on volume for mss comment field. Mnthly average info already saved in
C wrapup.
C
      if (nfils(ktape).eq.0) then
         if (ninavg(ktape).ne.'Q'.or.nstep.le.1) then
            ndcurf(ktape) = ndcur
            nscurf(ktape) = nscur
            ncdatf(ktape) = ncdate
            ncsecf(ktape) = ncsec
         end if 
      end if
#ifdef CRAY
      ldhstc = hchar(date())
      lthstc = hchar(clock())
#else
      ldhstc = date()
      lthstc = clock()
#endif
      lshstc = igtseq()
C
C Write out header
C
# ifdef PP_PCCM
      if (m_pin .eq. mapmesh(0,0) ) then
        lenhdi( 6) = (lenhdi( 6)-2) * p_nproc_ln + 2
        lenhdi( 7) = (lenhdi( 7)-2) * p_nproc_ln + 2
        lenhdi( 9) = lenhdi( 9) * p_nproc_ln
        lenhdi(10) = lenhdi(10) * p_nproc_ln
        lenhdi(11) = lenhdi(11) * p_nproc_lt
        pie = 4.*atan(1.)
        do j=1,p_glat/2
           xlat = asin(g_zsi(j))
           hdlat(j) = (180./pie)*(-xlat)
           hdlat(p_glat - j + 1) = (180./pie)*xlat
        enddo
        do j=1,p_glat
          hdwt(j) = g_zw(j)
        enddo
c computation of global field sizes from local sizes, jm 7/12/93
        do kk = 1, pflds
            m_ghflds( kk ) = (mhflds(2,kk) - 3) * p_nproc_ln + 3
        enddo
#  ifdef PP_INTEL_PFS
c
c   Pack the header record buffer ihrec with the integer arrays
c
        kk = 1
        do k = 1,37
          ihrec(kk) = lenhdi(k)
          kk = kk + 1
          enddo
        do k=1,nfldh
          ihrec(kk) = mhflds(1,k)
          ihrec(kk+1) = m_ghflds(k)
          ihrec(kk+2) = mhflds(3,k)
          kk = kk + 3
          enddo
        nbytes1 = 4*lenhdi(1)
        call cwrite(hunit(ktape),ihrec,nbytes1)
c
c    Pack the chrec character*8 array
c
        kk = 1
        do k = 1,89
          chrec(kk) = hdc(k)
          kk = kk + 1
          enddo
        do k = 1,nfldh
          chrec(kk) = mchflds(1,k)
          chrec(kk+1) = mchflds(2,k)
          kk = kk + 2
          enddo
        nbytes2 = 8*lenhdc
        call cwrite(hunit(ktape),chrec,nbytes2)
c
c    Pack the real header record rhrec
c
        kk = 1
        do k = 1,2*plev+1
          rhrec(kk) = sigapb(k)
          kk = kk + 1
          enddo
        do k = 1,2*plev+1
          rhrec(kk) = siga(k)
          kk = kk + 1
          enddo
        do k = 1,2*plev+1
          rhrec(kk) = sigb(k)
          kk = kk + 1
          enddo
        do k = 1,p_glat
          rhrec(kk) = hdlat(k)
          kk = kk + 1
          enddo
        do k = 1,p_glat
          rhrec(kk) = hdwt(k)
          kk = kk + 1
          enddo
        nbytes3 = R_SIZE*plenhr
        call cwrite(hunit(ktape),rhrec,nbytes3)
      end if
#  else
C  ..Parallel non-PFS write from node zero
C
        write (hunit(ktape)) (lenhdi(k),k=1,plenhis),
     $                     (mhflds(1,kk),
     $                      m_ghflds(kk),
     $                      mhflds(3,kk),kk=1,nfldh)
        write (hunit(ktape)) hdc,(mchflds(1,k),mchflds(2,k),k=1,nfldh)
        write (hunit(ktape)) sigapb,siga,sigb,hdlat,hdwt
        lenhdi( 6) = (lenhdi( 6)-2) / p_nproc_ln + 2
        lenhdi( 7) = (lenhdi( 7)-2) / p_nproc_ln + 2
        lenhdi( 9) = lenhdi( 9) / p_nproc_ln
        lenhdi(10) = lenhdi(10) / p_nproc_ln
        lenhdi(11) = lenhdi(11) / p_nproc_lt
        call prnthd(ktape   ,plenhi  ,plenhc  ,plenhr  ,lenhdi,
     $            hdc ,sigapb  ,mhflds  ,mchflds ,first(ktape)  )
      end if
#  endif
# else
C  ..Sequential version write
C
      write (hunit(ktape)) (lenhdi(k),k=1,plenhis),
     $                     (mhflds(1,kk),mhflds(2,kk),
     $                                   mhflds(3,kk),kk=1,nfldh)
      write (hunit(ktape)) hdc,(mchflds(1,k),mchflds(2,k),k=1,nfldh)
      write (hunit(ktape)) sigapb,siga,sigb,hdlat,hdwt
      call prnthd(ktape   ,plenhi  ,plenhc  ,plenhr  ,lenhdi        ,
     $            hdc     ,sigapb  ,mhflds  ,mchflds ,first(ktape)  )
      first(ktape) = .false.
# endif
C
#endif
      return
      end





