#include "params.h"
      subroutine wrtrs1
C-----------------------------------------------------------------------
C
C Write some restart data at appropriate times
C
C-----------------------------------------------------------------------
c inserted by implnone
      implicit none
#include "pmgrid.com"
#include "pagrid.com"
#include "pspect.com"
#include "comparll.com"
C-----------------------------------------------------------------------
#include "comhst.com"
C-----------------------------------------------------------------------
#include "comlun.com"
C-----------------------------------------------------------------------
#include "commss.com"
C-----------------------------------------------------------------------
#include "comslt.com"
C-----------------------------------------------------------------------
#include "comtim.com"
C-----------------------------------------------------------------------
#include "com3d.com"
C-----------------------------------------------------------------------
#include "comctl.com"
#include "abemub.com"
#include "incore.com"
#include "restart_fil.com"
#include "restart_buf.com"

C----------------------------Local storage------------------------------
      integer
     $    nf,                   ! File number 
     $    m_pin1,               ! Processor id
     $    daynum,               ! Date of month
     $    ntspdy,               ! Number of timesteps per day
     $    kfilno,               ! Decode regen file number
     $    b1, b2, b3,           ! cursors into y buffer
     $    j, jj, ih,            ! Indices
     $    lngth,                ! Length of buffer
     $    m,                    ! Index over constituent
     $    column_len		! for packing in k-columns
      double precision
     $    tstart,		! timer variables
     $    tstart1,
     $    tstart2,
     $    tstop,
     $    tstop1,
     $    tstop2,
     $    tstart3,
     $    tstop3,
     $    tstart_copy,
     $    tstop_copy
                                                                        !
      character*1   tem         ! Temporary for testing nrefrq          !
      character*5   bbd         ! Temp for building file number         !
C---------------------------Externals-----------------------------------
      logical whenwr
      external whenwr
      logical lenchr
      external lenchr
      double precision clock0f
      external clock0f
C---------------------------Save Declarations---------------------------
      logical first
      data first /.true./
      save first
      save tstart, tstart2, tstop, tstop2, tstart3, tstop3
C-----------------------------------------------------------------------
C

#ifdef PP_NORESTART
      return
#endif

C
C Determine if it is time to write restart files
C 1. time to stop model or
C 2. time to dispose first history tape
C
      lrewrt = .false.
      if (nlend) then                              ! end of run
         lrewrt = .true.
      else if (ninavg(1).eq.'Q') then              ! monthly average
             ntspdy = nint(86400./dtime)
             daynum=mod(mcdate,100)
             if (daynum.ne.1) then
               daynum=daynum-1
               if(mod(daynum,mresfq).eq.0 .and.
     $            mod(nstep-1,ntspdy).eq.0 .and.
     $            nstep-1.gt.nrstrt) lrewrt = .true.     ! every nrefrq days
             end if
             if (whenwr(nstep,1).and.nstep.gt.1) lrewrt =.true.
      else if (whenwr(nstep,1)) then               ! dispose 1st ht
             if (nfils(1)+1 .ge. mfilt(1)) then
                read(nhfil(1),'(a1,i4)')tem,kfilno
                if (mod(kfilno,nrefrq).eq.0) lrewrt = .true.
             end if
      end if

C
C Finished unless it is time to write restart files
C
      if (.not.lrewrt) return
C
C Write nra1 and nrb1 to restart file.
C Write slt data to restart file.
C

      nsect = 1
      column_len = rstrt_sz_hdr + rstrt_sz_nrx
      if (aeres) then
         column_len = column_len + rstrt_sz_hdr + rstrt_sz_ems
         nsect = nsect + 1
      endif
      if (doslt) then
         column_len = column_len + rstrt_sz_hdr + rstrt_sz_slt
         nsect = nsect + 1
      endif

      call pck_rstrt_init( nsect, column_len )

c section 1 of restart data set
      call pck_rstrt_sect( 1,rstrt_sz_nrx )

      tstart_copy = clock0f()

      do j = 1, plat
         b1= incore_b+(j-1)*pflenb
         lngth = pbflnb+pbflna
         call pck_rstrt_buf(j, y(b1), lngth/plond, plond-plon )
      enddo
      do j = 1, plat
         b2= incore_a+(j-1)*pflena
         lngth = pbflna
         call pck_rstrt_buf(j, y(b2), lngth/plond, plond-plon )
      enddo
      do j = 1, plat
         if ( j .le.plat/2 ) then
            ih = 1
            jj = j
         else
            ih = 2
            jj = j - plat/2
         endif
         lngth = plond*plev*(3+pcnst)
         call pck_rstrt_buf(j, x(i1,1,1,j1m+jj,ih,n3),
     $                      lngth/plond, plond-plon )
      enddo
      do j = 1, plat
         if ( j .le.plat/2 ) then
            ih = 1
            jj = j
         else
            ih = 2
            jj = j - plat/2
         endif
         lngth = plond*plev*(3+pcnst)
         call pck_rstrt_buf(j, x(i1,1,1,j1m+jj,ih,n3m1),
     $                      lngth/plond, plond-plon )
      enddo
      do j = 1, plat
         call pck_rstrt_buf(j, lammp(1,1,j), plev, 0 )
      enddo
      do j = 1, plat
         call pck_rstrt_buf(j, phimp(1,1,j), plev, 0 )
      enddo
      do j = 1, plat
         call pck_rstrt_buf(j, sigmp(1,1,j), plev, 0 )
      enddo
      do m = 1, pcnst
          do j = 1,plat
             if (j.le.plat/2) then
                ih = 1
                jj = j
             else
                ih = 2
                jj = j - plat/2
             endif
             call pck_rstrt_buf(j, hqfcst(1,1,m,j),
     $            plndlv/plond, plond-plon )
             call pck_rstrt_buf(j, qfcst(i1,1,m,j1m+jj,ih),
     $            plndlv/plond, plond-plon )
          enddo
      enddo
      do j = 1, plat
         call pck_rstrt_buf(j, ps(1,j,n3), 1, plond-plon )
      enddo
      do j = 1, plat
         call pck_rstrt_buf(j, ps(1,j,n3m1), 1, plond-plon )
      enddo
      if(doslt) then
          call pck_rstrt_sect(2,rstrt_sz_slt)
          do m = 1, pcnst
              do j = 1, plat
                  call pck_rstrt_rep(j,hw1(m))
                  call pck_rstrt_rep(j,hw2(m))
                  call pck_rstrt_rep(j,hw3(m))
                  call pck_rstrt_rep(j,alpha(m))
              enddo
          enddo 
      endif
#if 0
      if (aeres) then
          call pck_rstrt_sect(3,rstrt_sz_ems)
          do j = 1, plat
             b3= incore_ems+(j-1)*plngbuf
             call pck_rstrt_buf(j, y(b3), plngbuf/plond, plond-plon )
          enddo
      endif
#endif

      tstop_copy = clock0f()

c asynchronous write

      tstart1 = clock0f()
      m_pin1 =m_pin

      if(ninavg(1).eq.'Q') then
        call bldfln(nrfil)
      else
        read(nrfil,'(a1,i4)')tem,kfilno
        if(accrst) then            ! accumulate restarts (don-t toggle)
           kfilno=kfilno+1
        else
           kfilno=mod(kfilno+1,2)  ! toggle restarts
        endif
        write(bbd,'(i5)')kfilno+10000
        nrfil=tem//bbd(2:5)
      endif

      call restart_wopen( fid1, nrfil, lenchr(nrfil) ,m_pin1, p_nproc )
      tstop1  = clock0f()

      tstart2 = tstop1
      if ( desc .ne. -1 ) call iwrtend( desc )
      tstop2  = clock0f()

      call restart_wclose( fid2 )
      tstop3  = clock0f()


      tstart = clock0f()
      call write_restart( fid1, rstrt_buf, 
     $                    column_len*plon*plat*R_SIZE, desc )
      tstop  = clock0f()
#ifdef PP_ERROR
      write(0,1213)tstop1-tstart1,
     $             tstop3-tstop2,
     $             tstop2-tstart2,
     $             tstop-tstart
 1213 format('Restart write summary: open ',f10.0,/
     $       '                        cls ',f10.0,/
     $       '                       wait ',f10.0,/
     $       '                       awrt ',f10.0)
#endif

      fid2 = fid1

      return
      end

