#include "params.h"
      subroutine colsum0(vec, tmp, idim, mmtype)
      implicit none
c-----------------------------------------------------------------------------
c  Sums the vector of processors in the column of the processor mesh
#include "palgor.com"
#include "pmgrid.com"
#include "pagrid.com"
#include "pspect.com"
#include "comparll.com"
c-----------------------------------------------------------------------------
c
c     !  input parameters
c
      integer idim, mmtype
      real vec(idim), tmp(idim)
c
c     ! local storage
c
      integer base, base2
c
      if (p_nproc_lt .gt. 1) then
c
c       ! update message tags
c
        base   = mmtype
        base2  = mmtype + p_nproc
c
c       ! compute global vector sum
c
        if ((p_sumopt .le. 13) .and. (p_sumopt .ge. 10)) then
          call ringsum(p_sumopt-10, p_sumprot, p_nproc_lt, m_pin,
     &                 m_pin_dwn, m_pin_up, m_pin_lt, base, base2, 
     &                 idim, tmp, vec)
        elseif ((p_sumopt .eq. 20) .or. (p_sumopt .eq. 21)) then
          call halfsum(p_sumopt-20, p_sumbufs, p_sumprot, p_nproc_lt, 
     &                 mapcol, m_pin_lt, base, base2, p_exchsz, idim, 
     &                 tmp, vec)
        else
C         illegal communication option specified
          write(0,100) m_pin_lt, p_sumopt
  100     format (/,' fatal error in subroutine colsum0 ',/,
     &              ' illegal parallel algorithm specified ',/,
     &              ' procid = ',I4,' p_sumopt = ',I4)
          stop
C
        endif
c
      endif
c
      return
      end

      subroutine rowsum0(vec, tmp, idim, mmtype)
      implicit none
c-----------------------------------------------------------------------------
c  Sums the vector of processors in the row of the processor mesh
#include "palgor.com"
#include "pmgrid.com"
#include "pagrid.com"
#include "pspect.com"
#include "comparll.com"
c-----------------------------------------------------------------------------
c
c     !  input parameters
c
      integer idim, mmtype
      real vec(idim), tmp(idim)
c
c     ! local storage
c
      integer base, base2
c
      if (p_nproc_ln .gt. 1) then
c
c       ! update message tags
c
        base   = mmtype
        base2  = mmtype + p_nproc
c
c       ! compute global vector sum
c
        if ((p_sumopt .le. 13) .and. (p_sumopt .ge. 10)) then
          call ringsum(p_sumopt-10, p_sumprot, p_nproc_ln, m_pin,
     &                 m_pin_lft, m_pin_rht, m_pin_ln, base, base2, 
     &                 idim, tmp, vec)
        elseif ((p_sumopt .eq. 20) .or. (p_sumopt .eq. 21)) then
          call halfsum(p_sumopt-20, p_sumbufs, p_sumprot, p_nproc_ln, 
     &                 maprow, m_pin_ln, base, base2, p_exchsz, idim, 
     &                 tmp, vec)
        else
C         illegal communication option specified
          write(0,100) m_pin_ln, p_sumopt
  100     format (/,' fatal error in subroutine rowsum0 ',/,
     &              ' illegal parallel algorithm specified ',/,
     &              ' procid = ',I4,' p_sumopt = ',I4)
          stop
C
        endif
c
      endif
c
      return
      end


