#include "params.h"
      subroutine virtem(t       ,q       ,zvir    ,tv      )
C-----------------------------------------------------------------------
C
C Compute the virtual temperature.
C
C---------------------------Code history--------------------------------
C
C Original version:  B. Boville
C Standardized:      J. Rosinski, June 1992
C Reviewed:          D. Williamson, J. Hack, August 1992
C
C-----------------------------------------------------------------------
      implicit none
C------------------------------Parameters-------------------------------
#include "pmgrid.com"
C------------------------------Arguments--------------------------------
C
C Input arguments
C
      real t(plond,plev),      ! temperature
     $     q(plond,plev),      ! specific humidity
     $     zvir                ! virtual temperature constant
C
C Output arguments
C
      real tv(plond,plev)      ! virtual temperature
C
C---------------------------Local storage-------------------------------
C
      integer
     $     i, k                ! longitude and level indexes
C
C-----------------------------------------------------------------------
C
      do k=1,plev
         do i=1,plon
            tv(i,k) = t(i,k)*(1.0 + zvir*q(i,k))
         end do
      end do
C
      return
      end
