#include "params.h"
      subroutine bandij(dlam,phib,lamp,phip,iband,jband,nxpt_a)
c
      implicit none
#include "pmgrid.com"
#include "parslt.com"
#ifdef PP_PCCM
#include "pspect.com"
#include "comparll.com"
      integer ngls,jxdm,istart, j
      parameter( ngls= plon*plev, jxdm= 2*jintmx + p_lato2 + 2*nxpt,
     *           istart= nxpt+1 )
      integer ibdm
      parameter (ibdm =  plon + 1 + 2*nxpt)
      integer nxpt_a(plev), k
#else
      integer ngls,jxdm,istart
      parameter( ngls= plon*plev, jxdm= 2*jintmx + plat + 2*nxpt,
     *           istart= nxpt+1 )
#endif
      integer iband(ngls),jband(ngls)
      real dlam, phib(jxdm), lamp(ngls), phip(ngls)
c
c
c...All points should be within jintmx intervals of the latitude being
c   forecasted upon entry.  Calculate longitude and
c   latitude indicies that identify the "cells" in the extended grid tha
c   contain the points.
c
c...On entry.
c
c  dlam    Length of increment in equally spaced longitude grid (radians
c  phib    Latitude values for the extended grid.
c  lamp    Longitude coordinates of the points.  It is assumed that
c                     0.0 .le. lamp(i) .lt. 2*pi .
c  phip    Latitude coordinates of the points.
c
c...On return.
c
c  iband   Longitude index of the points.  This index points into
c          the extended arrays, e.g.,
c                   lam(iband) .le. lamp .lt. lam(iband+1) .
c  jband   Latitude index of the points.  This index points into
c          the extended arrays, e.g.,
c                   phib(jband) .le. phip .lt. phib(jband+1) .
c
c...Parameters required.
c
c  plon    Number of longitudes in global grid.
c  plev    Number of levels in global grid.
c  jintmx  A departure point must lie within jintmx latitude intervals
c          from the latitude of the extended array being forecasted.
c  ngls    Number of points in latitude slice in global grid.
c  jxdm    Number of latitudes in extended array.
c  istart  Longitude index in extended grid of point corresponding to
c          lambda=0.
c

      integer i
      real dphibr,phibs
      real cvmgp
#ifdef PP_PCCM
c
      dphibr = 1./( phib(jxdm/2+1) - phib(jxdm/2) )
      phibs  = phib(1)
c
c     ...Longitude indices.
c
      do 10  i=1,ngls
         iband(i) = istart + int( lamp(i)/dlam ) - m_pin_ln*plon
         if ( lamp(i) .lt. 0 ) then
             iband(i) = iband(i) - 1
         endif
c         if(iband(i).lt.1 .or. iband(i).ge.ibdm) then
c
c  For dynamic sltpads need to check the level max
c
	 k = (i-1)/plon + 1
         if(iband(i).lt.istart-nxpt_a(k) 
     &        .or. iband(i).ge.plon+1+nxpt+nxpt_a(k)) then
           write(6,*)'**Error in bandij.  Point out of bounds in E-W',
     &    m_pin_ln,m_pin_lt,iband(i)
           write(0,*)'**Error in bandij.  Point out of bounds in E-W',
     &    m_pin_ln,m_pin_lt,iband(i)
           call abortf('bandij') 
           endif
   10 continue
#else
c
      dphibr = 1./( phib(jxdm/2+1) - phib(jxdm/2) )
      phibs  = phib(1)
c
c     ...Longitude indices.
c
      do 10  i=1,ngls
         iband(i) = istart + int( lamp(i)/dlam )
   10 continue
#endif
c
c     ...Latitude indices.
c
#ifdef PP_PCCM
      do 20 i     = 1,ngls

	do 15 j = 1,jxdm-1
	  if(phib(j).le.phip(i) .and. phip(i).lt.phib(j+1)) then
	    jband(i)=j
	    go to 16		! break out of 15 loop
            endif
15	continue
16      continue 		! break out of 15 loop  goes here

        if( phip(i) .ge. phib(jband(i)+1) ) jband(i) = jband(i) + 1
        if(jband(i).lt.1 .or. jband(i).gt.jxdm) then
           write(0,*)'**Error in bandij.  Point out of bounds in N-S',
     &    m_pin_ln,m_pin_lt,jband(i)
           write(6,*)'**Error in bandij.  Point out of bounds in N-S',
     &    m_pin_ln,m_pin_lt,jband(i)
           call abortf('bandij') 
        endif
   20 continue
#else
      do 20 i     = 1,ngls
        jband(i) = int ( (phip(i) - phibs)*dphibr + 1. )
#  ifdef CRAY
         jband(i) = cvmgp(jband(i)+1,jband(i),phip(i)-phib(jband(i)+1))
#  else
         if( phip(i) .ge. phib(jband(i)+1) ) jband(i) = jband(i) + 1
#  endif
   20 continue
#endif

c
      return
      end


