#include "params.h"
      subroutine basdy(phi,lbasdy)
c
      implicit none
#include "pmgrid.com"
#include "parslt.com"
      integer jxdm,jfirst,jlast
#ifdef PP_PCCM
      parameter( jxdm= p_lato2 + 2*jintmx + 2*nxpt,
     *           jfirst= 2, jlast= jxdm - 2 )
c
c NOTE: for parallel code nxpt and jintmx have been redefined.  nxpt specifies
c the size of the extension of the grid in both lat and lon when jintmx = 0.
c This requires a reinialization of jfirst and jlast.  We assume that the
c interpolant requires only one extra point (the old nxpt) so that jfirst
c is 2.
cccccccc
#else
      parameter( jxdm= plat + 2*jintmx + 2*nxpt,
     *           jfirst= nxpt + 1, jlast= jxdm - nxpt - 1 )
#endif
c
      real phi(jxdm),lbasdy(4,2,jxdm)
c
c...Compute coefficients for the calculation of Lagrangian derivative
c   estimates at two center points of the four point stencil for each
c   interval in the unequally spaced latitude grid.
c
c...On entry.
c
c  phi     Latitude values in the extended grid.
c
c...On return.
c
c  lbasdy  Weights for Lagrange cubic derivative estimates on the
c          unequally spaced latitude grid.  If grid interval j (in
c          extended grid) is surrounded by a 4 point stencil, then
c          the derivative at the "bottom" of the interval uses the
c          weights lbasdy(1,1,j),lbasdy(2,1,j), lbasdy(3,1,j), and
c          lbasdy(4,1,j).  The derivative at the "top" of the interval
c          uses lbasdy(1,2,j), lbasdy(2,2,j), lbasdy(3,2,j),
c          and lbasdy(4,2,j).
c
c...Parameters.
c
c  plat    Number of latitudes in global grid.
c  jintmx  A departure point must lie within jintmx latitude intervals
c          from the center latitude of the band.
c  nxpt    Number of points beyond the horizontal grid boundary needed
c          to make a derivative estimate for an interval adjacent to the
c          grid boundary.
c  jxdm    Number of latitudes in extended grid.
c  jfirst  Latitude index in extended grid corresponding to the first
c          (southernmost) interval for which derivatives may be computed
c          at the endpoints.
c  jlast   Latitude index in extended grid corresponding to the last
c          (northernmost) interval for which derivatives may be computed
c          at the endpoints.
c
c
      integer jj
      external lcdbas
c
      do 10  jj=jfirst,jlast
         call lcdbas( phi(jj-1), lbasdy(1,1,jj), lbasdy(1,2,jj) )
 10   continue
c
      return
      end
