#include "params.h"
      subroutine basiy( phi, lbasiy )
c
      implicit none
c
c-----------------------------------------------------------------------
c
c...Compute coefficients for the calculation of Lagrangian cubic interp
c   at the second node of a four point stencil.  Done for each interval
c   in the unequally spaced latitude grid.
c
c------------------------------- parameters ----------------------------
#include "pmgrid.com"
c------------------------------ local parameters -----------------------
      integer
     $      jfirst              ! index of first latitude interval
     $     ,jlast               ! index of last  latitude interval
#ifdef PP_PCCM
      parameter(
     $      jfirst= 2 
     $     ,jlast= platd - 2 )
#else
      parameter(
     $      jfirst= nxpt + 1
     $     ,jlast= platd - nxpt - 1 )
#endif
c----------------------------- Input parameters ------------------------
c
c  ...On input
c
      real phi(platd)           ! grid values in extended grid
c
c  ...On output
c
      real lbasiy(4,2,platd)    ! Weights for Lagrange cubic interp
c
c-----------------------------------------------------------------------
c
      integer jj
      external lcbas
c
      do 10  jj=jfirst,jlast
         call lcbas( phi(jj-1),
     $               lbasiy(1,1,jj),
     $               lbasiy(1,2,jj) )
 10   continue
c
      return
      end
