#include "params.h"
      subroutine extys(kbdm,fb)
c
      implicit none
#include "pmgrid.com"
#include "parslt.com"
      integer ibdm,jxdm,plon2,istart,istop,js,jn
#ifdef PP_PCCM
#include "pspect.com"
#include "comparll.com"
#include "palgor.com"
      parameter( ibdm= plon + 1 + 2*nxpt,
     *           jxdm= p_lato2 +  2*nxpt + 2*jintmx,
     *           js  = 1    + nxpt + jintmx,
     *           jn  = p_lato2 + nxpt + jintmx,
     *           istart= nxpt+1, istop= nxpt+plon, plon2 = plon/2  )
      integer kbdm, order
      real fb(ibdm,kbdm*(3+pcnst),jxdm,2)
#else
      parameter( ibdm= plon + 1 + 2*nxpt,
     *           jxdm= plat +     2*nxpt + 2*jintmx,
     *           js  = 1    + nxpt + jintmx,
     *           jn  = plat + nxpt + jintmx,
     *           istart= nxpt+1, istop= nxpt+plon, plon2 = plon/2  )
      integer kbdm
      real fb(ibdm,kbdm*(3+pcnst),jxdm)
#endif
c
c
c.... Fill latitude extensions of a scalar extended array.
c     This is done in 2 steps:
c
c   1) interpolate to the pole points;
c     a) Lagrangian cubic interpolation of the mean field value on the
c        two Gaussian latitudes closest to the pole (DISABLED), or
c     b) use the mean field value on the Gaussian latitude closest to
c        the pole.
c   2) add latitude lines beyond the poles,
c
c...On entry.
c
c  kbdm    Vertical dimension
c  fb      Extended data array with only the interior filled
c
c...On return.
c
c  fb      As on entry except with the pole latitude and extensions
c          beyond it filled.
c
c...Parameters required.
c
c  plon    Number of longitudes in global grid.
c  pole    Method for interpolating grid data to the pole.
c  ibdm    Number of longitudes in extended array.
c  jxdm    Number of latitudes in  extended array.
c  istart  Longitude index of point corresponding to lambda=0 in extende
c          array.
c  istop   Longitude index of point corresponding to lambda=2*pi-dlam
c          in extended array.
c  plon2   plon/2
c  js      Latitude index pointing into the extended array corresponding
c          to the southern-most latitude in the global grid.
c  jn      Latitude index pointing into the extended array corresponding
c          to the northern-most latitude in the global grid.
c
      integer i,j,k,lm_type
      real grd(4),lcpole(4),zave(4),zpole
      logical first
#ifdef PP_PCCM
c   For communication across the pole
      integer jbmx,jbmx1
      parameter (jbmx = nxpt + jintmx, jbmx1=jbmx+1)
      real fbuf1(plon,plev,jbmx,2),fbuf2(plon,plev,jbmx,2),
     &     ztmp(2,plev,2),zbuf(2,plev,2)
      real repro_tmp(plon)
      real f_locsum
      integer len,ii,jj,node
#endif
c
      save first, lcpole
c
      data first/ .true. /
c
#ifdef PP_PCCM
c
c     ... Is this a pole processor?
c
      if ( m_pin_lt.ne.0) return
c     ...Compute Lagrangian cubic basis functions evaluated at the
c        poles.
c
      if( first )then
c
         if(pole .eq. 'ave' ) then
            lcpole(1) = 0.0
            lcpole(2) = 0.5
            lcpole(3) = 0.5
            lcpole(4) = 0.0
c
         endif
         first = .false.
      endif
c
c        ...Fill north pole line.
c
         do 50       k = 1,kbdm
c
            zpole      = 0.0
            do 10    i = 1,4
               zave(i) = 0.0
   10       continue
c
c   Accumulate the local sum
c
            zave(1) = f_locsum(fb(istart,k,jn-1,2),plon,repro_tmp)
            zave(2) = f_locsum(fb(istart,k,jn,2),plon,repro_tmp)
c
            zbuf(1,k,2)  = zave(1)
            zbuf(2,k,2)  = zave(2)
c
   50    continue
c
c     ...Fill south pole line.
c
         do 150      k = 1,kbdm
c
            zpole      = 0.0
            do 110   i = 1,4
               zave(i) = 0.0
  110       continue
c
c  Accumulate the local sums
c
	    zave(1) = f_locsum(fb(istart,k,js+1,1),plon,repro_tmp)
	    zave(2) = f_locsum(fb(istart,k,js,1),plon,repro_tmp)
c
            zbuf(1,k,1) = zave(1)
            zbuf(2,k,1) = zave(2)
c
  150    continue
c
c
c  Add contribution of the pole processors
c
            if(p_nproc_ln.gt.1) then
               lm_type = 330 + p_nproc
               call rowsum0(zbuf,ztmp,4*kbdm,lm_type)
            endif
         do 51       k = 1,kbdm
c
            zave(1) = zbuf(1,k,2)
            zave(2) = zbuf(2,k,2)
c
            zpole      = 0.0
            zave(1)    = zave(1)/float(p_glon)
            zave(2)    = zave(2)/float(p_glon)
            zave(3)    = zave(2)
            zave(4)    = zave(1)
c
            do 30  i   = 1,4
               zpole   = zpole + zave(i)*lcpole(i)
   30       continue
cdebug
c	 write(0,*) 'zpole -north',zpole
c
            do 40         i = istart,istop
               fb(i,k,jn+1,2) = zpole
   40       continue
c
   51    continue
         do 151      k = 1,kbdm
c
            zave(1) =zbuf(1,k,1)
            zave(2) =zbuf(2,k,1)
c
            zpole      = 0.0
            zave(1)    = zave(1)/float(p_glon)
            zave(2)    = zave(2)/float(p_glon)
            zave(3)    = zave(2)
            zave(4)    = zave(1)
c
            do 130   i = 1,4
               zpole   = zpole + zave(i)*lcpole(i)
  130       continue
cdebug
c	 write(0,*) 'zpole -south',zpole
c
            do 140        i = istart,istop
               fb(i,k,js-1,1) = zpole
  140       continue
c
  151    continue
c
c        ...Fill northern and southern lines beyond pole line.
c
         if( jn+2 .le. jxdm )then
	  if ( p_nproc_ln.eq.1) then
            do 62                  j = jn+2,jxdm
               do 61               k = 1,kbdm
cdir$ ivdep
                  do 60            i = istart,istart+plon2-1
                     fb(      i,k,j,2) = fb(plon2+i,k,2*jn+2-j,2)
                     fb(plon2+i,k,j,2) = fb(      i,k,2*jn+2-j,2)
   60             continue
   61          continue
   62       continue
            do 162                 j = 1,js-2
               do 161              k = 1,kbdm
cdir$ ivdep
                  do 160           i = istart,istart+plon2-1
                     fb(      i,k,j,1) = fb(plon2+i,k,2*js-2-j,1)
                     fb(plon2+i,k,j,1) = fb(      i,k,2*js-2-j,1)
  160             continue
  161          continue
  162       continue
	  else
c
c  Case: more than one pole processor:
c  Send required latitudes across the pole to opposite
c  processor.
c
c  Assume a mesh connect with the zero (myplat) holding poles
           node = mapmesh(mod(m_pin_ln + p_nproc_ln/2, p_nproc_ln),0)
           lm_type = 321
           if (m_pin .le. node) then
             order = 1
           else
             order = 2
           endif
           len = R_SIZE*plon*kbdm*jbmx *2
           call swap1(p_sltswopt, p_sltswprot, .true., order, m_pin, 
     &                lm_type, node, len, fbuf2)
            jj = 0
            do 67                  j = jn+2,jxdm
               jj = jj + 1
               do 66               k = 1,kbdm
cdir$ ivdep
                  do 65            i = 1,plon
                     ii = istart +i -1
                     fbuf1(   i,k,jj,2) = fb(ii,k,2*jn+2-j,2)
   65             continue
   66          continue
   67       continue
           jj = 0
           do 267                 j = 1,js-2
             jj = jj + 1
             do 266              k = 1,kbdm
cdir$ ivdep
               do 265           i = 1,plon
                 ii = istart +i -1
                 fbuf1( i,k,jj,1) = fb(ii,k,2*js-2-j,1)
  265          continue
  266        continue
  267      continue
           call swap2(p_sltswopt, p_sltswprot, .true., order, m_pin, 
     &                lm_type, node, len, fbuf1, len, fbuf2)
           call swap3(p_sltswopt, p_sltswprot, m_pin, 
     &                lm_type, node, len, fbuf2)
            jj = 0
            do 167                  j = jn+2,jxdm
               jj = jj + 1
               do 166               k = 1,kbdm
cdir$ ivdep
                  do 165            i = 1,plon
                     ii = istart +i -1
                     fb(     ii,k,j,2) = fbuf2(i,k,jj,2)
  165             continue
  166          continue
  167       continue
            jj = 0
            do 367                 j = 1,js-2
               jj = jj + 1
               do 366              k = 1,kbdm
cdir$ ivdep
                  do 365           i = 1,plon
                     ii = istart +i -1
                     fb(     ii,k,j,1) = fbuf2(i,k,jj,1)
  365             continue
  366          continue
  367       continue
c
           endif
#else
c     ...Compute Lagrangian cubic basis functions evaluated at the
c        poles.
c
      if( first )then
c
         if(pole .eq. 'ave' ) then
            lcpole(1) = 0.0
            lcpole(2) = 0.5
            lcpole(3) = 0.5
            lcpole(4) = 0.0
c
         endif
         first = .false.
      endif
c
c        ...Fill north pole line.
c
         do 50       k = 1,kbdm
c
            zpole      = 0.0
            do 10    i = 1,4
               zave(i) = 0.0
   10       continue
            do 20    i = istart,istop
               zave(1) = zave(1) + fb(i,k,jn-1)
               zave(2) = zave(2) + fb(i,k,jn  )
   20       continue
c
            zave(1)    = zave(1)/float(plon)
            zave(2)    = zave(2)/float(plon)
            zave(3)    = zave(2)
            zave(4)    = zave(1)
c
            do 30  i   = 1,4
               zpole   = zpole + zave(i)*lcpole(i)
   30       continue
c
            do 40         i = istart,istop
               fb(i,k,jn+1,2) = zpole
   40       continue
c
   50    continue
c
c     ...Fill south pole line.
c
         do 150      k = 1,kbdm
c
            zpole      = 0.0
            do 110   i = 1,4
               zave(i) = 0.0
  110       continue
            do 120   i = istart,istop
               zave(1) = zave(1) + fb(i,k,js+1)
               zave(2) = zave(2) + fb(i,k,js  )
  120       continue
c
            zave(1)    = zave(1)/float(plon)
            zave(2)    = zave(2)/float(plon)
            zave(3)    = zave(2)
            zave(4)    = zave(1)
c
            do 130   i = 1,4
               zpole   = zpole + zave(i)*lcpole(i)
  130       continue
c
            do 140        i = istart,istop
               fb(i,k,js-1) = zpole
  140       continue
c
  150    continue
c
c
c        ...Fill northern and southern lines beyond pole line.
c
         if( jn+2 .le. jxdm )then
            do 62                  j = jn+2,jxdm
               do 61               k = 1,kbdm
cdir$ ivdep
                  do 60            i = istart,istart+plon2-1
                     fb(      i,k,j) = fb(plon2+i,k,2*jn+2-j)
                     fb(plon2+i,k,j) = fb(      i,k,2*jn+2-j)
   60             continue
   61          continue
   62       continue
            do 162                 j = 1,js-2
               do 161              k = 1,kbdm
cdir$ ivdep
                  do 160           i = istart,istart+plon2-1
                     fb(      i,k,j) = fb(plon2+i,k,2*js-2-j)
                     fb(plon2+i,k,j) = fb(      i,k,2*js-2-j)
  160             continue
  161          continue
  162       continue
#endif
          endif
c
      return
      end
