#include "params.h"
      subroutine grdini(pmap,etamid,etaint,gravit,dlam,lam,phi,dphi,
     *                  gw,sinlam,coslam,lbasdy,lbasdz,
     *                  lbassd,lbasiy,detam,detai,kdpmpf,kdpmph,cwava)
c
      implicit none
#include "pmgrid.com"
      integer ibdm,jxdm,plevp1
#ifdef PP_PCCM
      parameter( ibdm= plon + 1 + 2*nxpt,
     *           jxdm= p_lato2 +  2*nxpt + 2*jintmx, plevp1= plev + 1)
c
      integer pmap
      integer kdpmpf(pmap),kdpmph(pmap)
      real etamid(plev),etaint(plevp1),gravit
      real dlam,lam(ibdm),phi(jxdm,2),dphi(jxdm,2),
     *     gw(plat),sinlam(plon),
     $     coslam(plon),sinphi(plat),cosphi(plat),
     $     lbasdy(4,2,jxdm,2),lbasdz(4,2,plev),lbassd(4,2,plevp1),
     $     lbasiy(4,2,jxdm,2),
     $     detam(plev),detai(plevp1),cwava
      integer ih   ! hemisphere
#else
      parameter( ibdm= plon + 1 + 2*nxpt,
     *           jxdm= plat +     2*nxpt + 2*jintmx, plevp1= plev + 1)
c
      integer pmap
      integer kdpmpf(pmap),kdpmph(pmap)
      real etamid(plev),etaint(plevp1),gravit
      real dlam,lam(ibdm),phi(jxdm),dphi(jxdm),gw(plat),sinlam(plon),
     *     coslam(plon),sinphi(plat),cosphi(plat),
     $     lbasdy(4,2,jxdm),lbasdz(4,2,plev),lbassd(4,2,plevp1),
     $     lbasiy(4,2,jxdm),
     $     detam(plev),detai(plevp1),cwava
#endif
c
c
c...Initialize model and extended grid parameters
c...Initialize weights for Lagrange cubic derivatives
c
c...On entry.
c
c  pmap    Dimension of artificial evenly spaced vertical grid arrays
c  etamid  Full-index hybrid-levels in vertical grid.
c  etaint  Half-index hybrid-levels from sig(1/2) = etaint(1) = 0. to
c          sig(plev+1/2) = etaint(plevp1) = 1.
c  gravit  Gravitational constant.
c
c...On return.
c
c  dlam    Length of increment in longitude grid.
c  lam     Longitude values in the extended grid.
c  phi     Latitude values in the extended grid.
c  dphi    Interval between latitudes in the extended grid
c  gw      Gauss weights for latitudes in the global grid.  (These sum
c          to 2.0 like the ones in CCM1.)
c  sinlam  Sine of longitudes in global grid (no extension points).
c  coslam  Cosine of longitudes in global grid (no extension points).
c  sinphi  Sine of latitudes in global grid (no extension points).
c  cosphi  Cosine of latitudes in global grid (no extension points).
c  lbasdy  Weights for Lagrange cubic derivative estimates on the
c          unequally spaced latitude grid
c  lbasdz  Weights for Lagrange cubic derivative estimates on the
c          unequally spaced vertical grid (corresponding to model
c          full levels).
c  lbassd  Weights for Lagrange cubic derivative estimates on the
c          unequally spaced vertical grid (corresponding to model
c          half levels).
c  lbasiy  Weights for Lagrange cubic interpolation on the
c          unequally spaced latitude grid
c  detam   Increment between model mid-levels ("full" levels)
c  detai   Increment between model interfaces ("half" levels).
c  kdpmpf  Array of indicies of the model full levels which are mapped
c          into an artificial evenly spaced vertical grid.  Used to aid
c          in search for vertical position of departure point 
c  kdpmph  Array of indicies of the model half levels which are mapped
c          into an artificial evenly spaced vertical grid.  Used to aid
c          in search for vertical position of departure point 
c  cwava   1./(plon*gravit)
c
c...Parameters required.
c
c  plat    Number of latitudes in global grid.
c  plev    Number of levels in global grid.
c  plon    Number of longitudes in global grid.
c  ibdm    Number of longitudes in extended grid.
c  jxdm    Number of latitudes in extended grid.
c  plevp1  plev + 1
c
      integer j,k
      real etamln(plev), etailn(plevp1),
     $     detamln(plev), detailn(plevp1)
c
      external basdy,basdz,basiy,grdxy,vrtmap
c
c     Extended horizontal grid coordinates.
c
      call grdxy(dlam,lam,phi,gw,sinlam,coslam,sinphi,cosphi)
c
c     Basis functions for computing Lagrangian cubic derivatives
c     on unequally spaced latitude and vertical grids.
c
#ifdef PP_PCCM
      call basdy(phi(1,1),lbasdy(1,1,1,1))
      call basdy(phi(1,2),lbasdy(1,1,1,2))
#else
      call basdy(phi,lbasdy)
#endif
      call basdz(plev,etamid,lbasdz)
      call basdz(plevp1,etaint,lbassd)
c
c     Basis functions for computing weights for Lagrangian cubic
c     interpolation on unequally spaced latitude and vertical grids.
c
#ifdef PP_PCCM
      call basiy(phi(1,1),lbasiy(1,1,1,1))
      call basiy(phi(1,2),lbasiy(1,1,1,2))
#else
      call basiy(phi,lbasiy)
#endif
c
c     compute interval lengths in latitudinal grid
c
#ifdef PP_PCCM
      do 10   ih = 1,2
      do 10    j = 1,jxdm-1
         dphi(j,ih) = phi(j+1,ih) - phi(j,ih)
#else
      do 10    j = 1,jxdm-1
         dphi(j) = phi(j+1) - phi(j)
#endif
   10 continue
c
c     Compute interval lengths in vertical grids.
c
      do 20 k = 1,plev
         etamln(k) = alog(etamid(k))
   20 continue
      do 30 k = 1,plevp1
         etailn(k) = alog(etaint(k))
   30 continue
      do 40 k = 1,plev-1
         detam  (k) = etamid(k+1) - etamid(k)
         detamln(k) = etamln(k+1) - etamln(k)
   40 continue
      do 50 k  = 1,plev
         detai  (k) = etaint(k+1) - etaint(k)
         detailn(k) = etailn(k+1) - etailn(k)
   50 continue
c
c Build artificial evenly spaced vertical grid for use in determining
c vertical position of departure point
c Build one grid for full model levels and one for half levels
c
      call vrtmap(plev ,pmap,etamln,detamln,kdpmpf)
      call vrtmap(plevp,pmap,etailn,detailn,kdpmph)
c
c compute moisture integration constant
c
#ifdef PP_PCCM
      cwava       = 1./(p_glon*gravit)
#else
      cwava       = 1./(plon*gravit)
#endif
c
      return
      end

