#include "params.h"
      subroutine hrintp(nf,fb,fxl,fxr,x,y,dy,wdy,xdp,ydp,idp,jdp,
     $                  limitd,fint,fyb,fyt,fdp,ikcnst)
c
      implicit none
      integer ikcnst
#include "pmgrid.com"
#include "parslt.com"
      integer ibdm,kbdm,jxdm
#ifdef PP_PCCM
      parameter( ibdm= plon + 1 + 2*nxpt, kbdm=plev,
     *           jxdm= p_lato2 +     2*nxpt + 2*jintmx )
#else
      parameter( ibdm= plon + 1 + 2*nxpt, kbdm=plev,
     *           jxdm= plat +     2*nxpt + 2*jintmx )
#endif
c
      integer nf,idp(plon,plev),jdp(plon,plev)
      real fb(ibdm,kbdm,ikcnst,jxdm),fxl(ibdm,kbdm,nf,jxdm),
     *     fxr(ibdm,kbdm,nf,jxdm),x(ibdm),y(jxdm),dy(jxdm),
     *     wdy(4,2,jxdm),xdp(plon,plev),ydp(plon,plev),
     *     fint(plon,plev,npdy,nf),fyb(plon,plev,nf),
     $     fyt(plon,plev,nf),fdp(plon,plev,nf)
      logical limitd

	 integer k
c
c
c...Interpolate 2-d field to departure point using rational bi-cubic
c   interpolation.
c
c...On entry.
c
c  nf      Number of fields being interpolated.
c  fb      Extended array of data to be interpolated.
c  fxl     x-derivatives at the left edge of each interval contained in
c  fxr     x-derivatives at the right edge of each interval contained in
c  x       Equally spaced x grid values in extended arrays.
c  y       y-coordinate (latitude) values in the extended array.
c  dy      Increment in the y-coordinate value for each interval in the
c          extended array.
c  wdy     Weights for Lagrange cubic derivative estimates on the
c          unequally spaced y-grid.  If grid interval j (in extended arr
c          is surrounded by a 4 point stencil, then the derivative at th
c          "bottom" of the interval uses the weights wdy(1,1,j),
c          wdy(2,1,j), wdy(3,1,j), and wdy(4,1,j).  The derivative at th
c          "top" of the interval uses wdy(1,2,j), wdy(2,2,j), wdy(3,2,j)
c          and wdy(4,2,j).
c  xdp     xdp(i,k) is the x-coordinate of the departure point that
c          corresponds to global grid point (i,k) in the latitude slice
c          being forecasted.
c  ydp     ydp(i,k) is the y-coordinate of the departure point that
c          corresponds to global grid point (i,k) in the latitude slice
c          being forecasted.
c  idp     idp(i,k) is the index of the x-interval that contains the
c          departure point corresponding to global grid point (i,k) in t
c          latitude slice being forecasted.
c          Note that
c                x(idp(i,k)) .le. xdp(i,k) .lt. x(idp(i,k)+1) .
c  jdp     jdp(i,k) is the index of the y-interval that contains the
c          departure point corresponding to global grid point (i,k) in t
c          latitude slice being forecasted.
c          Suppose yb contains the y-coordinates of the extended array
c          and ydp(i,k) is the y-coordinate of the departure point
c          corresponding to grid point (i,k).  Then,
c                yb(jdp(i,k)) .le. ydp(i,k) .lt. yb(jdp(i,k)+1) .
c  limitd  Logical flag to specify whether or not the y-derivatives will
c          limited.
c
c...On return.
c
c  fint    WORK ARRAY, results not used on return
c  fyb     WORK ARRAY, results not used on return
c  fyt     WORK ARRAY, results not used on return
c  fdp     Value of field at the departure points.
c
c...Parameters required.
c
c  plon    Number of longitudes in global grid.
c  plev    Number of levels in global grid.
c  pcnst   Number of components being advected.
c  npdy    The number of points in the stencil for computing the y
c          derivatives.  (I.e., the number of x interpolations required
c          each departure point.)
c  ibdm    Number of longitudes in extended array.
c  kbdm    Number of levels in extended array.
c  jxdm    Number of latitudes in extended array.
c
c
      external cubydr,herxin,heryin,limdy
c
c     ...Hermite cubic interpolation to the x-coordinate of each
c        departure point at each y-coordinate required to compute the
c        y-derivatives.
c
      call herxin(nf,fb,fxl,fxr,x,xdp,idp,jdp,fint,ikcnst)
c
c     ...Compute y-derivatives.
c
      call cubydr(nf,fint,wdy,jdp,fyb,fyt)
      if( limitd )then
         call limdy(nf,fint,dy,jdp,fyb,fyt)
      endif
c
c     ...Hermite cubic interpolation in the y-coordinate.
c
      call heryin(nf,fint,fyb,fyt,y,dy,ydp,jdp,fdp)
c
      return
      end
