#include "params.h"
      subroutine hrvint(nf,fb,fxl,fxr,x,wdy,xdp,ydp,idp,jdp,
     $                  fint,fdp,ikcnst)
c
      implicit none
      integer ikcnst
#include "pmgrid.com"
#include "parslt.com"
      integer ibdm,kbdm,jxdm
#ifdef PP_PCCM
      parameter( ibdm= plon + 1 + 2*nxpt, kbdm=plev,
     *           jxdm= p_lato2 +     2*nxpt + 2*jintmx )
#else
      parameter( ibdm= plon + 1 + 2*nxpt, kbdm=plev,
     *           jxdm= plat +     2*nxpt + 2*jintmx )
#endif
c
      integer nf,idp(plon,plev),jdp(plon,plev)
      real fb(ibdm,kbdm,ikcnst,jxdm),fxl(ibdm,kbdm,nf,jxdm),
     *     fxr(ibdm,kbdm,nf,jxdm),x(ibdm),
     *     wdy(4,2,jxdm),xdp(plon,plev),ydp(plon,plev),
     *     fint(plon,plev,npdy,nf),fdp(plon,plev,nf)
c
c
c...Interpolate 2-d field to departure point using rational bi-cubic
c   interpolation.
c
c...On entry.
c
c  nf      Number of fields being interpolated.
c  fb      Extended array of data to be interpolated.
c  fxl     x-derivatives at the left edge of each interval contained in
c  fxr     x-derivatives at the right edge of each interval contained in
c  x       Equally spaced x grid values in extended arrays.
c  wdy     Weights for Lagrange cubic interpolation on the
c          unequally spaced y-grid.
c  xdp     xdp(i,k) is the x-coordinate of the departure point that
c          corresponds to global grid point (i,k) in the latitude slice
c          being forecasted.
c  ydp     ydp(i,k) is the y-coordinate of the departure point that
c          corresponds to global grid point (i,k) in the latitude slice
c          being forecasted.
c  idp     idp(i,k) is the index of the x-interval that contains the
c          departure point corresponding to global grid point (i,k) in t
c          latitude slice being forecasted.
c          Note that
c                x(idp(i,k)) .le. xdp(i,k) .lt. x(idp(i,k)+1) .
c  jdp     jdp(i,k) is the index of the y-interval that contains the
c          departure point corresponding to global grid point (i,k) in t
c          latitude slice being forecasted.
c          Suppose yb contains the y-coordinates of the extended array
c          and ydp(i,k) is the y-coordinate of the departure point
c          corresponding to grid point (i,k).  Then,
c                yb(jdp(i,k)) .le. ydp(i,k) .lt. yb(jdp(i,k)+1) .
c
c...On return.
c
c  fint    WORK ARRAY, results not used on return
c  fdp     Value of field at the departure points.
c
c...Parameters required.
c
c  plon    Number of longitudes in global grid.
c  plev    Number of levels in global grid.
c  pcnst   Number of components being advected.
c  npdy    The number of points in the stencil for computing the y
c          derivatives.  (I.e., the number of x interpolations required
c          each departure point.)
c  ibdm    Number of longitudes in extended array.
c  kbdm    Number of levels in extended array.
c  jxdm    Number of latitudes in extended array.
c
c
      external herxin,lagyin
c
c     ...Hermite cubic interpolation to the x-coordinate of each
c        departure point at each y-coordinate required to compute the
c        y-derivatives.
c
      call herxin(nf,fb,fxl,fxr,x,xdp,idp,jdp,fint,ikcnst)
c
c     ...Lagrange cubic interpolation in y
c
      call lagyin(nf,fint,wdy,ydp,jdp,fdp)
c
      return
      end
