#include "params.h"
      subroutine limdx(f,dx,idim,ibeg,len,fxl,fxr)
c
      implicit none
#include "pmgrid.com"
#include "parslt.com"
      integer ibdm,kbdm,jxdm,nbpts
#ifdef PP_PCCM
      parameter( ibdm= plon + 1 + 2*nxpt, kbdm=plev,
     *           jxdm= 2*jintmx + p_lato2 + 2*nxpt,
     *           nbpts= ibdm*kbdm*pcnst )
#else
      parameter( ibdm= plon + 1 + 2*nxpt, kbdm=plev,
     *           jxdm= 2*jintmx + plat + 2*nxpt,
     *           nbpts= ibdm*kbdm*pcnst )
#endif
c
      integer idim,ibeg,len
      real f(idim), dx, fxl(idim), fxr(idim)
c
c...Limit the derivative estimates for data on an equally spaced grid.
c
c...On entry.
c
c  f       Values on equally spaced grid from which derivatives fxl and
c          fxr were computed.
c  dx      Value of grid spacing.
c  idim    Length of f, fxl, and fxr.
c  ibeg    First interval of grid for which derivatives are computed.
c  len     Number of grid intervals for which derivatives are computed.
c          (There are idim - 1 intervals between the idim gridpoints
c          represented in f, fxl, and fxr.)
c  fxl     fxl(i) is the derivative at the left edge of interval i.
c  fxr     fxr(i) is the derivative at the right edge of interval i.
c
c...On return.
c
c  fxl     fxl(i) is the limited derivative at the left edge of interval
c  fxr     fxr(i) is the limited derivative at the right edge of interva
c
c...Parameters required.
c
c  ibdm    Number of longitudes in extended array.
c  jxdm    Number of latitudes in extended array.
c  kbdm    Number of levels in extended array.
c  nbpts   Number of elements in extended array.
c
c
      integer i,iend
      real rdx,deli(nbpts)
      external abortf,scm0
c
      if(idim .gt. nbpts) 
     $call abortf('error limdx: work arrays not large enough')
c
      iend = ibeg + len - 1
      rdx = 1./dx
c
      do 10  i=ibeg,iend
         deli(i) = ( f(i+1) - f(i) )*rdx
   10 continue
c
c     ...limiter
c
      call scm0( len, deli(ibeg), fxl(ibeg), fxr(ibeg) )
c
      return
      end
