#include "params.h"
      subroutine limdz(f,dsig,fst,fsb)
c
      implicit none
#include "pmgrid.com"
#include "parslt.com"
      integer plevm1
      parameter( plevm1= plev - 1 )
c
      real f(plon,plev,pcnst),dsig(plev),fst(plon,plev,pcnst),
     *     fsb(plon,plev,pcnst)
c
c...Apply SCMO limiter to vertical derivatives on a vertical slice.
c
c...On entry.
c
c  f       Field values used to compute the discrete differences for eac
c          interval in the vertical grid.
c  dsig    Increment in the sigma-coordinate value for each interval.
c  fst     Derivative estimate at the top of each sigma interval in grid
c  fsb     Derivative estimate at the bottom of each sigma interval in g
c
c...On return.
c
c  fst     Limited derivative at the top of each interval.
c  fsb     Limited derivative at the bottom of each interval.
c
c...Parameters required.
c
c  plon    Number of longitudes in global grid.
c  plev    Number of levels in global grid.
c
c
      integer i,k,n
      real rdsig,deli(plon,plevm1)
      external scm0
c
c     ...Loop over fields.
c
      do 100  n=1,pcnst
c
         do 20  k=1,plevm1
            rdsig = 1.0/dsig(k)
            do 19  i=1,plon
               deli(i,k) = ( f(i,k+1,n) - f(i,k,n) )*rdsig
   19       continue
   20    continue
c
         call scm0( plon*plevm1, deli, fst(1,1,n), fsb(1,1,n) )
c
  100 continue
c
      return
      end
