#include "params.h"
      subroutine s2gvel(udp,vdp,lam,cosphi,sinphi,lamdp,phidp,upr,vpr)
c
      implicit none
#include "pmgrid.com"
#include "parslt.com"
c
      real udp(plon,plev),vdp(plon,plev),lam(plon),cosphi,sinphi,
     *     lamdp(plon,plev),phidp(plon,plev),
     *     upr(plon,plev),vpr(plon,plev)
c
c...Transform velocity components of departure points in a single latitu
c   slice from spherical coordinates to local geodesic coordinates.
c
c...On entry.
c
c  udp    u-component of departure point velocity in spherical coords.
c  vdp    v-component of departure point velocity in spherical coords.
c  lam    Longitude component of arrival point position in spherical
c         coordinates.
c  cosphi Cosine of latitude of arrival point positions.
c  sinphi Sine of latitude of arrival point positions.
c  lamdp  Longitude component of departure point position in spherical
c         coordinates.
c  phidp  Latitude component of departure point position in spherical
c         coordinates.
c
c...On return.
c
c  upr    u-component of departure point velocity in geodesic coords.
c  vpr    v-component of departure point velocity in geodesic coords.
c
c...Parameters required.
c
c  plon   Number of longitudes in global grid.
c  plev   Number of levels in global grid.
c
c
      integer i,k
      real cdlam,clamp,cphid,cphip,dlam,sdlam,slamp,sphid,sphip
c
      do 100  k=1,plev
         do 90  i=1,plon
c
            dlam = lam(i) - lamdp(i,k)
            sdlam = sin( dlam )
            cdlam = cos( dlam )
            sphid = sin( phidp(i,k) )
            cphid = cos( phidp(i,k) )
c
            sphip = sphid*cosphi - cphid*sinphi*cdlam
            cphip = cos( asin( sphip ) )
c
            slamp = - sdlam*cphid / cphip
            clamp = cos( asin( slamp ) )
c
            vpr(i,k) = ( vdp(i,k)*( cphid*cosphi
     *                              + sphid*sinphi*cdlam )
     *                 - udp(i,k)*sinphi*sdlam ) / cphip
c
            upr(i,k) = ( udp(i,k)*cdlam + vdp(i,k)*sphid*sdlam
     *                 + vpr(i,k)*slamp*sphip ) / clamp
c
   90    continue
  100 continue
c
      return
      end
