#include "params.h"
      subroutine scm0(n,deli,df1,df2)
c
      implicit none
#include "pmgrid.com"
#include "parslt.com"
      integer ibdm,kbdm,jxdm,nbpts
      real eps,fac
#ifdef WORD4 
      parameter( eps= 1.e-06, fac= 3.*( 1. - eps ),
#else
      parameter( eps= 1.e-12, fac= 3.*( 1. - eps ),
#endif
#ifdef PP_PCCM
     *           ibdm= plon + 1 + 2*nxpt, kbdm=plev,
     *           jxdm= 2*jintmx + p_lato2 + 2*nxpt)
#else
     *           ibdm= plon + 1 + 2*nxpt, kbdm=plev,
     *           jxdm= 2*jintmx + plat + 2*nxpt)
#endif
c
      integer n
      real deli(n),df1(n),df2(n)
c
c...Apply SCM0 limiter to derivative estimates.
c
c...On entry.
c
c  n       Dimension of input arrays.
c  deli    deli(i) is the discrete derivative on interval i, i.e.,
c          deli(i) = ( f(i+1) - f(i) )/( x(i+1) - x(i) ).
c  df1     df1(i) is the derivative at the left edge of interval i.
c  df2     df2(i) is the derivative at the right edge of interval i.
c
c...On return.
c
c  df1     df1(i) is the limited derivative at the left edge of interval
c  df2     df2(i) is the limited derivative at the right edge of interva
c
c...Parameters required.
c
c  ibdm    Number of longitudes in extended array.
c  jxdm    Number of latitudes in extended array.
c  kbdm    Number of levels in extended array.
c
      integer i
      real tmp1,tmp2
c
      real cvmgp, cvmgm
      external abort
c
c
      do 200   i = 1,n
         tmp1 = fac*deli(i)
         tmp2 = abs( tmp1 )
c
#ifdef CRAY
         df1(i) = cvmgp( 0.0        , df1(i), -deli(i)*df1(i) )
         df2(i) = cvmgp( 0.0        , df2(i), -deli(i)*df2(i) )
         df1(i) = cvmgm( tmp1    , df1(i), tmp2 - abs( df1(i) ) )
         df2(i) = cvmgm( tmp1    , df2(i), tmp2 - abs( df2(i) ) )
#else
         if( deli(i)*df1(i) .le. 0.0 ) df1(i) = 0.
         if( deli(i)*df2(i) .le. 0.0 ) df2(i) = 0.
         if( abs( df1(i) ) .gt. tmp2 ) df1(i) = tmp1
         if( abs( df2(i) ) .gt. tmp2 ) df2(i) = tmp1
#endif
 200  continue
c
      return
      end
