#include "params.h"
#undef DEBUG_DISABLE_SLT
      subroutine sltb1(pmap,jcen,jgc,dt,ra,iterdp,ub,uxl,uxr,vb,
     $                 wb,fb,fxl,fxr,
     $                 lam,phib,dphib,sig,sigh,dsig,dsigh,
     $                 lbasdy,lbasdz,lbassd,lbasiy,kdpmpf,kdpmph,
#ifdef PP_PCCM
     $                 lammp,phimp,sigmp,fbout,diag,nxpt_a)
#else
     $                 lammp,phimp,sigmp,fbout,diag)
#endif
c
      implicit none
#include "pmgrid.com"
#include "pspect.com"
#include "comparll.com"
#include "parslt.com"
      integer ibdm,jxdm,plevp1
#ifdef PP_PCCM
      parameter( ibdm= plon + 1 + 2*nxpt,
     *           jxdm= p_lato2 +  2*nxpt + 2*jintmx,
     *           plevp1= plev + 1 )
#else
      parameter( ibdm= plon + 1 + 2*nxpt,
     *           jxdm= plat +     2*nxpt + 2*jintmx,
     *           plevp1= plev + 1 )
#endif
c
      integer pmap,jcen,jgc,iterdp
      integer kdpmpf(pmap),kdpmph(pmap)
      real ub(ibdm,plev*(3+pcnst),jxdm),uxl(ibdm,plev,2,jxdm),
     $     uxr(ibdm,plev,2,jxdm),
     *     vb(ibdm,plev*(3+pcnst),jxdm),
     *     wb(plon,plevp1),fb(ibdm,plev,3+pcnst,jxdm),
     *     fxl(ibdm,plev,pcnst,jxdm),fxr(ibdm,plev,pcnst,jxdm),
     *     dt,ra,lam(ibdm),phib(jxdm),dphib(jxdm),
     *     sig(plev),sigh(plevp1),dsig(plev),
     *     dsigh(plevp1),
     $     lbasdy(4,2,jxdm),lbasdz(4,2,plev),lbassd(4,2,plevp1),
     $     lbasiy(4,2,jxdm),
     *     lammp(plon,plev),phimp(plon,plev),sigmp(plon,plev),
     *     fbout(ibdm,plev,pcnst,jxdm),diag(plond,plev,pcnst,plat)
#ifdef PP_PCCM
      integer nxpt_a(plev),nxpt_max,iext,isafe
#endif
c
c...sltb1 implements a banded version of semi-Lagrangian transport (slt)
c   on a sphere.  A call to sltb1 results in the slt algorithm being
c   executed on a given latitude slice in the extended data arrays using
c   information from a latitude band extending "jintmx + nxpt" on either
c   side of the latitude slice being forecasted.
c
c...On entry.
c
c  pmap    Dimension of kdpmap arrays
c  jcen    Index in extended grid corresponding to latitude being foreca
c  jgc     Latitude index in global grid of the latitude slice being for
c  dt      Time interval that parameterizes the parcel trajectory.
c  ra      Reciprocal of radius of earth.
c  iterdp  Number of iterations used for departure point calculation.
c  ub      u-velocity component.
c  uxl     x-derivatives at the left edge of each interval contained in
c  uxr     x-derivatives at the right edge of each interval contained in
c  vb      v-velocity component.
c  wb      z-velocity component (sigma dot).
c  fb      Scalar components to be transported.
c  fxl     x-derivatives at the left edge of each interval contained in
c  fxr     x-derivatives at the right edge of each interval contained in
c  lam     Longitude values for the extended grid.
c  phib    Latitude values for the extended grid.
c  dphib   Interval between latitudes in the extended grid.
c  sig     Hybrid eta values at the "full-index" levels.
c  sigh    Half-index eta-levels including sigh(i,1) = eta(1/2) = 0.0 an
c          sigh(i,plev+1) = eta(plev+1/2) = 1.  Note that in general
c          sigh(i,k) .lt. sig(i,k)  where sig(i,k) is the hybrid value a
c          k_th full-index level.
c  dsig    Interval lengths in full-index hybrid level grid.
c  dsigh   Interval lengths in half-index hybrid level grid.
c  lbasdy  Weights for Lagrange cubic derivative estimates on the
c          unequally spaced latitude grid.
c  lbasdz  Weights for Lagrange cubic derivative estimates on the
c          unequally spaced vertical grid (full levels).
c  lbassd  Weights for Lagrange cubic derivative estimates on the
c          unequally spaced vertical grid (half levels).
c  lbasiy  Weights for Lagrange cubic interpolation on the
c          unequally spaced latitude grid.
c  kdpmpf  Not used locally
c  kdpmph  Not used locally
c  lammp   Longitude coordinates of the trajectory mid-points of the
c          parcels that correspond to the global grid points contained
c          in the latitude slice being forecasted.  On entry lammp
c          is an initial guess.
c  phimp   Latitude coordinates of the trajectory mid-points of the
c          parcels that correspond to the global grid points contained
c          in the latitude slice being forecasted.  On entry phimp
c          is an initial guess.
c  sigmp   Hybrid value at the trajectory midpoint for each gridpoint
c          in a vertical slice from the global grid.  On entry sigmp is
c          an initial guess.
c
c...On return.
c
c  lammp   Longitude coordinates of the trajectory mid-points of the
c          parcels that correspond to the global grid points contained
c          in the latitude slice being forecasted.
c  phimp   Latitude coordinates of the trajectory mid-points of the
c          parcels that correspond to the global grid points contained
c          in the latitude slice being forecasted.
c  sigmp   Hybrid value at the trajectory midpoint for each gridpoint
c          in a vertical slice from the global grid.
c  fbout   Extended array only one latitude of which, however, is filled
c          with forecasted (transported) values.  SLTB1 must be called
c          multiple times to fill the entire array.  This is done to
c          facilitate multi-tasking.
c  diag    Diagnostic values for each scalar component at the global
c          grid points that correspond to the latitude slice being forec
c          As in "fbout", only one latitude slice at a time is filled
c          Currently the only diagnostic computed is the time tendency
c          due to horizontal advection.
c
c...Parameters required.
c
c  plon    Number of longitudes in global grid.
c  plev    Number of levels in global grid.
c  ibdm    Number of longitudes in extended array.
c  jxdm    Number of latitudes in extended array.
c  pcnst   Number of constituents
c
      integer i,j,k, idp(plon,plev),jdp(plon,plev),kdp(plon,plev),n
      real fhr(plon,plev,pcnst),phigs,
     *     lamdp(plon,plev),phidp(plon,plev),sigdp(plon,plev),
     *     fhst(plon,plev,pcnst),fhsb(plon,plev,pcnst),
     *     wst(plon,plevp1),wsb(plon,plevp1),fdp(plon,plev,pcnst),
     $     fint(plon,plev,npdy,pcnst),fyb(plon,plev,pcnst),
     $     fyt(plon,plev,pcnst)
      logical locgeo
c
      external sphdep,herzin,hrintp,vrtdep,cubzdr,limdz
c
      save phigs
c
      data phigs /1.221730/
c
c
c...HORIZONTAL INTERPOLATION
c
c     ...Compute departure points and corresponding indices.
c     ...Poleward of latitude phigs (radians), perform the computation
c        in local geodesic coordinates.
c     ...Equatorward of latitude phigs, perform the computation
c        in global spherical coordinates
c
#ifdef DEBUG_DISABLE_SLT
c short circuit out the slt and just keep moisture constant.
c strictly for debugging reproducibility in rest of code
      
      do n = 1, pcnst
	do k = 1, plev
	   do i = 1, plon
	      fbout(nxpt+i,k,n,jcen) = fb(nxpt+i,k,n,jcen)*.00001
              diag(i,k,n,jgc) = 
     $          (fbout(nxpt+i,k,n,jcen) - fb(nxpt+i,k,n,jcen))/dt

	   enddo
	enddo
      enddo
      return
#endif


      locgeo = .false.
      if(abs(phib(jcen)) .ge. phigs) locgeo = .true.
c
#ifdef PP_PCCM
      call sphdep(jcen,jgc,dt,ra,iterdp,locgeo,ub,uxl,uxr,vb,lam,phib,
     &            lbasiy,lammp,phimp,lamdp,phidp,idp,jdp,nxpt_a)
#else
      call sphdep(jcen,jgc,dt,ra,iterdp,locgeo,ub,uxl,uxr,vb,lam,phib,
     &            lbasiy,lammp,phimp,lamdp,phidp,idp,jdp)
#endif

c
c     ...Interpolate scalar fields to the departure points.
C     !  Last arg to hrintp=dimensioning construct--JR
c
      call hrintp(pcnst,fb,fxl,fxr,lam,phib,dphib,lbasdy,lamdp,phidp,
     &            idp,jdp,limdr,fint,fyb,fyt,fhr,3+pcnst)
      
c
c     ...Compute time tendency due to horizontal advection.
c
      do 20  n=1,pcnst
         do 19  k=1,plev
            do 18  i=1,plon
               diag(i,k,n,jgc) = (fhr(i,k,n) - fb(nxpt+i,k,n,jcen))/dt
   18       continue
   19    continue
   20 continue
c
c...VERTICAL INTERPOLATION
c
c     ...Compute vertical derivatives of vertical wind
c
         call cubzdr(plon,plevp1, wb, lbassd,wst,wsb)
c
c     ...Compute departure points and corresponding indices.
c
      call vrtdep(pmap,dt,iterdp,jcen,wb,wst,wsb,sig,sigh,dsig,dsigh,
     $            kdpmpf,kdpmph,sigmp,sigdp,kdp)

c
c     ...Vertical derivatives of scalar fields.
c
c     ...Loop over components.
      do 30  n=1,pcnst
         call cubzdr(plon,plev,fhr(1,1,n),lbasdz,fhst(1,1,n),
     *                                           fhsb(1,1,n))
   30 continue
c
      if( limdr )then
         call limdz(fhr,dsig,fhst,fhsb)
      endif
c
c     ...Vertical interpolation of scalar fields.
c
      call herzin(plev,pcnst,fhr,fhst,fhsb,sig,dsig,sigdp,kdp,fdp)

c
c     ...Transfer transported values to extended array
c
      do 60                         n = 1,pcnst
         do 50                      k = 1,plev
            do 40                   i = 1,plon
               fbout(nxpt+i,k,n,jcen) = fdp(i,k,n)
   40       continue
   50    continue
   60 continue
c
#ifdef PP_PCCM
c    ...Locally update the nxpt_a array using idp
c    The array values over the row of processors in longitude
c    are syncronized in sltini
c
      isafe = 4
      do 80 k = 1,plev
        nxpt_max = 0
        do 70 i = 1,plon
           iext= i + nxpt
           nxpt_max = max(nxpt_max,abs(iext - idp(i,k))+isafe)
70      continue
        nxpt_a(k) = min(nxpt_max,nxpt)
80    continue
#endif
      return
      end

