#include "params.h"
#ifdef PP_PCCM
      subroutine sltini(dlam,sinlam,coslam,ufld,vfld,qin,
     *                  uxl,uxr,qxl,qxr,nxpt_a)
c
      implicit none
#include "pmgrid.com"
#include "parslt.com"
      integer ibdm,jxdm,nbpts
#include "pspect.com"
#include "comparll.com"
      parameter( ibdm= plon + 1 + 2*nxpt,
     *           jxdm= p_lato2  + 2*nxpt + 2*jintmx,
     *           nbpts= ibdm*plev*jxdm)
      integer nuvpts,nqpts
      parameter(nuvpts=ibdm*plev,nqpts=ibdm*plev*pcnst)
      real dlam,sinlam(plon),coslam(plon)
     *    ,ufld(ibdm,plev*(3+pcnst),jxdm,2)
     *    ,vfld(ibdm,plev*(3+pcnst),jxdm,2)
     *    ,qin (ibdm,plev,3+pcnst,jxdm,2)
     *    ,uxl (ibdm,plev,2    ,jxdm,2) ,uxr (ibdm,plev,2    ,jxdm,2)
     *    ,qxl (ibdm,plev,pcnst,jxdm,2) ,qxr (ibdm,plev,pcnst,jxdm,2)
      integer nxpt_a(plev,jxdm,2),itmp(plev,jxdm,2)
      integer ih, k, jfirst, jlast, nei_nxpt
      logical first /.true./
      save first
#else
      subroutine sltini(dlam,sinlam,coslam,ufld,vfld,qin,
     *                  uxl,uxr,qxl,qxr)
c
      implicit none
#include "pmgrid.com"
#include "parslt.com"
      integer ibdm,jxdm,nbpts
      parameter( ibdm= plon + 1 + 2*nxpt,
     *           jxdm= plat     + 2*nxpt + 2*jintmx,
     *           nbpts= ibdm*plev*jxdm)
      integer nuvpts,nqpts
      parameter(nuvpts=ibdm*plev,nqpts=ibdm*plev*pcnst)
      real dlam,sinlam(plon),coslam(plon)
     *   ,ufld(ibdm,plev*(3+pcnst),jxdm),vfld(ibdm,plev*(3+pcnst),jxdm)
     *   ,qin (ibdm,plev,3+pcnst,jxdm)
     *   ,uxl (ibdm,plev,2    ,jxdm) ,uxr (ibdm,plev,2    ,jxdm)
     *   ,qxl (ibdm,plev,pcnst,jxdm) ,qxr (ibdm,plev,pcnst,jxdm)
#endif
      integer j,lm_type
c
c...Prepare the extended arrays for use in the SLT routines
c
c   1)  Fill latitude extensions.
c   2)  Fill longitude extensions.
c   3)  Compute x-derivatives
c
c...On entry.
c
c  dlam    Length of increment in longitude grid.
c  sinlam  Sine of longitudes in global grid (no extension points).
c  coslam  Cosine of longitudes in global grid (no extension points).
c  ufld    u-velocity component
c  vfld    v-velocity component
c  qin     array of "pcnst" scalar species
c
c...On return.
c
c  ufld    u-velocity component with extensions filled
c  vfld    v-velocity component with extensions filled
c  qin     array of "pcnst" scalar species with extensions filled
c  uxl     x-derivatives of u at the left  (west) edge of given interval
c  uxr     x-derivatives of u at the right (east) edge of given interval
c  qxl     x-derivatives of scalar species at the left  (west) edge
c          of given interval
c  qxr     x-derivatives of scalar species at the right (east) edge
c          of given interval
c
c...Parameters required.
c
c  nxpt    Number of points beyond the horizontal grid boundary needed
c          to make a derivative estimate for an interval adjacent to the
c          grid boundary.
c  plon    Number of longitudes in global grid.
c  plev    Number of levels in global grid.
c  ibdm    Number of longitudes in extended grid.
c  jxdm    Number of latitudes in extended grid. (Modified in parallel code)
c  nbpts   Number of elements in extended arrays.
c  pcnst      Number of species to be advected by SLT
c
      integer n, i

c
      external cubxdr,extx,extys,extyv,limdx
c
c     fill latitude extensions beyond the southern- and northern-most
c     latitudes in the global grid
c
#ifdef PP_PCCM
      call extyv( coslam,sinlam,ufld )
      call extyv( coslam,sinlam,vfld )
      do 10  n = 1,pcnst
         call extys( plev,qin(1,1,n,1,1) )
   10 continue
c
c  Syncronize the nxpt_a array for this timestep
c
      if(first) then
c
c  Initialize the nxpt_a array
c
        do ih = 1,2
          do j= 1,jxdm
            do k = 1,plev
              nxpt_a(k,j,ih) = nxpt
            enddo
          enddo
        enddo
        first = .false.
      else
       if(p_nproc_ln.gt.1) then
c
c   Be sure the ovrlap extension is enough to support interp.
c
        jfirst = nxpt+jintmx+1
	do ih = 1,2
	  do j = 1,nxpt+jintmx
	    do k = 1,plev
		itmp(k,j,ih) = nxpt_a(k,jfirst,ih)
	    enddo
	  enddo
	enddo
        jlast = p_lato2 + nxpt+jintmx
	do ih = 1,2
	  do j = jlast+1,jxdm
	    do k = 1,plev
		itmp(k,j,ih) = nxpt_a(k,jlast,ih)
	    enddo
	  enddo
	enddo
c
	do ih = 1,2
	  do j = jfirst,jlast
	    do k = 1,plev
                nei_nxpt = 0
		if(k.gt.1)nei_nxpt = max(nxpt_a(k-1,j,ih),nei_nxpt)
                nei_nxpt = max(nxpt_a(k,j,ih),nei_nxpt)
                if(k.le.plev-1)nei_nxpt = max(nxpt_a(k+1,j,ih),nei_nxpt)
                if(k.le.plev-2)nei_nxpt = max(nxpt_a(k+2,j,ih),nei_nxpt)
                nei_nxpt = max(nxpt_a(k,j-1,ih),nei_nxpt)
                nei_nxpt = max(nxpt_a(k,j,ih),nei_nxpt)
                nei_nxpt = max(nxpt_a(k,j+1,ih),nei_nxpt)
                nei_nxpt = max(nxpt_a(k,j+2,ih),nei_nxpt)
		itmp(k,j,ih) = nei_nxpt
	    enddo
	  enddo
	enddo
	do ih = 1,2
	  do j = 1,jxdm
	    do k = 1,plev
		nxpt_a(k,j,ih) = itmp(k,j,ih)
	    enddo
	  enddo
	enddo
c
c   Syncronize the nxpt_a across the processors in the row.
c
        lm_type = 330 + 5*p_nproc
        call rowmaxi0(nxpt_a,itmp,plev*jxdm*2,lm_type)
cdebug:
cw        write(0,*) 'nxpt_a:',nxpt_a
       endif
      endif
c
c  Update the overlap between processors...
c  the arrays have been extended as if poles were present
c
      call ovrlap(ufld,nxpt_a)
      call ovrlap(vfld,nxpt_a)
      call ovrlap(qin,nxpt_a)
c
C     !  fill longitude extensions
C     !  3rd parameter to extx=dimensioning construct--JR
c
      call extx( plev,ufld(1,1,1,1),3+pcnst )
      call extx( plev,ufld(1,1,1,2),3+pcnst )
      call extx( plev,vfld(1,1,1,1),3+pcnst )
      call extx( plev,vfld(1,1,1,2),3+pcnst )
      do 20  n = 1,pcnst
         call extx( plev,qin(1,1,n,1,1),3+pcnst )
         call extx( plev,qin(1,1,n,1,2),3+pcnst )
   20 continue
c
c     compute x-derivatives
c
CMIC$ DO ALL SHARED(DLAM,UFLD,UXL,UXR,VFLD,QIN,QXL,QXR)PRIVATE(J)
      do 30 ih = 1,2
      do 30  j = 1,jxdm
         call cubxdr(ufld(1,1,j,ih),dlam,nuvpts,2,nuvpts-3,
     $               uxl(1,1,1,j,ih),uxr(1,1,1,j,ih))
         call cubxdr(vfld(1,1,j,ih),dlam,nuvpts,2,nuvpts-3,
     $               uxl(1,1,2,j,ih),uxr(1,1,2,j,ih))
         call cubxdr(qin(1,1,1,j,ih),dlam,nqpts,2,nqpts-3,
     *               qxl(1,1,1,j,ih),qxr(1,1,1,j,ih))
         if( limdr )then
            call limdx(qin(1,1,1,j,ih),dlam,nqpts,2,
     *                 nqpts-3,qxl(1,1,1,j,ih),qxr(1,1,1,j,ih))
         endif
   30 continue
#else
      call extyv( coslam,sinlam,ufld )
      call extyv( coslam,sinlam,vfld )
      do 10  n = 1,pcnst
         call extys( plev,qin(1,1,n,1) )
   10 continue
c
C     !  fill longitude extensions
C     !  3rd parameter to extx=dimensioning construct--JR
c
      call extx( plev,ufld,3+pcnst )
      call extx( plev,vfld,3+pcnst )
      do 20  n = 1,pcnst
         call extx( plev,qin(1,1,n,1),3+pcnst )
   20 continue
c
c     compute x-derivatives
c
CMIC$ DO ALL SHARED(DLAM,UFLD,UXL,UXR,VFLD,QIN,QXL,QXR)PRIVATE(J)
      do 30  j = 1,jxdm
         call cubxdr(ufld(1,1,j),dlam,nuvpts,2,nuvpts-3,
     $               uxl(1,1,1,j),uxr(1,1,1,j))
         call cubxdr(vfld(1,1,j),dlam,nuvpts,2,nuvpts-3,
     $               uxl(1,1,2,j),uxr(1,1,2,j))
         call cubxdr(qin(1,1,1,j),dlam,nqpts,2,nqpts-3,
     *               qxl(1,1,1,j),qxr(1,1,1,j))
         if( limdr )then
            call limdx(qin(1,1,1,j),dlam,nqpts,2,
     *                 nqpts-3,qxl(1,1,1,j),qxr(1,1,1,j))
         endif
   30 continue
#endif
c
      return
      end
