#include "params.h"
#ifdef PP_RHOMB_TRUNC
c
c     Pat Worley's modified f_locsum for non-power of 2 values
c     of len
c
      real function f_locsum( vec, len, work )
      implicit none
      integer len
      real vec(len)
      real work(len)
      integer i, l
      do i = 1, len
        work(i) = vec(i)
      enddo
      l = 1
      do while (l .lt. len)
         do i = 1,len-l,2*l
            work(i) = work(i) + work(i+l)
	 enddo
	 l = 2*l
      enddo
      f_locsum = work(1)
      return
      end
#else
      real function f_locsum( vec, len, work )
      implicit none
      integer len
      real vec(len)
      real work(len)
      integer i, l
      do i = 1, len
	  work(i) = vec(i)
      enddo
      l = 1
      do while ( l .lt. len )
	  do i = 1, len, l*2
              work(i) = work(i) + work(i+l)
	  enddo
	  l = l * 2
      enddo
      f_locsum = work(1)
      return
      end
#endif
C
C  This routine implements the on-node tree sum in place.
C
C       vec	vector of vectors to be summed
C       len     number of elements in each vector
C	jmp	length of each vector including unused portions
C       n       number of vectors to be summed (must be power of 2)
C
      subroutine s_locsum( vec, len, jmp, n )
      implicit none
      real vec(*)
      integer len, jmp, n
      integer i, j, l, ioff1, ioff2

      l = 1
      do while ( l .lt. n )
	  do i = 1, n, l*2
	      ioff1 = (i - 1) * jmp
	      ioff2 = (i - 1 + l ) * jmp
	      do j = 1, len
		   vec( j + ioff1 ) = 
     $                 vec( j + ioff1 ) + vec( j + ioff2 )
	      enddo
          enddo
	  l = l * 2
      enddo
      return
      end

