#include "params.h"
/* error_dup.c SCCS(1.2 92/10/06 10:27:44) */
/* redirect standard error from process into a file */
/* also redirect standard output to a file */

#include <stdio.h>
#include <fcntl.h>

#define STANDARD_ERROR 2

#define STANDARD_OUTPUT 1

#ifdef RS6000
void error_dup(me)
#else
void error_dup_(me)
#endif
int *me;
{
    int newfd ;
    char filename[256] ;

    if ( *me == 0 )
    {
        fprintf(stdout,"PCCM: redirecting stdout\n") ;
    }

/* redirect standard out*/
    if ( *me == 0 )
    {
        sprintf(filename,"pccm.out.%04d",*me) ;
    }
    else
    {
        sprintf(filename,"/dev/null") ; 
    }
    if ((newfd = open( filename, O_CREAT | O_WRONLY, 0666 )) < 0 )
    {
	perror("error_dup: cannot open pccm.out.nnnn") ;
	fprintf(stderr,"...sending error to standard error and continuing.\n") ;
	return ;
    }
    if( dup2( newfd, STANDARD_OUTPUT ) < 0 )
    {
	perror("error_dup: dup2 fails to change output descriptor") ;
	fprintf(stderr,"...sending error to standard error and continuing.\n") ;
	close(newfd) ;
	return ;
    }

/* redirect standard error */
#ifdef PP_ONE_FOR_ALL_ERROR
    if ( *me == 0 )
    {
        sprintf(filename,"pccm.error.%04d",*me) ;
    }
    else
    {
        sprintf(filename,"/dev/null") ;
    }
#else
        sprintf(filename,"pccm.error.%04d",*me) ;
#endif
    if ((newfd = open( filename, O_CREAT | O_WRONLY, 0666 )) < 0 )
    {
	perror("error_dup: cannot open pccm.error.log") ;
	fprintf(stderr,"...sending error to standard error and continuing.\n") ;
	return ;
    }
    if( dup2( newfd, STANDARD_ERROR ) < 0 )
    {
	perror("error_dup: dup2 fails to change error descriptor") ;
	fprintf(stderr,"...sending error to standard error and continuing.\n") ;
	close(newfd) ;
	return ;
    }

}

