#include "params.h"
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#ifdef PP_INTEL_PFS
extern int      gopen();
#define M_RECORD 3      /* Unshared file pointer, fixed record length,
                         * access in first come first served order, records
                         * are position dependent by logical node number.
                         */
#endif

static char mess[256] ;
static int statfd = -1  ;

static int file_n ;		/* restriction: only 1 file at a time */

#ifdef RS6000
read_restart( id, buf, n, nread )
#else
read_restart_( id, buf, n, nread )
#endif
int * id ;
int * n ;
int *nread ;
char *buf ;
{
    int i, got ;

    if ( statfd < 0 ) 
    {
	fprintf(stderr,"read_rstrt: restart file not opened.\n") ;
    }
    if ( *n < file_n )
    {
	fprintf(stderr,
	"read_restrt_: buffer of %d is too small for %d bytes in file\n",
	*n, file_n ) ;
	abort_("read_rstrt_",11) ;	/* src/abort.c */
    }

/* 95/03/07 -- this loop was added for the IBM SP.  It's probably good
   programming practice anyway.  (since it doesn't take the OS at it's
   word that a read on a regular file is guaranteed to read all bytes
   requested if they are there or return an error).   Don't bother changing
   for other platforsm, the loop will only execute once on OS's that do 
   follow their own specs.  */
    i = 0 ; 
    while ( i < file_n )
    {
      if (( got = read( *id, &(buf[i]), file_n-i )) < 0 )
      {
	perror("read_restrt_") ; 
	abort_("read_rstrt_",11) ;	/* src/abort.c */
      }
      i += got ;
    }
    *nread = i ;

#ifdef PP_ERROR
fprintf(stderr,"read_restart: debug: buf len %d, should %d, did %d\n",
      *n,file_n,*nread) ;
#endif
}

/* this routine is used by rdrs1_a.F, the one-to-all reader for
   single file input.  Note that for these files, there are
   no length words at the beginning of the data.  Perhaps this
   should be removed for the each-processor-reads scheme too, 
   although it does allow the processor to read in all its data
   at once, supposedly speeding up input. */
#ifdef RS6000
read_column( id, buf, n, nread )
#else
read_column_( id, buf, n, nread )
#endif
    int * id ;
    char * buf ;
    int * n ;
    int * nread ;
{
    if ( statfd < 0 )
    {
        fprintf(stderr,"read_column: restart file not opened.\n") ;
    };
    if (( *nread = read( *id, buf, *n )) < 0 )
    {
        perror("read_column") ;
	abort_("read_column",11) ;
    }
    if ( (*nread != *n) && (*nread != 0))
    {
        fprintf(stderr,
        "read_column: WARNING only %d of %d bytes read\n", *nread, *n) ;
    }
}



#ifdef RS6000
read_length_info( id, n )
#else
read_length_info_( id, n )
#endif
int * id ;
int * n ;
{
    struct stat statbuf ;

    if ( statfd < 0 )
    {
        fprintf(stderr,"read_rstrt: restart file not opened.\n") ;
    }
    /* 95/03/07 -- converted to use fstat instead, allowing us to
       get rid of the four byte length record at the beginning */

    if ( fstat( *id, &statbuf ) < 0 )
    {
        perror("read_length_info: can't stat file") ;
	abort_("read_length_info",11) ;
    }

    *n = statbuf.st_size ;
    file_n = *n ;
#ifdef PP_INTEL_PFS
    file_n = file_n/PP_NPROC;
#endif

#ifdef PP_ERROR
    fprintf(stderr,"read_length_info: returns file size of %d bytes\n",file_n) ;
#endif
}


#ifdef RS6000
restart_ropen(m_pin, name,len0,id)
#else
restart_ropen_(m_pin, name,len0,id)
#endif
    int *m_pin ;
    char * name ;
    int *len0, *id ;
{
    int i ;
    int me ;
    int nodes ;
    int numvols ;
    int vollst[128] ;
    char tname[200] ;
    char fname[200] ;
    int len ;

    len = *len0 ;
    if ( len > 199 ) len = 199 ;

    strncpy( tname, name, len ) ;
    tname[len] = '\0' ;

    if ( *m_pin >= 0 )
    {
#ifdef PP_INTEL_PFS
	sprintf( fname, "%s", tname ) ;
#else
	sprintf( fname, "%s.%04d", tname, *m_pin ) ;
#endif
    }
    else
    {
	strcpy( fname, tname ) ;
    }


#ifdef PP_INTEL_PFS
    if ((statfd = gopen( fname, O_RDONLY, M_RECORD, 0 )) < 0 )
#else
    if ((statfd = open( fname, O_RDONLY, 0 )) < 0 )
#endif
    {
	fprintf(stderr,"cannot open %s for reading\n",fname ) ;
	perror("restart_ropen") ;
	exit(2) ;
    }
#ifdef PP_ERROR
    else
    {
	fprintf(stderr,"successfully opens %s for reading\n",fname ) ;
    }
#endif
    *id = statfd ;
}

#ifdef RS6000
restart_rclose()
#else
restart_rclose_()
#endif
{
    statfd = -1 ;
    file_n = -1 ;
    close( statfd ) ;
}


#ifdef RS6000
get_column( data, curs, buf, n, nread )
#else
get_column_( data, curs, buf, n, nread )
#endif
char * data ;
int  * curs ;
char * buf ;
int  * n ;
int  * nread ;
{
    int i ;

#if 0
    fprintf(stderr,"get_column curs=%d, n=%d, nread=%d ",
	 *curs, *n, *nread ) ;
#endif

    for ( i = 0 ; (i < *n) && (*curs < file_n) ; i++ )
    {
	buf[i] = data[*curs] ;
	*curs = *curs + 1 ;
    }

    *nread = i ;
#if 0
    fprintf(stderr," | nread = %d\n", *nread ) ;
#endif
}
