#include "params.h"
      subroutine grcalc(irow    ,ztodt   ,
     $                  grts    ,grths   ,grqs    ,grqhs   ,grds    ,
     $                  grzs    ,grus    ,gruhs   ,grvs    ,grvhs   ,
     $                  grpss   ,grdpss  ,grpms   ,grpls   ,
     $                  grta    ,grtha   ,grqa    ,grqha   ,grda    ,
     $                  grza    ,grua    ,gruha   ,grva    ,grvha   ,
     $                  grpsa   ,grdpsa  ,grpma   ,grpla)
C-----------------------------------------------------------------------
C Compute legendre transforms from spectral to grid.
C Note: contains synch mods.  NSHPER assumed = 1.
C "s" suffix to variable => symetric component
C "a" suffix to variable => anti-symetric component
C Rewritten/tested by J. Rosinski 11/14/89
C-----------------------------------------------------------------------
c inserted by implnone
      implicit none
#include "pmgrid.com"
#include "pagrid.com"
#include "pspect.com"
C----------------------------------------------------------------------
#include "comcon.com"
C----------------------------------------------------------------------
#include "comhd.com"
C-----------------------------------------------------------------------
#include "commap.com"
C----------------------------------------------------------------------
#include "comspe.com"
C-----------------------------------------------------------------------
#ifdef PP_PCCM
#include "comparll.com"
#endif
C-----------------------------------------------------------------------
C
C Input variables
C
      integer irow
      real ztodt
C
C Output variables
C
      real grts(plond,plev),
     $     grths(plond,plev),
     $     grqs(plond,plev),
     $     grqhs(plond,plev),
     $     grds(plond,plev),
     $     grzs(plond,plev)
      real grus(plond,plev),
     $     gruhs(plond,plev),
     $     grvs(plond,plev),
     $     grvhs(plond,plev),
     $     grpss(plond),
     $     grdpss(plond),
     $     grpms(plond),
     $     grpls(2,*),
     $     grta(plond,plev),
     $     grtha(plond,plev)
      real grqa(plond,plev),
     $     grqha(plond,plev),
     $     grda(plond,plev),
     $     grza(plond,plev),
     $     grua(plond,plev),
     $     gruha(plond,plev),
     $     grva(plond,plev),
     $     grvha(plond,plev),
     $     grpsa(plond),
     $     grdpsa(plond)
      real grpma(plond),
     $     grpla(2,*)
C
C Local workspace
C
      real gru1s(plond),
     $     gruh1s(plond),
     $     grv1s(plond),
     $     grvh1s(plond),
     $     gru1a(plond),
     $     gruh1a(plond),
     $     grv1a(plond),
     $     grvh1a(plond),
     $     alpn(pspt),
     $     dalpn(pspt)
c declarations inserted by implnone
      real raxm,tmp,tmpi,tmpr,zurcor
c declarations inserted by implnone
      integer i,ii,ir,k,m,mc,mck,mr,n
#ifdef PP_PCCM
      integer mm, mt
#endif
C
C Compute alpn and dalpn
C
#ifdef PP_PCCM
      do mm = m_fwavbeg, m_fwavend
	 mt = m_mtrue(mm)
         mr = m_offalp(mm)
         raxm = ra*xm(mt+1)
         do n=1,m_lenalp(mm)
            alpn(mr+n) = alp(mr+n,irow)*rsq(mt+n)*raxm
            dalpn(mr+n) = dalp(mr+n,irow)*rsq(mt+n)*ra
         end do
         if (mt .eq. 0) zurcor = ez*dalpn(mr+2)
      end do
#else
      do m=1,pmmax
         mr = nstart(m)
         raxm = ra*xm(m)
         do n=1,nlen(m)
            alpn(mr+n) = alp(mr+n,irow)*rsq(m+n-1)*raxm
            dalpn(mr+n) = dalp(mr+n,irow)*rsq(m+n-1)*ra
         end do
      end do
      zurcor = ez*dalpn(2)
#endif
C
C Computation for plev-level variables
C
      do k=1,plev
C
C Initialize local sums
C
         do i=1,plon
            gru1s(i) = 0.
            gruh1s(i) = 0.
            grv1s(i) = 0.
            grvh1s(i) = 0.
            gru1a(i) = 0.
            gruh1a(i) = 0.
            grv1a(i) = 0.
            grvh1a(i) = 0.
         end do
C
C Loop over n for t,q,d,and end of u and v
C

#ifdef PP_PCCM
         do mm = m_fwavbeg, m_fwavend
	    mt = m_mtrue(mm)
	    m  = m_fwavdex(mm)
	    mr = m_offalp(mm)
            mc = 2*mr
            mck = (k-1)*m_nspect2 + mc
            do n=1,m_lenalp(mm),2
#else
         do m=1,pmmax
            mr = nstart(m)
            mc = 2*mr
            mck = (k-1)*psp + mc
CDIR$ IVDEP
            do n=1,nlen(m),2
#endif
               ir = mck + 2*n - 1
               ii = ir + 1
               grts (2*m-1,k) = grts (2*m-1,k) + t(ir)*alp(mr+n,irow)
               grts (2*m  ,k) = grts (2*m  ,k) + t(ii)*alp(mr+n,irow)
c
#ifdef PP_PCCM
               tmp = alp(mr+n,irow)*hdiftq(n+mt,k)
#else
               tmp = alp(mr+n,irow)*hdiftq(n+m-1,k)
#endif
               grths(2*m-1,k) = grths(2*m-1,k) - t(ir)*tmp
               grths(2*m  ,k) = grths(2*m  ,k) - t(ii)*tmp
c
               grqs (2*m-1,k) = grqs (2*m-1,k) + q(ir)*alp(mr+n,irow)
               grqs (2*m  ,k) = grqs (2*m  ,k) + q(ii)*alp(mr+n,irow)
c
               grqhs(2*m-1,k) = grqhs(2*m-1,k) - q(ir)*tmp
               grqhs(2*m  ,k) = grqhs(2*m  ,k) - q(ii)*tmp
c
               grds(2*m-1,k) = grds(2*m-1,k) + d(ir)*alp(mr+n,irow)
               grds(2*m  ,k) = grds(2*m  ,k) + d(ii)*alp(mr+n,irow)
c
               grzs(2*m-1,k) = grzs(2*m-1,k) + vz(ir)*alp(mr+n,irow)
               grzs(2*m  ,k) = grzs(2*m  ,k) + vz(ii)*alp(mr+n,irow)
c
               grua (2*m-1,k) = grua (2*m-1,k) + vz(ir)*dalpn(mr+n)
               grua (2*m  ,k) = grua (2*m  ,k) + vz(ii)*dalpn(mr+n)
c
#ifdef PP_PCCM
               tmp = dalpn(mr+n)*hdifzd(n+mt,k)
#else
               tmp = dalpn(mr+n)*hdifzd(n+m-1,k)
#endif
               gruha(2*m-1,k) = gruha(2*m-1,k) - vz(ir)*tmp
               gruha(2*m  ,k) = gruha(2*m  ,k) - vz(ii)*tmp
c
               grva (2*m-1,k) = grva (2*m-1,k) - d(ir)*dalpn(mr+n)
               grva (2*m  ,k) = grva (2*m  ,k) - d(ii)*dalpn(mr+n)
c
               grvha(2*m-1,k) = grvha(2*m-1,k) + d(ir)*tmp
               grvha(2*m  ,k) = grvha(2*m  ,k) + d(ii)*tmp
c
               gru1s (2*m-1) = gru1s (2*m-1) + d(ir)*alpn(mr+n)
               gru1s (2*m  ) = gru1s (2*m  ) + d(ii)*alpn(mr+n)
c
#ifdef PP_PCCM
               tmp = alpn(mr+n)*hdifzd(n+mt,k)
#else
               tmp = alpn(mr+n)*hdifzd(n+m-1,k)
#endif
               gruh1s(2*m-1) = gruh1s(2*m-1) - d(ir)*tmp
               gruh1s(2*m  ) = gruh1s(2*m  ) - d(ii)*tmp
c
               grv1s (2*m-1) = grv1s (2*m-1) + vz(ir)*alpn(mr+n)
               grv1s (2*m  ) = grv1s (2*m  ) + vz(ii)*alpn(mr+n)
c
               grvh1s(2*m-1) = grvh1s(2*m-1) - vz(ir)*tmp
               grvh1s(2*m  ) = grvh1s(2*m  ) - vz(ii)*tmp
            end do
         end do
#ifdef PP_PCCM
         do mm = m_fwavbeg, m_fwavend
	    mt = m_mtrue(mm)
	    m  = m_fwavdex(mm)
	    mr = m_offalp(mm)
            mc = 2*mr
            mck = (k-1)*m_nspect2 + mc
            do n=2,m_lenalp(mm),2
#else
         do m=1,pmmax
            mr = nstart(m)
            mc = 2*mr
            mck = (k-1)*psp + mc
CDIR$ IVDEP
            do n=2,nlen(m),2
#endif
               ir = mck + 2*n - 1
               ii = ir + 1
               grta (2*m-1,k) = grta (2*m-1,k) + t(ir)*alp(mr+n,irow)
               grta (2*m  ,k) = grta (2*m  ,k) + t(ii)*alp(mr+n,irow)
c
#ifdef PP_PCCM
               tmp = alp(mr+n,irow)*hdiftq(n+mt,k)
#else
               tmp = alp(mr+n,irow)*hdiftq(n+m-1,k)
#endif
               grtha(2*m-1,k) = grtha(2*m-1,k) - t(ir)*tmp
               grtha(2*m  ,k) = grtha(2*m  ,k) - t(ii)*tmp
c
               grqa (2*m-1,k) = grqa (2*m-1,k) + q(ir)*alp(mr+n,irow)
               grqa (2*m  ,k) = grqa (2*m  ,k) + q(ii)*alp(mr+n,irow)
c
               grqha(2*m-1,k) = grqha(2*m-1,k) - q(ir)*tmp
               grqha(2*m  ,k) = grqha(2*m  ,k) - q(ii)*tmp
c
               grda(2*m-1,k) = grda(2*m-1,k) + d(ir)*alp(mr+n,irow)
               grda(2*m  ,k) = grda(2*m  ,k) + d(ii)*alp(mr+n,irow)
c
               grza(2*m-1,k) = grza(2*m-1,k) + vz(ir)*alp(mr+n,irow)
               grza(2*m  ,k) = grza(2*m  ,k) + vz(ii)*alp(mr+n,irow)
c
               grus (2*m-1,k) = grus (2*m-1,k) + vz(ir)*dalpn(mr+n)
               grus (2*m  ,k) = grus (2*m  ,k) + vz(ii)*dalpn(mr+n)
c
#ifdef PP_PCCM
               tmp = dalpn(mr+n)*hdifzd(n+mt,k)
#else
               tmp = dalpn(mr+n)*hdifzd(n+m-1,k)
#endif
               gruhs(2*m-1,k) = gruhs(2*m-1,k) - vz(ir)*tmp
               gruhs(2*m  ,k) = gruhs(2*m  ,k) - vz(ii)*tmp
c
               grvs (2*m-1,k) = grvs (2*m-1,k) - d(ir)*dalpn(mr+n)
               grvs (2*m  ,k) = grvs (2*m  ,k) - d(ii)*dalpn(mr+n)
c
               grvhs(2*m-1,k) = grvhs(2*m-1,k) + d(ir)*tmp
               grvhs(2*m  ,k) = grvhs(2*m  ,k) + d(ii)*tmp
c
               gru1a (2*m-1) = gru1a (2*m-1) + d(ir)*alpn(mr+n)
               gru1a (2*m  ) = gru1a (2*m  ) + d(ii)*alpn(mr+n)
c
#ifdef PP_PCCM
               tmp = alpn(mr+n)*hdifzd(n+mt,k)
#else
               tmp = alpn(mr+n)*hdifzd(n+m-1,k)
#endif
               gruh1a(2*m-1) = gruh1a(2*m-1) - d(ir)*tmp
               gruh1a(2*m  ) = gruh1a(2*m  ) - d(ii)*tmp
c
               grv1a (2*m-1) = grv1a (2*m-1) + vz(ir)*alpn(mr+n)
               grv1a (2*m  ) = grv1a (2*m  ) + vz(ii)*alpn(mr+n)
c
               grvh1a(2*m-1) = grvh1a(2*m-1) - vz(ir)*tmp
               grvh1a(2*m  ) = grvh1a(2*m  ) - vz(ii)*tmp
            end do
         end do
C
C Final computation of um and vm
C
cdir$ ivdep
#ifdef PP_PCCM
         do mm = m_fwavbeg, m_fwavend
	    m = m_fwavdex(mm)
#else
         do m=1,pmmax
#endif
c
c Symmetric
c
            grus (2*m-1,k) = grus (2*m-1,k) + gru1s (2*m  )
            gruhs(2*m-1,k) = gruhs(2*m-1,k) + gruh1s(2*m  )
            grus (2*m  ,k) = grus (2*m  ,k) - gru1s (2*m-1)
            gruhs(2*m  ,k) = gruhs(2*m  ,k) - gruh1s(2*m-1)
            grvs (2*m-1,k) = grvs (2*m-1,k) + grv1s (2*m  )
            grvhs(2*m-1,k) = grvhs(2*m-1,k) + grvh1s(2*m  )
            grvs (2*m  ,k) = grvs (2*m  ,k) - grv1s (2*m-1)
            grvhs(2*m  ,k) = grvhs(2*m  ,k) - grvh1s(2*m-1)
C
C Anti-symmetric
C
            grua (2*m-1,k) = grua (2*m-1,k) + gru1a (2*m  )
            gruha(2*m-1,k) = gruha(2*m-1,k) + gruh1a(2*m  )
            grua (2*m  ,k) = grua (2*m  ,k) - gru1a (2*m-1)
            gruha(2*m  ,k) = gruha(2*m  ,k) - gruh1a(2*m-1)
            grva (2*m-1,k) = grva (2*m-1,k) + grv1a (2*m  )
            grvha(2*m-1,k) = grvha(2*m-1,k) + grvh1a(2*m  )
            grva (2*m  ,k) = grva (2*m  ,k) - grv1a (2*m-1)
            grvha(2*m  ,k) = grvha(2*m  ,k) - grvh1a(2*m-1)
         end do
C
C Correction for u:zeta=vz-ez=(zeta+f)-f
C
#ifdef PP_PCCM
         if ( l_pwave0 ) then
            grus(m_pwave0_dex,k) = grus(m_pwave0_dex,k) - zurcor
	 endif
#else
         grus(1,k) = grus(1,k) - zurcor
#endif
      end do
C
C Computation for 1-level variables (ln(p*) and derivatives).
C
#ifdef PP_PCCM
      do mm = m_fwavbeg, m_fwavend
	 mt = m_mtrue(mm)
	 m  = m_fwavdex(mm)
	 mr = m_offalp(mm)
         mc = 2*mr
         do n=1,m_lenalp(mm),2
#else
      do m=1,pmmax
         mr = nstart(m)
         mc = 2*mr
         do n=1,nlen(m),2
#endif
            ir = mc + 2*n - 1
            ii = ir + 1
c
            tmpr = alps(ir)*alp(mr+n,irow)
            tmpi = alps(ii)*alp(mr+n,irow)
            grpss(2*m-1) = grpss(2*m-1) + tmpr
            grpss(2*m  ) = grpss(2*m  ) + tmpi
c
#ifdef PP_PCCM
            grdpss(2*m-1) = grdpss(2*m-1) + tmpr*hdfst4(mt+n)*ztodt
            grdpss(2*m  ) = grdpss(2*m  ) + tmpi*hdfst4(mt+n)*ztodt
#else
            grdpss(2*m-1) = grdpss(2*m-1) + tmpr*hdfst4(m+n-1)*ztodt
            grdpss(2*m  ) = grdpss(2*m  ) + tmpi*hdfst4(m+n-1)*ztodt
#endif
c
            grpma(2*m-1) = grpma(2*m-1) + alps(ir)*dalp(mr+n,irow)*ra
            grpma(2*m  ) = grpma(2*m  ) + alps(ii)*dalp(mr+n,irow)*ra
         end do
      end do
#ifdef PP_PCCM
      do mm = m_fwavbeg, m_fwavend
	 mt = m_mtrue(mm)
	 m  = m_fwavdex(mm)
	 mr = m_offalp(mm)
         mc = 2*mr
         do n=2,m_lenalp(mm),2
#else
      do m=1,pmmax
         mr = nstart(m)
         mc = 2*mr
         do n=2,nlen(m),2
#endif
            ir = mc + 2*n - 1
            ii = ir + 1
c
            tmpr = alps(ir)*alp(mr+n,irow)
            tmpi = alps(ii)*alp(mr+n,irow)
            grpsa(2*m-1) = grpsa(2*m-1) + tmpr
            grpsa(2*m  ) = grpsa(2*m  ) + tmpi
c
#ifdef PP_PCCM
            grdpsa(2*m-1) = grdpsa(2*m-1) + tmpr*hdfst4(mt+n)*ztodt
            grdpsa(2*m  ) = grdpsa(2*m  ) + tmpi*hdfst4(mt+n)*ztodt
#else
            grdpsa(2*m-1) = grdpsa(2*m-1) + tmpr*hdfst4(m+n-1)*ztodt
            grdpsa(2*m  ) = grdpsa(2*m  ) + tmpi*hdfst4(m+n-1)*ztodt
#endif
c
            grpms(2*m-1) = grpms(2*m-1) + alps(ir)*dalp(mr+n,irow)*ra
            grpms(2*m  ) = grpms(2*m  ) + alps(ii)*dalp(mr+n,irow)*ra
         end do
      end do
C
C Multiply by m/a to get d(ln(p*))/dlamda
C and by 1/a to get (1-mu**2)d(ln(p*))/dmu
C
#ifdef PP_PCCM
      do mm=m_fwavbeg, m_fwavend
	 m  = m_fwavdex(mm)
	 mt = m_mtrue(mm)+1
         grpls(1,m) = -grpss(2*m  )*ra*xm(mt)
         grpls(2,m) =  grpss(2*m-1)*ra*xm(mt)
         grpla(1,m) = -grpsa(2*m  )*ra*xm(mt)
         grpla(2,m) =  grpsa(2*m-1)*ra*xm(mt)
      end do
#else
      do m=1,pmmax
         grpls(1,m) = -grpss(2*m  )*ra*xm(m)
         grpls(2,m) =  grpss(2*m-1)*ra*xm(m)
         grpla(1,m) = -grpsa(2*m  )*ra*xm(m)
         grpla(2,m) =  grpsa(2*m-1)*ra*xm(m)
      end do
#endif
      return
      end
