#include "params.h"
#ifdef PP_TRIANG_TRUNC
#ifdef PP_PCCM
      subroutine quad(mm       ,doslt   ,zdt     ,ztdtsq  ,grlps1  ,
     $                grlps2  ,grt1    ,grq1    ,grz1    ,grd1    ,
     $                grfu1   ,grfv1   ,grvt1   ,grvq1   ,grrh1   ,
     $                grt2    ,grq2    ,grz2    ,grd2    ,grfu2   ,
     $                grfv2   ,grvt2   ,grvq2   ,grrh2)
C-----------------------------------------------------------------------
      implicit none
#include "pmgrid.com"
#include "pagrid.com"
#include "pspect.com"
C---------------------------------------------------------------------
#include "comcon.com"
C---------------------------------------------------------------------
#include "commap.com"
C---------------------------------------------------------------------
#include "comspe.com"
#include "comparll.com"
C---------------------------------------------------------------------
C
C Input arguments
C
      integer mm
      logical doslt
      real zdt
      real ztdtsq(pnmax)

c parallel fft needs full size
      real grlps1(plon,plat/2),
     $     grlps2(plon,plat/2)
      real grt1(plon,plev,plat/2),
     $     grq1(plon,plev,plat/2),
     $     grz1(plon,plev,plat/2),
     $     grd1(plon,plev,plat/2),
     $     grfu1(plon,plev,plat/2),
     $     grfv1(plon,plev,plat/2),
     $     grvt1(plon,plev,plat/2),
     $     grvq1(plon,plev,plat/2),
     $     grrh1(plon,plev,plat/2)
      real grt2(plon,plev,plat/2),
     $     grq2(plon,plev,plat/2),
     $     grz2(plon,plev,plat/2),
     $     grd2(plon,plev,plat/2),
     $     grfu2(plon,plev,plat/2),
     $     grfv2(plon,plev,plat/2),
     $     grvt2(plon,plev,plat/2),
     $     grvq2(plon,plev,plat/2),
     $     grrh2(plon,plev,plat/2)

c
c Local workspace
c
      real zw(plat/2),
     $     ztdtrw(plat/2)
      real arrout(psp)

      real dummy
      integer m
      integer malp, n_len, n_len2, mfc, mfr
      integer ix, ip, iq, mt
      integer n_spect
      integer nv	! this will be 3 if doslt is true, 4 otherwise

      real zcsj,zdtrc,zrcsj,ztdtrc,zwalp,zwdalp
      integer ii,ir,j,k,mc,mck,mr,n
      integer isp, im
c
#define VX1(I) vx(I)
#define NV 3
#define VX2(I,S) vx(I*nv+S*nv*n_len2)
#define IVX(I,S) (I+S*n_len2)
c
      integer ptmp
      parameter (ptmp = max((p_log2plat-1),1))
      real vx((NV+1)*2*pmmax*ptmp)

      doslt = .true.
      if ( doslt ) then
          nv = NV
      else
          nv = NV+1
      endif
      mt = m_mtrue(mm)
      m  = m_fwavdex(mm)
      mr = m_offalp(mm)
      mc = 2*mr
      n_len = m_lenalp(mm)
      n_len2 = n_len*2
      n_spect = m_offalp(m_fwavend)+m_lenalp(m_fwavend)

      rearth =  6.37122E+6
      do j=1,plat/2
         zcsj = cs(j)*rearth
         zrcsj = 1./zcsj
         zdtrc = zdt*zrcsj
         ztdtrc = 2.*zdtrc
         zw(j) = w(j)*2.
         ztdtrw(j) = ztdtrc*zw(j)
      end do

C
C CONTRIBUTIONS TO SPECTRAL FIELDS.  LN(P*) FIRST
C
      isp = -1
      do j=1,plat/2

	 if ( mod( j-1, 2 ) .eq. 0 ) then
	    isp = isp + 1
            ir = IVX((mc),isp)
	    do ix = isp*n_len2+1, isp*n_len2+n_len2
               ir = ir + 1
	       alps(ir) = 0.0
	    enddo
	 endif

         do n=1,m_lenalp(mm),2
            ir = IVX((mc + 2*n - 1),isp)
            ii = ir + 1
            zwalp = zw(j)*alp(mr+n,j)
            alps(ir) = alps(ir) + grlps1(2*m-1,j)*zwalp
            alps(ii) = alps(ii) + grlps1(2*m  ,j)*zwalp
         end do
         do n=2,m_lenalp(mm),2
            ir = IVX((mc + 2*n - 1),isp)
            ii = ir + 1
            zwalp = zw(j)*alp(mr+n,j)
            alps(ir) = alps(ir) + grlps2(2*m-1,j)*zwalp
            alps(ii) = alps(ii) + grlps2(2*m  ,j)*zwalp
         end do

	 if ( mod( j-1, 2 ) .eq. 1 ) then
	    im = ( j-1 ) /2
	    do while ( mod( im, 2 ) .eq. 1 )
	       ip = isp * n_len2 + mc
	       isp = isp - 1
	       iq = isp * n_len2 + mc
     	       do ix = 1, n_len2
		  alps(iq+ix) = alps(iq+ix) + alps(ip+ix)
	       enddo
	       im = im / 2
	    enddo
	 endif

      end do

#define T(I)  VX1(I)
#define D(I)  VX1(I+1)
#define VZ(I) VX1(I+2)
#define Q(I) VX1(I+3)

      do k=1,plev

	 isp = -1
         mck = (k-1)*psp + mc
         do j=1,plat/2

	    if ( mod( j-1, 2 ) .eq. 0 ) then
	       isp = isp + 1
	       do ix = isp*n_len2*nv+1, isp*n_len2*nv+n_len2*nv
		   VX1(ix) = 0.0
	       enddo
	    endif

            do n=1,m_lenalp(mm),2
               zwdalp = ztdtrw(j)*dalp(mr+n,j)
               zwalp  = zw(j)*alp (mr+n,j)
	       ir = IVX((2*nv*n-2*nv+1),isp*nv)
	       ii = ir + nv
               T(ir) = T(ir) + zwalp*grt1 (2*m-1,k,j) +
     $                        zwdalp*grvt2(2*m-1,k,j)
               T(ii) = T(ii) + zwalp*grt1 (2*m  ,k,j) +
     $                        zwdalp*grvt2(2*m  ,k,j)
               D(ir) = D(ir) + (grd1(2*m-1,k,j) +
     $                      ztdtsq(n+mt)*grrh1(2*m-1,k,j))*zwalp -
     $                      grfv2(2*m-1,k,j)*zwdalp
               D(ii) = D(ii) + (grd1(2*m  ,k,j) +
     $                      ztdtsq(n+mt)*grrh1(2*m  ,k,j))*zwalp -
     $                      grfv2(2*m  ,k,j)*zwdalp
               VZ(ir) = VZ(ir) + grz1(2*m-1,k,j)*zwalp +
     $                       grfu2(2*m-1,k,j)*zwdalp
               VZ(ii) = VZ(ii) + grz1(2*m  ,k,j)*zwalp +
     $                       grfu2(2*m  ,k,j)*zwdalp
            end do
            do n=2,m_lenalp(mm),2
               zwdalp = ztdtrw(j)*dalp(mr+n,j)
               zwalp  = zw(j)*alp (mr+n,j)
	       ir = IVX((2*nv*n-2*nv+1),isp*nv)
	       ii = ir + nv
               T(ir) = T(ir) + zwalp*grt2(2*m-1,k,j) +
     $                      grvt1(2*m-1,k,j)*zwdalp
               T(ii) = T(ii) + zwalp*grt2(2*m  ,k,j) +
     $                      grvt1(2*m  ,k,j)*zwdalp
               D(ir) = D(ir) + (grd2(2*m-1,k,j) +
     $                      ztdtsq(n+mt)*grrh2(2*m-1,k,j))*zwalp -
     $                      grfv1(2*m-1,k,j)*zwdalp
               D(ii) = D(ii) + (grd2(2*m  ,k,j) +
     $                      ztdtsq(n+mt)*grrh2(2*m  ,k,j))*zwalp -
     $                      grfv1(2*m  ,k,j)*zwdalp
               VZ(ir) = VZ(ir) + grz2(2*m-1,k,j)*zwalp +
     $                       grfu1(2*m-1,k,j)*zwdalp
               VZ(ii) = VZ(ii) + grz2(2*m  ,k,j)*zwalp +
     $                       grfu1(2*m  ,k,j)*zwdalp
            end do
	    if ( .not. doslt ) then
	       do n=1,m_lenalp(mm),2
                  zwdalp = ztdtrw(j)*dalp(mr+n,j)
                  zwalp  = zw(j)*alp (mr+n,j)
	          ir = IVX((2*nv*n-2*nv+1),isp*nv)
	          ii = ir + nv
	          Q(ir) = Q(ir) + zwalp*grq1(2*m-1,k,j) +
     $                          grvq2(2*m-1,k,j)*zwdalp
                  Q(ii) = Q(ii) + zwalp*grq2(1*m  ,k,j) +
     $                          grvq2(2*m  ,k,j)*zwdalp
	       enddo
	       do n=2,m_lenalp(mm),2
                  zwdalp = ztdtrw(j)*dalp(mr+n,j)
                  zwalp  = zw(j)*alp (mr+n,j)
	          ir = IVX((2*nv*n-2*nv+1),isp*nv)
	          ii = ir + nv
	          Q(ir) = Q(ir) + zwalp*grq2(2*m-1,k,j) +
     $                          grvq1(2*m-1,k,j)*zwdalp
                  Q(ii) = Q(ii) + zwalp*grq2(2*m  ,k,j) +
     $                          grvq1(2*m  ,k,j)*zwdalp
               enddo
            endif

	    if ( mod( j-1, 2 ) .eq. 1 ) then
	       im = ( j-1 ) /2
	       do while ( mod( im, 2 ) .eq. 1 )
		  ip = isp * n_len2 * nv
		  isp = isp - 1
		  iq = isp * n_len2 * nv
		  do ix = 1, n_len2 * nv
		     VX1(iq+ix) = VX1(iq+ix) + VX1(ip+ix)
		  enddo
		  im = im / 2
	       enddo
	    endif

	 end do ! j
	 im = (n_spect*(k-1) + m_offalp(mm))*2
         do ix = 1, n_len2*nv, nv
	     im = im + 1
     	     t(im)  = VX1(ix)
	     d(im)  = VX1(ix+1)
	     vz(im) = VX1(ix+2)
	 enddo
         if ( .not.doslt ) then
	    im = (n_spect*(k-1) + m_offalp(mm))*2
            do ix = 1, n_len2*nv, nv
	       im = im + 1
               q(im) = VX1(ix+3)
	    enddo
         endif
      end do ! k
      return
      end
#else
c original routine
      subroutine quad(m       ,doslt   ,zdt     ,ztdtsq  ,grlps1  ,
     $                grlps2  ,grt1    ,grq1    ,grz1    ,grd1    ,
     $                grfu1   ,grfv1   ,grvt1   ,grvq1   ,grrh1   ,
     $                grt2    ,grq2    ,grz2    ,grd2    ,grfu2   ,
     $                grfv2   ,grvt2   ,grvq2   ,grrh2)
C-----------------------------------------------------------------------
c inserted by implnone
      implicit none
#include "pagrid.com"
#include "pspect.com"
C---------------------------------------------------------------------
#include "comcon.com"
C---------------------------------------------------------------------
#include "commap.com"
C---------------------------------------------------------------------
#include "comspe.com"
C---------------------------------------------------------------------
C
C Input arguments
C
      integer m
      logical doslt
      real zdt
      real ztdtsq(pnmax)
      real grlps1(2*pmmax,plat/2),
     $     grlps2(2*pmmax,plat/2)
      real grt1(2*pmmax,plev,plat/2),
     $     grq1(2*pmmax,plev,plat/2),
     $     grz1(2*pmmax,plev,plat/2),
     $     grd1(2*pmmax,plev,plat/2),
     $     grfu1(2*pmmax,plev,plat/2),
     $     grfv1(2*pmmax,plev,plat/2),
     $     grvt1(2*pmmax,plev,plat/2),
     $     grvq1(2*pmmax,plev,plat/2),
     $     grrh1(2*pmmax,plev,plat/2)
      real grt2(2*pmmax,plev,plat/2),
     $     grq2(2*pmmax,plev,plat/2),
     $     grz2(2*pmmax,plev,plat/2),
     $     grd2(2*pmmax,plev,plat/2),
     $     grfu2(2*pmmax,plev,plat/2),
     $     grfv2(2*pmmax,plev,plat/2),
     $     grvt2(2*pmmax,plev,plat/2),
     $     grvq2(2*pmmax,plev,plat/2),
     $     grrh2(2*pmmax,plev,plat/2)
c
c Local workspace
c
      real zw(plat/2),
     $     ztdtrw(plat/2)
      real arrout(psp)
c declarations inserted by implnone
      real zcsj,zdtrc,zrcsj,ztdtrc,zwalp,zwdalp
c declarations inserted by implnone
      integer ii,ir,j,k,mc,mck,mr,n
c
      mr = nstart(m)
      mc = 2*mr
c      write(6,*)'w=',w
      do j=1,plat/2
         zcsj = cs(j)*rearth
         zrcsj = 1./zcsj
         zdtrc = zdt*zrcsj
         ztdtrc = 2.*zdtrc
         zw(j) = w(j)*2.
         ztdtrw(j) = ztdtrc*zw(j)
      end do
C
C CONTRIBUTIONS TO SPECTRAL FIELDS.  LN(P*) FIRST
C
      do j=1,plat/2
         do n=1,nlen(m),2
            ir = mc + 2*n - 1
            ii = ir + 1
            zwalp = zw(j)*alp(mr+n,j)
            alps(ir) = alps(ir) + grlps1(2*m-1,j)*zwalp
            alps(ii) = alps(ii) + grlps1(2*m  ,j)*zwalp
         end do
         do n=2,nlen(m),2
            ir = mc + 2*n - 1
            ii = ir + 1
            zwalp = zw(j)*alp(mr+n,j)
            alps(ir) = alps(ir) + grlps2(2*m-1,j)*zwalp
            alps(ii) = alps(ii) + grlps2(2*m  ,j)*zwalp
         end do
      end do
      mr = nstart(m)
      mc = 2*mr
      do k=1,plev
         mck = (k-1)*psp + mc
         do j=1,plat/2
            do n=1,nlen(m),2
               zwdalp = ztdtrw(j)*dalp(mr+n,j)
               zwalp  = zw(j)*alp (mr+n,j)
               ir = mck + 2*n - 1
               ii = ir + 1
               t(ir) = t(ir) + zwalp*grt1 (2*m-1,k,j) +
     $                        zwdalp*grvt2(2*m-1,k,j)
               t(ii) = t(ii) + zwalp*grt1 (2*m  ,k,j) +
     $                        zwdalp*grvt2(2*m  ,k,j)
               d(ir) = d(ir) + (grd1(2*m-1,k,j) +
     $                      ztdtsq(n+m-1)*grrh1(2*m-1,k,j))*zwalp -
     $                      grfv2(2*m-1,k,j)*zwdalp
               d(ii) = d(ii) + (grd1(2*m  ,k,j) +
     $                      ztdtsq(n+m-1)*grrh1(2*m  ,k,j))*zwalp -
     $                      grfv2(2*m  ,k,j)*zwdalp
               vz(ir) = vz(ir) + grz1(2*m-1,k,j)*zwalp +
     $                       grfu2(2*m-1,k,j)*zwdalp
               vz(ii) = vz(ii) + grz1(2*m  ,k,j)*zwalp +
     $                       grfu2(2*m  ,k,j)*zwdalp
            end do
         end do
         if(.not.doslt) then
            do j=1,plat/2
               do n=1,nlen(m),2
                  zwdalp = ztdtrw(j)*dalp(mr+n,j)
                  zwalp  = zw(j)*alp (mr+n,j)
                  ir = mck + 2*n - 1
                  ii = ir + 1
                  q(ir) = q(ir) + zwalp*grq1(2*m-1,k,j) +
     $                          grvq2(2*m-1,k,j)*zwdalp
                  q(ii) = q(ii) + zwalp*grq1(2*m  ,k,j) +
     $                          grvq2(2*m  ,k,j)*zwdalp
               end do
            end do
         end if
         do j=1,plat/2
            do n=2,nlen(m),2
               zwdalp = ztdtrw(j)*dalp(mr+n,j)
               zwalp  = zw(j)*alp (mr+n,j)
               ir = mck + 2*n - 1
               ii = ir + 1
               t(ir) = t(ir) + zwalp*grt2(2*m-1,k,j) +
     $                      grvt1(2*m-1,k,j)*zwdalp
               t(ii) = t(ii) + zwalp*grt2(2*m  ,k,j) +
     $                      grvt1(2*m  ,k,j)*zwdalp
               d(ir) = d(ir) + (grd2(2*m-1,k,j) +
     $                      ztdtsq(n+m-1)*grrh2(2*m-1,k,j))*zwalp -
     $                      grfv1(2*m-1,k,j)*zwdalp
               d(ii) = d(ii) + (grd2(2*m  ,k,j) +
     $                      ztdtsq(n+m-1)*grrh2(2*m  ,k,j))*zwalp -
     $                      grfv1(2*m  ,k,j)*zwdalp
               vz(ir) = vz(ir) + grz2(2*m-1,k,j)*zwalp +
     $                       grfu1(2*m-1,k,j)*zwdalp
               vz(ii) = vz(ii) + grz2(2*m  ,k,j)*zwalp +
     $                       grfu1(2*m  ,k,j)*zwdalp
            end do
         end do
         if(.not.doslt) then
            do j=1,plat/2
               do n=2,nlen(m),2
                  zwdalp = ztdtrw(j)*dalp(mr+n,j)
                  zwalp  = zw(j)*alp (mr+n,j)
                  ir = mck + 2*n - 1
                  ii = ir + 1
                  q(ir) = q(ir) + zwalp*grq2(2*m-1,k,j) +
     $                          grvq1(2*m-1,k,j)*zwdalp
                  q(ii) = q(ii) + zwalp*grq2(2*m  ,k,j) +
     $                          grvq1(2*m  ,k,j)*zwdalp
               end do
            end do
         end if
      end do
      return
      end
#endif
#endif

#ifdef PP_RHOMB_TRUNC
#include "params.h"
      subroutine quad(mm      ,doslt   ,zdt     ,ztdtsq  ,grlps1  ,
     $                grlps2  ,grt1    ,grq1    ,grz1    ,grd1    ,
     $                grfu1   ,grfv1   ,grvt1   ,grvq1   ,grrh1   ,
     $                grt2    ,grq2    ,grz2    ,grd2    ,grfu2   ,
     $                grfv2   ,grvt2   ,grvq2   ,grrh2)
C-----------------------------------------------------------------------
c inserted by implnone
      implicit none
#include "pmgrid.com"
#include "pagrid.com"
#include "pspect.com"
C---------------------------------------------------------------------
#include "comcon.com"
C---------------------------------------------------------------------
#include "commap.com"
C---------------------------------------------------------------------
#include "comspe.com"
C---------------------------------------------------------------------
#include "comparll.com"
C---------------------------------------------------------------------
C
C Input arguments
C
      integer m, mm, mt
      logical doslt
      real zdt
      real ztdtsq(pnmax)
c parallel fft needs full size
      real grlps1(plon,plat/2),
     $     grlps2(plon,plat/2)
      real grt1(plon,plev,plat/2),
     $     grq1(plon,plev,plat/2),
     $     grz1(plon,plev,plat/2),
     $     grd1(plon,plev,plat/2),
     $     grfu1(plon,plev,plat/2),
     $     grfv1(plon,plev,plat/2),
     $     grvt1(plon,plev,plat/2),
     $     grvq1(plon,plev,plat/2),
     $     grrh1(plon,plev,plat/2)
      real grt2(plon,plev,plat/2),
     $     grq2(plon,plev,plat/2),
     $     grz2(plon,plev,plat/2),
     $     grd2(plon,plev,plat/2),
     $     grfu2(plon,plev,plat/2),
     $     grfv2(plon,plev,plat/2),
     $     grvt2(plon,plev,plat/2),
     $     grvq2(plon,plev,plat/2),
     $     grrh2(plon,plev,plat/2)
c
c Local workspace
c
      real zw(plat/2),
     $     ztdtrw(plat/2)
      real arrout(psp)
c declarations inserted by implnone
      real zcsj,zdtrc,zrcsj,ztdtrc,zwalp,zwdalp
c declarations inserted by implnone
      integer ii,ir,j,k,mc,mck,mr,n
c
      m  = m_fwavdex(mm)
      mt = m_mtrue(mm)
      mr = m_offalp(mm)
      mc = 2*mr
c      write(6,*)'w=',w
      do j=1,plat/2
         zcsj = cs(j)*rearth
         zrcsj = 1./zcsj
         zdtrc = zdt*zrcsj
         ztdtrc = 2.*zdtrc
         zw(j) = w(j)*2.
         ztdtrw(j) = ztdtrc*zw(j)
      end do
C
C CONTRIBUTIONS TO SPECTRAL FIELDS.  LN(P*) FIRST
C

c note that repro is not installed yet!!!!!!!!!!!!!!!!!!!!!

      do j=1,plat/2
         do n=1,m_lenalp(mm),2
            ir = mc + 2*n - 1
            ii = ir + 1
            zwalp = zw(j)*alp(mr+n,j)
            alps(ir) = alps(ir) + grlps1(2*m-1,j)*zwalp
            alps(ii) = alps(ii) + grlps1(2*m  ,j)*zwalp
         end do
         do n=2,m_lenalp(mm),2
            ir = mc + 2*n - 1
            ii = ir + 1
            zwalp = zw(j)*alp(mr+n,j)
            alps(ir) = alps(ir) + grlps2(2*m-1,j)*zwalp
            alps(ii) = alps(ii) + grlps2(2*m  ,j)*zwalp
         end do
      end do

      mr = m_offalp(mm)
      mc = 2*mr
      do k=1,plev
         mck = (k-1)*m_nspect2 + mc
         do j=1,plat/2
            do n=1,m_lenalp(mm),2
               zwdalp = ztdtrw(j)*dalp(mr+n,j)
               zwalp  = zw(j)*alp (mr+n,j)
               ir = mck + 2*n - 1
               ii = ir + 1
               t(ir) = t(ir) + zwalp*grt1 (2*m-1,k,j) +
     $                        zwdalp*grvt2(2*m-1,k,j)
               t(ii) = t(ii) + zwalp*grt1 (2*m  ,k,j) +
     $                        zwdalp*grvt2(2*m  ,k,j)
               d(ir) = d(ir) + (grd1(2*m-1,k,j) +
     $                      ztdtsq(n+mt)*grrh1(2*m-1,k,j))*zwalp -
     $                      grfv2(2*m-1,k,j)*zwdalp
               d(ii) = d(ii) + (grd1(2*m  ,k,j) +
     $                      ztdtsq(n+mt)*grrh1(2*m  ,k,j))*zwalp -
     $                      grfv2(2*m  ,k,j)*zwdalp
               vz(ir) = vz(ir) + grz1(2*m-1,k,j)*zwalp +
     $                       grfu2(2*m-1,k,j)*zwdalp
               vz(ii) = vz(ii) + grz1(2*m  ,k,j)*zwalp +
     $                       grfu2(2*m  ,k,j)*zwdalp
            end do
         end do
         if(.not.doslt) then
            do j=1,plat/2
               do n=1,m_lenalp(mm),2
                  zwdalp = ztdtrw(j)*dalp(mr+n,j)
                  zwalp  = zw(j)*alp (mr+n,j)
                  ir = mck + 2*n - 1
                  ii = ir + 1
                  q(ir) = q(ir) + zwalp*grq1(2*m-1,k,j) +
     $                          grvq2(2*m-1,k,j)*zwdalp
                  q(ii) = q(ii) + zwalp*grq1(2*m  ,k,j) +
     $                          grvq2(2*m  ,k,j)*zwdalp
               end do
            end do
         end if
         do j=1,plat/2
            do n=2,m_lenalp(mm),2
               zwdalp = ztdtrw(j)*dalp(mr+n,j)
               zwalp  = zw(j)*alp (mr+n,j)
               ir = mck + 2*n - 1
               ii = ir + 1
               t(ir) = t(ir) + zwalp*grt2(2*m-1,k,j) +
     $                      grvt1(2*m-1,k,j)*zwdalp
               t(ii) = t(ii) + zwalp*grt2(2*m  ,k,j) +
     $                      grvt1(2*m  ,k,j)*zwdalp
               d(ir) = d(ir) + (grd2(2*m-1,k,j) +
     $                      ztdtsq(n+mt)*grrh2(2*m-1,k,j))*zwalp -
     $                      grfv1(2*m-1,k,j)*zwdalp
               d(ii) = d(ii) + (grd2(2*m  ,k,j) +
     $                      ztdtsq(n+mt)*grrh2(2*m  ,k,j))*zwalp -
     $                      grfv1(2*m  ,k,j)*zwdalp
               vz(ir) = vz(ir) + grz2(2*m-1,k,j)*zwalp +
     $                       grfu1(2*m-1,k,j)*zwdalp
               vz(ii) = vz(ii) + grz2(2*m  ,k,j)*zwalp +
     $                       grfu1(2*m  ,k,j)*zwdalp
            end do
         end do
         if(.not.doslt) then
            do j=1,plat/2
               do n=2,m_lenalp(mm),2
                  zwdalp = ztdtrw(j)*dalp(mr+n,j)
                  zwalp  = zw(j)*alp (mr+n,j)
                  ir = mck + 2*n - 1
                  ii = ir + 1
                  q(ir) = q(ir) + zwalp*grq2(2*m-1,k,j) +
     $                          grvq1(2*m-1,k,j)*zwdalp
                  q(ii) = q(ii) + zwalp*grq2(2*m  ,k,j) +
     $                          grvq1(2*m  ,k,j)*zwdalp
               end do
            end do
         end if
      end do
      return
      end
#endif
