c wrapper for real fast Fourier transform of longitude data
c 3/8/95 - P. Worley
#include "params.h"
      subroutine rftlon(data, work1, work2, jump, lth, nvect, isign)
      implicit none
#include "pmgrid.com"
#include "pspect.com"
#include "comparll.com"
#include "comfft.com"
#include "palgor.com"
#if ( defined(INTERVAL_TIMER) )
#include "timers.com"
#endif
c
      integer jump, lth, nvect, isign, m_type2, i
      real data(jump, nvect)
      real work1(*), work2(*)
c
c return immediately if nvect=0 to prevent
c array out-of-bounds conditions below
c RLJ 7/5/01
      if (nvect .eq. 0) return

      if ( isign .ne. 1 .and. isign .ne. -1 ) then
        call abortf('bad sign arg to rftlon')
      endif
c
#if (defined(PP_PCCM))
# ifdef INTERVAL_TIMER
      if ( isign .eq. 1) then
        call interval_timer( 1, TIMER_BwdFFT, 0 )
      else
        call interval_timer( 1, TIMER_FwdFFT, 0 )
      endif
# endif
c
# if (defined(PP_FFTX))
      if ( isign .eq. 1 ) then
        call bwd_fftx(data, work1, work2, nvect)
      else
        call fwd_fftx(data, work1, work2, nvect)
      endif
# else
c
      if (isign .eq. 1) then
        if (l_pwave0) then
c         "pack" the last Fourier coefficient into the first
c         complex value - assumes that last wavenumber is always 
c         truncated
          do i=1,nvect
            data(2*m_pwave0_dex,i) = 0.0
          enddo
        endif
      endif
c
      m_type2 = m_type + p_nproc
      call RFT_235(p_dfftopt, p_dfftprot, p_nproc_ln, maprow, m_pin_ln,
     &             m_type, m_type2, isign, lth,
     &             nvect, jump, mxtrigs, trig, work1, data)
      m_type = m_type2 + p_nproc
c
      if (isign .eq. -1) then
        if (l_pwave0) then
c         "unpack" the last Fourier coefficient from the 
c         first complex value - assumes that last wavenumber is always
c         truncated
          do i=1,nvect
            data(2*m_pwave0_dex,i)  = 0.0
          enddo
        endif
      endif
c
# endif
c
# ifdef INTERVAL_TIMER
      if ( isign .eq. 1) then
        call interval_timer( 0, TIMER_BwdFFT, 0 )
      else
        call interval_timer( 0, TIMER_FwdFFT, 0 )
      endif
# endif
c
#else
      call fft991(data, work1, trig, ifax, 1, jump, lth, nvect, 
     $            isign)
#endif
c
      return
      end

