#include "params.h"
      subroutine spegrd(irow    ,cwava   ,qfcst   ,
     $                  psm1    ,u3m1    ,v3m1    ,t3m1    ,q3m1    ,
     $                  q3      ,u3      ,v3      ,bpstr            ,
     $                  bz               ,bd               ,bduh    ,
     $                  bdvh             ,bdth             ,bdqh    ,
     $                  bdpsl            ,bdpsm            ,bdps    ,
     $                  pdela   ,hw2al   ,hw2bl   ,hw3al   ,hw3bl)
C-----------------------------------------------------------------------
c inserted by implnone
      implicit none
#include "pmgrid.com"
#include "pagrid.com"
#include "pspect.com"
C-----------------------------------------------------------------------
#include "comcon.com"
C-----------------------------------------------------------------------
#include "comctl.com"
C-----------------------------------------------------------------------
#include "comfft.com"
C---------------------------------------------------------------------
#include "comhd.com"
C---------------------------------------------------------------------
#include "comhyb.com"
C---------------------------------------------------------------------
#include "comlun.com"
C---------------------------------------------------------------------
#include "commap.com"
C---------------------------------------------------------------------
#include "comspe.com"
C-----------------------------------------------------------------------
#include "comtim.com"

#ifdef INTERVAL_TIMER
#include "timers.com"
#endif

C-----------------------------------------------------------------------
C
C Input arguments
C
      integer irow
#ifdef PP_PCCM
      real cwava,
     $     qfcst(plond,plev,pcnst,platd,2)
      real psm1(plond,plat),
     $     u3m1(plond,plevd,platd,2),
     $     v3m1(plond,plevd,platd,2),
     $     t3m1(plond,plevd,platd,2),
     $     q3m1(plond,plevd,platd,2),
     $     q3(plond,plevd,platd,2)
      real u3(plond,plevd,platd,2),
     $     v3(plond,plevd,platd,2)
#else
      real cwava,
     $     qfcst(plond,plev,pcnst,plat)
      real psm1(plond,plat),
     $     u3m1(plond,plevd,plat),
     $     v3m1(plond,plevd,plat),
     $     t3m1(plond,plevd,plat),
     $     q3m1(plond,plevd,plat),
     $     q3(plond,plevd,plat)
      real u3(plond,plevd,plat),
     $     v3(plond,plevd,plat)
#endif
      real bpstr(plond),     ! ps next to vort. for fft contiguity
     $     bz(plond,plev),
     $     bd(plond,plev),
     $     bduh(plond,plev),
     $     bdvh(plond,plev),
     $     bdth(plond,plev),
     $     bdqh(plond,plev),
     $     bdpsl(plond),
     $     bdpsm(plond),
     $     bdps(plond)
      real pdela(plond,plev),    ! del P(A)
#ifdef PP_PCCM
     $     hw2al (pcnst,plat),
     $     hw2bl (pcnst,plat),
     $     hw3al (pcnst,plat),
     $     hw3bl (pcnst,plat)
#else
     $     hw2al (pcnst,plat/2),
     $     hw2bl (pcnst,plat/2),
     $     hw3al (pcnst,plat/2),
     $     hw3bl (pcnst,plat/2)
#endif
C
C Local workspace
C
      real pmid(plond,plev),
     $     pint(plond,plevp),
     $     pdel(plond,plev),
     $     pdelb(plond,plev)    ! del P(B)
      real grdps(plond),
     $     grzs(plond,plev),
     $     grds(plond,plev),
     $     gruhs(plond,plev),
     $     grvhs(plond,plev),
     $     grths(plond,plev),
     $     grqhs(plond,plev),
     $     grpss(plond),
     $     grus(plond,plev),
     $     grvs(plond,plev),
     $     grts(plond,plev),
     $     grqs(plond,plev),
     $     grpls(plond),
     $     grpms(plond)
      real grdpa(plond),
     $     grza(plond,plev),
     $     grda(plond,plev),
     $     gruha(plond,plev),
     $     grvha(plond,plev),
     $     grtha(plond,plev),
     $     grqha(plond,plev),
     $     grpsa(plond),
     $     grua(plond,plev),
     $     grva(plond,plev),
     $     grta(plond,plev),
     $     grqa(plond,plev),
     $     grpla(plond),
     $     grpma(plond)
      real pspsr(plond)
#ifdef CRAY
      real work1((plon+1)*pcray)  ! Workspace for fft (Cray)
      real work2(1)
#else
# if (defined(PP_PCCM))
#  if (defined(PP_FFTX))
c     transpose parallel fft work space
      real work1(plond,4+6*plev)
      real work2(p_glon+2,((4+6*plev)/p_nproc_ln + 1)*2) 
#  else
c     distributed parallel fft work space
      real work1(plond,4+6*plev)
      real work2(1)
#  endif
# else
      real work1((plon+1)*(4+6*plev))   ! sequential definition
      real work2(1)
# endif
#endif
      real factor,sdot,ztodt,rcoslat
      integer i,ihem,inc,isign,k,klev,m,ntr2,ntr3
      integer lat               ! latitude index S->N
#ifdef PP_PCCM
      real repro_tmp(plon)
      real repro2_tmp(plon)
      real f_locsum
#include "comparll.com"
      integer ih                ! hemisphere 1=s, 2=n
      integer j
      integer mm
      real rbuf(2*(pcnst+1))
#endif
C
c
C Initialize slt integrals
C
      ztodt = twodt
      if(nstep.eq.0) ztodt = 0.5*ztodt
      inc = 1
      isign = +1
#ifndef PP_PCCM
      do 9 m=1,pcnst
         hw2al (m,irow) = 0.0
         hw2bl (m,irow) = 0.0
         hw3al (m,irow) = 0.0
         hw3bl (m,irow) = 0.0
    9 continue
#endif
C
C Zero those arrays into which GRCALC will accumulate sums
C
      call resetr(grdps,plond,0.)
      call resetr(grzs,plndlv,0.)
      call resetr(grds,plndlv,0.)
      call resetr(gruhs,plndlv,0.)
      call resetr(grvhs,plndlv,0.)
      call resetr(grths,plndlv,0.)
      call resetr(grqhs,plndlv,0.)
      call resetr(grpss,plond,0.)
      call resetr(grus,plndlv,0.)
      call resetr(grvs,plndlv,0.)
      call resetr(grts,plndlv,0.)
      call resetr(grqs,plndlv,0.)
      call resetr(grpls,plond,0.)
      call resetr(grpms,plond,0.)
c
      call resetr(grdpa,plond,0.)
      call resetr(grza,plndlv,0.)
      call resetr(grda,plndlv,0.)
      call resetr(gruha,plndlv,0.)
      call resetr(grvha,plndlv,0.)
      call resetr(grtha,plndlv,0.)
      call resetr(grqha,plndlv,0.)
      call resetr(grpsa,plond,0.)
      call resetr(grua,plndlv,0.)
      call resetr(grva,plndlv,0.)
      call resetr(grta,plndlv,0.)
      call resetr(grqa,plndlv,0.)
      call resetr(grpla,plond,0.)
      call resetr(grpma,plond,0.)
c
      call grcalc(irow    ,ztodt   ,
     $            grts    ,grths   ,grqs    ,grqhs   ,grds    ,
     $            grzs    ,grus    ,gruhs   ,grvs    ,grvhs   ,
     $            grpss   ,grdps   ,grpms   ,grpls   ,
     $            grta    ,grtha   ,grqa    ,grqha   ,grda    ,
     $            grza    ,grua    ,gruha   ,grva    ,grvha   ,
     $            grpsa   ,grdpa   ,grpma   ,grpla)

C
C Recompute real fields from symetric and antisymetric parts.
C
      do 90 ihem=1,2
         if(ihem.eq.1) then
C
C Northern hemisphere
C
#ifdef PP_PCCM
            ih = 2
            j = j1 + p_lato2 - irow
#endif
            lat = plat - irow + 1
            do 20 k=1,plev
               do 10 i=1,plonp2
                  bz(i,k) = grzs(i,k) + grza(i,k)
                  bd(i,k) = grds(i,k) + grda(i,k)
                  bduh(i,k) = gruhs(i,k) + gruha(i,k)
                  bdvh(i,k) = grvhs(i,k) + grvha(i,k)
                  bdth(i,k) = grths(i,k) + grtha(i,k)
#ifdef PP_PCCM
                  u3m1(i,k,j,ih) = grus(i,k) + grua(i,k)
                  v3m1(i,k,j,ih) = grvs(i,k) + grva(i,k)
                  t3m1(i,k,j,ih) = grts(i,k) + grta(i,k)
#else
                  u3m1(i,k,lat) = grus(i,k) + grua(i,k)
                  v3m1(i,k,lat) = grvs(i,k) + grva(i,k)
                  t3m1(i,k,lat) = grts(i,k) + grta(i,k)
#endif
   10          continue
   20       continue
            if(.not.doslt) then
               do 24 k=1,plev
                  do 22 i=1,plonp2
#ifdef PP_PCCM
                     q3m1(i,k,j,ih) = grqs(i,k) + grqa(i,k)
#else
                     q3m1(i,k,lat) = grqs(i,k) + grqa(i,k)
#endif
                     bdqh(i,k) = grqhs(i,k) + grqha(i,k)
   22             continue
   24          continue
            end if
            do 30 i=1,plonp2
               bdps(i) = grdps(i) + grdpa(i)
               psm1(i,lat) = grpss(i) + grpsa(i)
               bdpsl(i) = grpls(i) + grpla(i)
               bdpsm(i) = grpms(i) + grpma(i)
   30       continue
         else
C
C Southern hemisphere
C
#ifdef PP_PCCM
            j = j1m + irow
            ih = 1
#endif
            lat = irow
            do 50 k=1,plev
               do 40 i=1,plonp2
                  bz(i,k) = grzs(i,k) - grza(i,k)
                  bd(i,k) = grds(i,k) - grda(i,k)
                  bduh(i,k) = gruhs(i,k) - gruha(i,k)
                  bdvh(i,k) = grvhs(i,k) - grvha(i,k)
                  bdth(i,k) = grths(i,k) - grtha(i,k)
#ifdef PP_PCCM
                  u3m1(i,k,j,ih) = grus(i,k) - grua(i,k)
                  v3m1(i,k,j,ih) = grvs(i,k) - grva(i,k)
                  t3m1(i,k,j,ih) = grts(i,k) - grta(i,k)
#else
                  u3m1(i,k,lat) = grus(i,k) - grua(i,k)
                  v3m1(i,k,lat) = grvs(i,k) - grva(i,k)
                  t3m1(i,k,lat) = grts(i,k) - grta(i,k)
#endif
   40          continue
   50       continue
            if(.not.doslt) then
               do 54 k=1,plev
                  do 52 i=1,plonp2
#ifdef PP_PCCM
                     q3m1(i,k,j,ih) = grqs(i,k) - grqa(i,k)
#else
                     q3m1(i,k,lat) = grqs(i,k) - grqa(i,k)
#endif
                     bdqh(i,k) = grqhs(i,k) - grqha(i,k)
   52             continue
   54          continue
            end if
            do 60 i=1,plonp2
               bdps(i) = grdps(i) - grdpa(i)
               psm1(i,lat) = grpss(i) - grpsa(i)
               bdpsl(i) = grpls(i) - grpla(i)
               bdpsm(i) = grpms(i) - grpma(i)
   60       continue
         end if

ccccccccccccccc split here cccccccccccccccccccccc
C
C Transform back to grid space.
C First: copy ps to location contiguous to vorticity
C !!!! NOTE CONTIGUITY ASSUMPTIONS !!!!
C
         call copyac(psm1(1,lat),bpstr,plonp2)

#ifdef INTERVAL_TIMER
         call interval_timer( 1, TIMER_BwdFFT, 0 )
#endif

C
C ps,vort,div,duh,dvh,dth,dqh,dpsl,dpsm,dps
C
         ntr2 = 4 + 6*plev
         call rftlon(bpstr, work1, work2, plond, plon, ntr2, isign)
C
C u,v,t,q (q only if spectral run)
C
         ntr3 = (3+pcnst)*plev
         if(doslt) ntr3 = 3*plev
#ifdef PP_PCCM
         call rftlon(u3m1(1,1,j,ih), work1, work2, plond, plon, ntr3, 
     &               isign)
#else
         call rftlon(u3m1(1,1,j,lat), work1, work2, plond, plon, ntr3, 
     &               isign)
#endif

#ifdef INTERVAL_TIMER
         call interval_timer( 0, TIMER_BwdFFT, 0 )
#endif
C
C Remove cosine(latitude) from momentum variables
C
         rcoslat = 1./cos(clat(lat))
         do k=1,plev
            do i=1,plon
#ifdef PP_PCCM
               u3m1(i,k,j,ih) = u3m1(i,k,j,ih)*rcoslat
               v3m1(i,k,j,ih) = v3m1(i,k,j,ih)*rcoslat
#else
               u3m1(i,k,lat) = u3m1(i,k,lat)*rcoslat
               v3m1(i,k,lat) = v3m1(i,k,lat)*rcoslat
#endif
               bduh(i,k) = bduh(i,k)*rcoslat
               bdvh(i,k) = bdvh(i,k)*rcoslat
            end do
         end do
C
C Copy transformed surface pressure back
C
         call copyac(bpstr,psm1(1,lat),plonp2)
c
c Convert from t-prime to temperature
c
         do k=1,plev
            do i=1,plon
#ifdef PP_PCCM
c              t3m1(i,k,j,ih) = t3m1(i,k,j,ih) + t0(k)
#else
c              t3m1(i,k,lat) = t3m1(i,k,lat) + t0(k)
#endif
            end do
         end do
         do 70 i=1,plon
            psm1(i,lat) = exp(psm1(i,lat)) - psr
            pspsr(i) = psm1(i,lat) + psr
   70    continue

         call plevs0(pspsr,pint,pmid,pdel)
         call pdelb0(pspsr,pdelb)


C
C Finish horizontal diffusion: add correction term to t and q diffusions.
C
         klev = max(kmnhd4,nprlev)
#ifdef PP_ERROR
         write(0,*)'call difcor ',klev,kmnhd4,nprlev
#endif

#ifdef PP_PCCM
         call difcor(doslt,klev,ztodt,bdps,u3m1(1,1,j,ih),
     $               v3m1(1,1,j,ih),q3(1,1,j,ih),pdel,
     $               pint,t3m1(1,1,j,ih),
     $               q3m1(1,1,j,ih),bdth,bdqh,bduh,bdvh)

#else
         call difcor(doslt,klev,ztodt,bdps,u3m1(1,1,lat),
     $               v3m1(1,1,lat),q3(1,1,lat),pdel,
     $               pint,t3m1(1,1,lat),
     $               q3m1(1,1,lat),bdth,bdqh,bduh,bdvh)
#endif

         if(doslt) then
c
c calculate SLT moisture integrals
c all the ()-s are for bit for bit results with case 381
c
#ifdef PP_PCCM
            do 80 m=1,pcnst

               do i=1,plon
                     repro_tmp(i) = 0.0
               enddo
               do k=1,plev
                  do i = 1,plon
                     repro_tmp(i) = repro_tmp(i) +
     $                   qfcst(i,k,m,j,ih)*pdela(i,k)
                  enddo
               enddo
               do i = 1,plon
                  repro_tmp(i) = repro_tmp(i) * cwava*w(irow)*0.5
               enddo
               hw2al (m,lat) = f_locsum( repro_tmp, plon, repro2_tmp)

               do i=1,plon
                     repro_tmp(i) = 0.0
               enddo
               do k=1,plev
                  do i = 1,plon
                     repro_tmp(i) = repro_tmp(i) +
     $                    qfcst(i,k,m,j,ih)*pdelb(i,k)
                  enddo
               enddo
               do i = 1,plon
                  repro_tmp(i) = repro_tmp(i) * cwava*w(irow)*0.5
               enddo
               hw2bl (m,lat) = f_locsum( repro_tmp, plon, repro2_tmp)
c
   80       continue
            call qmassd(cwava,w(irow),q3m1(1,1,j,ih),
     $                  qfcst(1,1,1,j,ih),pdela,hw3al (1,lat))
            call qmassd(cwava,w(irow),q3m1(1,1,j,ih),
     $                  qfcst(1,1,1,j,ih),pdelb,hw3bl (1,lat))
c
c
         endif
C
C Fix negative q values
C
         if(.not.doslt) call qneg1(q3m1(1,1,j,ih),pdel)
C
C Accumulate moisture integrals
C
c                               ! give mint access to lat
         call mint(irow,lat,q3m1(1,1,j,ih),pspsr,rga,pdel)
#else
            do 80 m=1,pcnst
               do 79 k=1,plev
               hw2al (m,irow) = hw2al (m,irow) + ((cwava*w(irow))*
     $                sdot(plon,qfcst(1,k,m,lat),1,pdela(1,k),1))*0.5
               hw2bl (m,irow) = hw2bl (m,irow) + ((cwava*w(irow))*
     $                sdot(plon,qfcst(1,k,m,lat),1,pdelb(1,k),1))*0.5
   79          continue
   80       continue
            call qmassd(cwava,w(irow),q3m1(1,1,lat),
     $                  qfcst(1,1,1,lat),pdela,hw3al (1,irow))
            call qmassd(cwava,w(irow),q3m1(1,1,lat),
     $                  qfcst(1,1,1,lat),pdelb,hw3bl (1,irow))
         end if
C
C Fix negative q values
C
         if(.not.doslt) call qneg1(q3m1(1,1,lat),pdel)
C
C Accumulate moisture integrals
C
         call mint(irow,q3m1(1,1,lat),pspsr,rga,pdel)
#endif
C
C Write out this latitude--!!!! NOTE CONTIGUITY ASSUMPTION !!!!
C
         call writeric(nra1,bpstr,pflena,lat)
   90 continue
      return
      end
